/*     */ package com.jaspersoft.jasperserver.irplugin;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ResourceDescriptor;
/*     */ import com.jaspersoft.jasperserver.irplugin.gui.RepositoryExplorer;
/*     */ import com.jaspersoft.jasperserver.irplugin.gui.jrxmlvalidator.ImageElementValidationItem;
/*     */ import com.jaspersoft.jasperserver.irplugin.gui.jrxmlvalidator.JrxmlValidationDialog;
/*     */ import com.jaspersoft.jasperserver.irplugin.wsclient.WSClient;
/*     */ import it.businesslogic.ireport.CrosstabReportElement;
/*     */ import it.businesslogic.ireport.ImageReportElement;
/*     */ import it.businesslogic.ireport.JRProperty;
/*     */ import it.businesslogic.ireport.Report;
/*     */ import it.businesslogic.ireport.ReportElement;
/*     */ import it.businesslogic.ireport.SubDataset;
/*     */ import it.businesslogic.ireport.gui.JMDIDesktopPane;
/*     */ import it.businesslogic.ireport.gui.JReportFrame;
/*     */ import it.businesslogic.ireport.gui.MainFrame;
/*     */ import it.businesslogic.ireport.gui.event.ReportFrameActivatedEvent;
/*     */ import it.businesslogic.ireport.gui.event.ReportFrameActivatedListener;
/*     */ import it.businesslogic.ireport.util.Misc;
/*     */ import java.awt.Dialog;
/*     */ import java.io.File;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Enumeration;
/*     */ import java.util.List;
/*     */ import java.util.Vector;
/*     */ import javax.swing.ImageIcon;
/*     */ import javax.swing.JComponent;
/*     */ import javax.swing.JDesktopPane;
/*     */ import javax.swing.JInternalFrame;
/*     */ import javax.swing.JOptionPane;
/*     */ import javax.swing.SwingUtilities;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class RepositoryJrxmlFile
/*     */   extends RepositoryFile
/*     */   implements ReportFrameActivatedListener
/*     */ {
/*  54 */   private JReportFrame reportFrame = null;
/*     */   
/*     */   public RepositoryJrxmlFile(JServer server, ResourceDescriptor descriptor) {
/*  57 */     super(server, descriptor);
/*  58 */     MainFrame.getMainInstance().addReportFrameActivatedListener(this);
/*     */   }
/*     */   
/*     */   public String toString()
/*     */   {
/*  63 */     if (getDescriptor() != null)
/*     */     {
/*  65 */       return "" + getDescriptor().getLabel();
/*     */     }
/*  67 */     return "???";
/*     */   }
/*     */   
/*     */ 
/*     */   public void reportFrameActivated(ReportFrameActivatedEvent reportFrameActivatedEvent)
/*     */   {
/*  73 */     if (getReportFrame() == null) return;
/*  74 */     if (reportFrameActivatedEvent.getReportFrame() == null)
/*     */     {
/*     */ 
/*  77 */       setReportFrame(null);
/*  78 */       IRPlugin.getMainInstance().getRepositoryExplorer().updateToolBar();
/*  79 */       return;
/*     */     }
/*     */     
/*     */ 
/*  83 */     JInternalFrame[] frames = MainFrame.getMainInstance().getJMDIDesktopPane().getAllFrames();
/*     */     
/*  85 */     boolean found = false;
/*  86 */     for (int i = 0; i < frames.length; i++)
/*     */     {
/*  88 */       if (frames[i] == getReportFrame())
/*     */       {
/*  90 */         found = true;
/*  91 */         break;
/*     */       }
/*     */     }
/*  94 */     if (!found)
/*     */     {
/*  96 */       setReportFrame(null);
/*  97 */       IRPlugin.getMainInstance().getRepositoryExplorer().updateToolBar();
/*     */     }
/*     */   }
/*     */   
/*     */   public void editFile()
/*     */     throws Exception
/*     */   {
/* 104 */     if (getReportFrame() == null)
/*     */     {
/*     */ 
/*     */ 
/* 108 */       String tmpFileName = IRPlugin.createTmpFileName(getDescriptor().getName(), ".jrxml");
/* 109 */       getServer().getWSClient().get(getDescriptor(), new File(tmpFileName));
/* 110 */       setReportFrame(MainFrame.getMainInstance().openFile(tmpFileName));
/*     */       
/*     */ 
/* 113 */       for (int i = 0; i < getReportFrame().getReport().getJRproperties().size(); i++)
/*     */       {
/* 115 */         JRProperty p = (JRProperty)getReportFrame().getReport().getJRproperties().get(i);
/* 116 */         if ((p.getName().equals("com.jaspersoft.ji.adhoc")) && (p.getValue().equals("1")))
/*     */         {
/*     */ 
/* 119 */           p.setValue("0");
/*     */           try
/*     */           {
/* 122 */             SwingUtilities.invokeLater(new Runnable()
/*     */             {
/*     */               public void run()
/*     */               {
/* 126 */                 if (JOptionPane.showConfirmDialog(MainFrame.getMainInstance(), IRPlugin.getString("messages.adhoc", "You have selected to edit an Ad Hoc report.\nIf you continue, the report will lose its sorting and grouping.\nFurthermore, any changes you make in iReport will be lost\nnext Time you edit it via the Ad Hoc report editor.\nContinue anyway?"), IRPlugin.getString("alert", "Alert!"), 0, 2) == 1)
/*     */                 {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 135 */                   RepositoryJrxmlFile.this.getReportFrame().setVisible(false);
/* 136 */                   RepositoryJrxmlFile.this.getReportFrame().getMainFrame().getJMDIDesktopPane().internalFrameClosed(RepositoryJrxmlFile.this.reportFrame);
/* 137 */                   RepositoryJrxmlFile.this.getReportFrame().dispose();
/*     */                 }
/*     */               }
/*     */             });
/*     */           }
/*     */           catch (Exception ex) {}
/*     */         }
/*     */       }
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 154 */       loadRepositoryImages(getReportFrame().getReport().getElements());
/*     */     }
/*     */     else
/*     */     {
/* 158 */       getReportFrame().setSelected(true);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected void loadRepositoryImages(Vector elements)
/*     */   {
/* 168 */     Enumeration enumElements = elements.elements();
/* 169 */     while (enumElements.hasMoreElements())
/*     */     {
/* 171 */       ReportElement re = (ReportElement)enumElements.nextElement();
/* 172 */       if ((re instanceof ImageReportElement))
/*     */       {
/* 174 */         ImageReportElement ire = (ImageReportElement)re;
/*     */         
/* 176 */         String expression = ire.getImageExpression();
/* 177 */         expression = Misc.string_replace("\\", "\\\\", expression);
/* 178 */         expression = Misc.string_replace("", "\"", expression);
/*     */         
/* 180 */         if (((ire.getImageClass().length() == 0) || (ire.getImageClass().equals("java.lang.String"))) && (expression.toLowerCase().startsWith("repo:")))
/*     */         {
/*     */ 
/* 183 */           ResourceDescriptor rd = new ResourceDescriptor();
/* 184 */           expression = expression.substring(5);
/* 185 */           if (expression.startsWith("/"))
/*     */           {
/* 187 */             rd.setUriString(expression);
/*     */           }
/*     */           else
/*     */           {
/* 191 */             rd.setUriString(getDescriptor().getParentFolder() + "/" + expression);
/*     */           }
/*     */           
/* 194 */           RepositoryFile rf = new RepositoryFile(getServer(), rd);
/*     */           try {
/* 196 */             String imgFile = rf.getFile();
/* 197 */             if (imgFile != null)
/*     */             {
/* 199 */               ImageIcon img = new ImageIcon(imgFile);
/* 200 */               ire.setImg(img.getImage());
/*     */             }
/*     */           }
/*     */           catch (Exception ex) {
/* 204 */             ex.printStackTrace();
/*     */           }
/*     */         }
/*     */       }
/* 208 */       if ((re instanceof CrosstabReportElement))
/*     */       {
/* 210 */         loadRepositoryImages(((CrosstabReportElement)re).getElements());
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   public JReportFrame getReportFrame()
/*     */   {
/* 218 */     return this.reportFrame;
/*     */   }
/*     */   
/*     */   public void setReportFrame(JReportFrame reportFrame) {
/* 222 */     this.reportFrame = reportFrame;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean validateUrls(JServer server, RepositoryReportUnit repoUnit)
/*     */   {
/* 230 */     List imageElementValidationItems = new ArrayList();
/*     */     
/* 232 */     if (getReportFrame() != null)
/*     */     {
/* 234 */       Vector elements = getReportFrame().getReport().getElements();
/* 235 */       for (int i = 0; i < elements.size(); i++)
/*     */       {
/* 237 */         ReportElement re = (ReportElement)elements.elementAt(i);
/* 238 */         if ((re instanceof ImageReportElement))
/*     */         {
/* 240 */           ImageReportElement ire = (ImageReportElement)re;
/*     */           
/* 242 */           String fname = ire.getImageExpression();
/*     */           
/* 244 */           if ((ire.getImageClass().equals("java.lang.String")) && (!ire.getImageExpression().startsWith("\"repo:")) && (fname.length() > 3) && (fname.charAt(0) == '"') && (fname.charAt(fname.length() - 1) == '"') && (ire.getImageExpression().indexOf("$F{") < 0) && (ire.getImageExpression().indexOf("$P{") < 0) && (ire.getImageExpression().indexOf("$V{") < 0) && (ire.getImageExpression().indexOf("$R{") < 0))
/*     */           {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 256 */             fname = Misc.string_replace("\\", "\\\\", fname);
/*     */             
/* 258 */             fname = Misc.string_replace("\\", "\\\\", fname);
/* 259 */             fname = Misc.string_replace("", "\"", fname);
/*     */             
/* 261 */             File f = new File(fname);
/* 262 */             if (f.exists())
/*     */             {
/* 264 */               ImageElementValidationItem ievi = new ImageElementValidationItem();
/* 265 */               ievi.setOriginalFileName(f);
/*     */               
/* 267 */               String name = getValidName(f.getName(), repoUnit);
/* 268 */               ievi.setResourceName(name);
/* 269 */               ievi.setProposedExpression("repo:" + name);
/* 270 */               ievi.setReportElement(ire);
/* 271 */               imageElementValidationItems.add(ievi);
/*     */             }
/*     */           }
/*     */         }
/*     */       }
/*     */       
/* 277 */       Report report = getReportFrame().getReport();
/* 278 */       boolean skipValidation = false;
/* 279 */       for (int i = 0; i < report.getJRproperties().size(); i++)
/*     */       {
/* 281 */         JRProperty prop = (JRProperty)report.getJRproperties().get(i);
/* 282 */         if ((prop.getName() != null) && (prop.getName().equals("com.jaspersoft.irplugin.validation")))
/*     */         {
/* 284 */           if (!prop.getValue().equals("0"))
/*     */             break;
/* 286 */           skipValidation = true; break;
/*     */         }
/*     */       }
/*     */       
/*     */ 
/*     */ 
/* 292 */       if ((imageElementValidationItems.size() > 0) && (!skipValidation))
/*     */       {
/* 294 */         JrxmlValidationDialog jvd = new JrxmlValidationDialog(MainFrame.getMainInstance(), true);
/* 295 */         jvd.setImageElementVelidationItems(imageElementValidationItems);
/* 296 */         jvd.setServer(server);
/* 297 */         jvd.setReportUnit(repoUnit);
/* 298 */         jvd.setReport(getReportFrame().getReport());
/* 299 */         jvd.setVisible(true);
/*     */         
/* 301 */         if (jvd.getDialogResult() == 2)
/*     */         {
/* 303 */           return false;
/*     */         }
/*     */       }
/*     */     }
/*     */     
/* 308 */     return true;
/*     */   }
/*     */   
/*     */ 
/*     */   public String getValidName(String name, RepositoryReportUnit repoUnit)
/*     */   {
/* 314 */     return getValidName(name, repoUnit, 0);
/*     */   }
/*     */   
/*     */ 
/*     */   private String getValidName(String name, RepositoryReportUnit repoUnit, int k)
/*     */   {
/* 320 */     String ext = "";
/* 321 */     String base = name;
/* 322 */     if (name.lastIndexOf(".") > 0)
/*     */     {
/* 324 */       ext = name.substring(name.lastIndexOf("."));
/* 325 */       base = name.substring(0, name.lastIndexOf("."));
/*     */     }
/* 327 */     String newName = base + (k == 0 ? "" : new StringBuffer().append("-").append(k).toString()) + ext;
/*     */     
/* 329 */     for (int i = 0; i < repoUnit.getDescriptor().getChildren().size(); i++)
/*     */     {
/* 331 */       ResourceDescriptor rd = (ResourceDescriptor)repoUnit.getDescriptor().getChildren().get(i);
/* 332 */       if (rd.getName().equals(newName))
/*     */       {
/* 334 */         return getValidName(name, repoUnit, ++k);
/*     */       }
/*     */     }
/* 337 */     return newName;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-ireport-plugin-2.0.1.jar!\com\jaspersoft\jasperserver\irplugin\RepositoryJrxmlFile.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */