/*     */ package com.jaspersoft.jasperserver.irplugin.gui.inputcontrols;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ResourceDescriptor;
/*     */ import com.jaspersoft.jasperserver.irplugin.IRPlugin;
/*     */ import com.jaspersoft.jasperserver.irplugin.gui.inputcontrols.ui.BasicInputControlUI;
/*     */ import com.jaspersoft.jasperserver.irplugin.gui.inputcontrols.ui.InputControlUI;
/*     */ import it.businesslogic.ireport.gui.MainFrame;
/*     */ import java.math.BigDecimal;
/*     */ import java.text.DateFormat;
/*     */ import java.text.Format;
/*     */ import java.text.ParseException;
/*     */ import java.text.SimpleDateFormat;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Date;
/*     */ import java.util.HashMap;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Properties;
/*     */ import java.util.regex.Pattern;
/*     */ import javax.swing.JComponent;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class BasicInputControl
/*     */ {
/*  47 */   public static Map valueHistories = new HashMap();
/*     */   
/*  49 */   protected ResourceDescriptor inputControl = null;
/*  50 */   private ResourceDescriptor dataType = null;
/*     */   
/*     */   private InputControlUI inputControlUI;
/*  53 */   private Object defaultValue = null;
/*     */   
/*     */   public Object getDefaultValue() {
/*  56 */     return this.defaultValue;
/*     */   }
/*     */   
/*     */   public void setDefaultValue(Object defaultValue) {
/*  60 */     this.defaultValue = defaultValue;
/*  61 */     getInputControlUI().setValue(defaultValue);
/*     */   }
/*     */   
/*     */   public BasicInputControl()
/*     */   {
/*  66 */     setInputControlUI(new BasicInputControlUI());
/*     */   }
/*     */   
/*     */   public JComponent getUI()
/*     */   {
/*  71 */     return (JComponent)getInputControlUI();
/*     */   }
/*     */   
/*     */   public Object getValue() throws InputValidationException
/*     */   {
/*  76 */     return validate();
/*     */   }
/*     */   
/*     */   public ResourceDescriptor getInputControl() {
/*  80 */     return this.inputControl;
/*     */   }
/*     */   
/*     */   public void setInputControl(ResourceDescriptor inputControl, List values)
/*     */   {
/*  85 */     setInputControl(inputControl, (ResourceDescriptor)null);
/*     */   }
/*     */   
/*     */   public void setInputControl(ResourceDescriptor inputControl)
/*     */   {
/*  90 */     setInputControl(inputControl, (ResourceDescriptor)null);
/*     */   }
/*     */   
/*     */   public void setInputControl(ResourceDescriptor inputControl, ResourceDescriptor dataType) {
/*  94 */     this.inputControl = inputControl;
/*  95 */     this.dataType = dataType;
/*     */     
/*  97 */     String label = inputControl.getLabel() + (inputControl.isMandatory() ? "*" : "");
/*  98 */     getInputControlUI().setLabel(label);
/*  99 */     getInputControlUI().setReadOnly(inputControl.isReadOnly());
/*     */     
/* 101 */     List history = getHistory(inputControl.getUriString());
/* 102 */     List revisedHistory = new ArrayList();
/* 103 */     if ((dataType != null) && (dataType.getDataType() == 3))
/*     */     {
/* 105 */       SimpleDateFormat format = new SimpleDateFormat(MainFrame.getMainInstance().getProperties().getProperty("dateformat", "d/M/y"));
/*     */       
/* 107 */       for (int i = 0; i < history.size(); i++)
/*     */       {
/* 109 */         Object obj = history.get(i);
/* 110 */         if ((obj instanceof Date))
/*     */         {
/* 112 */           revisedHistory.add(format.format(obj));
/*     */         }
/*     */         else {
/* 115 */           revisedHistory.add(obj);
/*     */         }
/*     */       }
/* 118 */     } else if ((dataType != null) && (dataType.getDataType() == 3))
/*     */     {
/* 120 */       SimpleDateFormat format = new SimpleDateFormat(MainFrame.getMainInstance().getProperties().getProperty("timeformat", "d/M/y H:m:s"));
/*     */       
/* 122 */       for (int i = 0; i < history.size(); i++)
/*     */       {
/* 124 */         Object obj = history.get(i);
/* 125 */         if ((obj instanceof Date))
/*     */         {
/* 127 */           revisedHistory.add(format.format(obj));
/*     */         }
/*     */         else {
/* 130 */           revisedHistory.add(obj);
/*     */         }
/*     */       }
/*     */     }
/*     */     else {
/* 135 */       revisedHistory = history;
/*     */     }
/* 137 */     getInputControlUI().setHistory(revisedHistory);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void addHistoryValue(String controlUri, Object value)
/*     */   {
/* 146 */     if (controlUri == null) return;
/* 147 */     List list = getHistory(controlUri);
/* 148 */     if (list.contains(value)) list.remove(value);
/* 149 */     list.add(0, value);
/*     */   }
/*     */   
/*     */   public List getHistory(String controlUri)
/*     */   {
/* 154 */     if (controlUri == null) { return null;
/*     */     }
/* 156 */     List list = null;
/* 157 */     if (valueHistories.get(controlUri) == null)
/*     */     {
/* 159 */       list = new ArrayList();
/* 160 */       valueHistories.put(controlUri, list);
/* 161 */       return list;
/*     */     }
/*     */     
/* 164 */     return (List)valueHistories.get(controlUri);
/*     */   }
/*     */   
/*     */   public InputControlUI getInputControlUI() {
/* 168 */     return this.inputControlUI;
/*     */   }
/*     */   
/*     */   public void setInputControlUI(InputControlUI inputControlUI) {
/* 172 */     this.inputControlUI = inputControlUI;
/*     */   }
/*     */   
/*     */   public Object validate() throws InputValidationException
/*     */   {
/* 177 */     Object val = getInputControlUI().getValue();
/* 178 */     if (getInputControl().getControlType() == 2)
/*     */     {
/*     */ 
/* 181 */       if (getDataType() != null)
/*     */       {
/* 183 */         if (val == null) { return null;
/*     */         }
/* 185 */         String strVal = "" + val;
/*     */         
/*     */ 
/*     */ 
/* 189 */         switch (getDataType().getDataType())
/*     */         {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */         case 1: 
/* 201 */           if ((getDataType().getPattern() != null) && (getDataType().getPattern().trim().length() > 0) && (!Pattern.matches(getDataType().getPattern(), strVal)))
/*     */           {
/*     */ 
/*     */ 
/* 205 */             throw new InputValidationException(IRPlugin.getFormattedString("basicInputControl.patternError", "{0} does not match the pattern ({1})", new Object[] { getInputControl().getLabel(), getDataType().getPattern() }));
/*     */           }
/*     */           
/*     */ 
/* 209 */           val = strVal;
/* 210 */           break;
/*     */         
/*     */ 
/*     */ 
/*     */         case 2: 
/*     */           try
/*     */           {
/* 217 */             if (strVal.trim().length() == 0) return null;
/* 218 */             val = new BigDecimal(strVal);
/*     */           }
/*     */           catch (NumberFormatException e)
/*     */           {
/* 222 */             throw new InputValidationException(IRPlugin.getFormattedString("basicInputControl.invalidNumber", "Invalid number set for {0}", new Object[] { getInputControl().getLabel() }));
/*     */           }
/*     */         
/*     */ 
/*     */ 
/*     */ 
/*     */         case 4: 
/* 229 */           SimpleDateFormat format = new SimpleDateFormat(MainFrame.getMainInstance().getProperties().getProperty("timeformat", "d/M/y H:m:s"));
/*     */           
/*     */           try
/*     */           {
/* 233 */             if (strVal.trim().length() == 0) return null;
/* 234 */             val = format.parse(strVal);
/*     */           }
/*     */           catch (ParseException e)
/*     */           {
/* 238 */             throw new InputValidationException(IRPlugin.getFormattedString("basicInputControl.invalidDatetime", "Invalid value set for {0} is not a valid datetime in the form {1}", new Object[] { getInputControl().getLabel(), MainFrame.getMainInstance().getProperties().getProperty("timeformat", "d/M/y H:m:s") }));
/*     */           }
/*     */         
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */         case 3: 
/* 247 */           SimpleDateFormat format = new SimpleDateFormat(MainFrame.getMainInstance().getProperties().getProperty("dateformat", "d/M/y"));
/*     */           
/*     */ 
/*     */           try
/*     */           {
/* 252 */             if (strVal.trim().length() == 0) return null;
/* 253 */             val = format.parse(strVal);
/*     */           }
/*     */           catch (ParseException e)
/*     */           {
/* 257 */             throw new InputValidationException(IRPlugin.getFormattedString("basicInputControl.invalidDate", "Invalid value set for {0} is not a valid date in the form {1}", new Object[] { getInputControl().getLabel(), MainFrame.getMainInstance().getProperties().getProperty("dateformat", "d/M/y") }));
/*     */           }
/*     */         }
/*     */         
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 267 */     return val;
/*     */   }
/*     */   
/*     */   public ResourceDescriptor getDataType() {
/* 271 */     return this.dataType;
/*     */   }
/*     */   
/*     */   public void setDataType(ResourceDescriptor dataType) {
/* 275 */     this.dataType = dataType;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-ireport-plugin-2.0.1.jar!\com\jaspersoft\jasperserver\irplugin\gui\inputcontrols\BasicInputControl.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */