/*     */ package com.jaspersoft.jasperserver.irplugin.wsclient;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.Argument;
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ListItem;
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.OperationResult;
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.Request;
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ResourceDescriptor;
/*     */ import com.jaspersoft.jasperserver.irplugin.JServer;
/*     */ import com.jaspersoft.jasperserver.ws.xml.Marshaller;
/*     */ import com.jaspersoft.jasperserver.ws.xml.Unmarshaller;
/*     */ import java.io.ByteArrayInputStream;
/*     */ import java.io.ByteArrayOutputStream;
/*     */ import java.io.File;
/*     */ import java.io.FileOutputStream;
/*     */ import java.io.InputStream;
/*     */ import java.io.OutputStream;
/*     */ import java.io.StringWriter;
/*     */ import java.net.MalformedURLException;
/*     */ import java.net.URL;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collection;
/*     */ import java.util.HashMap;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ import javax.activation.DataHandler;
/*     */ import javax.activation.FileDataSource;
/*     */ import net.sf.jasperreports.engine.JasperPrint;
/*     */ import net.sf.jasperreports.engine.util.JRLoader;
/*     */ import org.apache.axis.attachments.AttachmentPart;
/*     */ import org.apache.axis.client.Stub;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class WSClient
/*     */ {
/*  67 */   private JServer server = null;
/*     */   
/*  69 */   private String webservicesUri = null;
/*     */   
/*  71 */   private ManagementService managementService = null;
/*     */   
/*  73 */   private Unmarshaller unmarshaller = new Unmarshaller();
/*  74 */   private Marshaller marshaller = new Marshaller();
/*     */   
/*     */   public WSClient(JServer server) throws Exception {
/*  77 */     this.server = server;
/*     */     URL url;
/*     */     try
/*     */     {
/*  81 */       url = new URL(server.getUrl());
/*     */     } catch (MalformedURLException e1) {
/*  83 */       throw new Exception(e1);
/*     */     }
/*     */     
/*  86 */     setWebservicesUri(url.toString());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public List listDatasources()
/*     */     throws Exception
/*     */   {
/*  95 */     Request req = new Request();
/*     */     
/*  97 */     req.setOperationName("list");
/*  98 */     req.setResourceDescriptor(null);
/*  99 */     req.setLocale(getServer().getLocale());
/*     */     
/* 101 */     req.getArguments().add(new Argument("LIST_DATASOURCES", "true"));
/*     */     
/* 103 */     StringWriter xmlStringWriter = new StringWriter();
/* 104 */     Marshaller.marshal(req, xmlStringWriter);
/*     */     
/* 106 */     return list(xmlStringWriter.toString());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public List list(ResourceDescriptor descriptor)
/*     */     throws Exception
/*     */   {
/* 114 */     Request req = new Request();
/*     */     
/* 116 */     req.setOperationName("list");
/* 117 */     req.setResourceDescriptor(descriptor);
/* 118 */     req.setLocale(getServer().getLocale());
/*     */     
/* 120 */     StringWriter xmlStringWriter = new StringWriter();
/* 121 */     Marshaller.marshal(req, xmlStringWriter);
/*     */     
/* 123 */     return list(xmlStringWriter.toString());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public String getVersion()
/*     */     throws Exception
/*     */   {
/* 131 */     Request req = new Request();
/*     */     
/* 133 */     req.setOperationName("list");
/* 134 */     req.setResourceDescriptor(null);
/* 135 */     req.setLocale(getServer().getLocale());
/*     */     
/*     */     try
/*     */     {
/* 139 */       ManagementService ms = getManagementService();
/* 140 */       String reqXml = this.marshaller.marshal(req);
/*     */       
/*     */ 
/* 143 */       String result = ms.list(reqXml);
/*     */       
/*     */ 
/* 146 */       OperationResult or = (OperationResult)this.unmarshaller.unmarshal(result);
/*     */       
/* 148 */       if (or.getReturnCode() != 0) { throw new Exception(or.getReturnCode() + " - " + or.getMessage());
/*     */       }
/* 150 */       String str1 = or.getVersion();return str1;
/*     */     } catch (Exception ex) {
/* 152 */       ex = ex;
/* 153 */       ex.printStackTrace();
/* 154 */       throw ex;
/*     */     }
/*     */     finally {}
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public List list(String xmlRequest)
/*     */     throws Exception
/*     */   {
/*     */     try
/*     */     {
/* 167 */       String result = getManagementService().list(xmlRequest);
/*     */       
/* 169 */       OperationResult or = (OperationResult)this.unmarshaller.unmarshal(result);
/*     */       
/* 171 */       if (or.getReturnCode() != 0) { throw new Exception(or.getReturnCode() + " - " + or.getMessage());
/*     */       }
/* 173 */       List localList = or.getResourceDescriptors();return localList;
/*     */     } catch (Exception ex) {
/* 175 */       ex = ex;
/* 176 */       ex.printStackTrace();
/* 177 */       throw ex;
/*     */     }
/*     */     finally {}
/*     */   }
/*     */   
/*     */   public void delete(ResourceDescriptor descriptor)
/*     */     throws Exception
/*     */   {
/* 185 */     delete(descriptor, null);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void delete(ResourceDescriptor descriptor, String reportUnitUri)
/*     */     throws Exception
/*     */   {
/*     */     try
/*     */     {
/* 195 */       Request req = new Request();
/* 196 */       req.setOperationName("delete");
/* 197 */       req.setResourceDescriptor(descriptor);
/* 198 */       req.setLocale(getServer().getLocale());
/*     */       
/* 200 */       if ((reportUnitUri != null) && (reportUnitUri.length() > 0))
/*     */       {
/* 202 */         req.getArguments().add(new Argument("MODIFY_REPORTUNIT_URI", reportUnitUri));
/*     */       }
/*     */       
/* 205 */       String result = getManagementService().delete(this.marshaller.marshal(req));
/*     */       
/* 207 */       OperationResult or = (OperationResult)this.unmarshaller.unmarshal(result);
/*     */       
/* 209 */       if (or.getReturnCode() != 0) throw new Exception(or.getReturnCode() + " - " + or.getMessage());
/*     */     }
/*     */     catch (Exception ex) {
/* 212 */       ex.printStackTrace();
/* 213 */       throw ex;
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ResourceDescriptor get(ResourceDescriptor descriptor, File outputFile)
/*     */     throws Exception
/*     */   {
/* 226 */     return get(descriptor, outputFile, null);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ResourceDescriptor get(ResourceDescriptor descriptor, File outputFile, List args)
/*     */     throws Exception
/*     */   {
/*     */     try
/*     */     {
/* 239 */       Request req = new Request();
/*     */       
/* 241 */       req.setOperationName("get");
/* 242 */       req.setResourceDescriptor(descriptor);
/* 243 */       req.setLocale(getServer().getLocale());
/*     */       
/* 245 */       if (args != null)
/*     */       {
/* 247 */         for (int i = 0; i < args.size(); i++)
/*     */         {
/* 249 */           Argument arg = (Argument)args.get(i);
/* 250 */           req.getArguments().add(arg);
/*     */         }
/*     */       }
/*     */       
/* 254 */       if (outputFile == null)
/*     */       {
/* 256 */         req.getArguments().add(new Argument("NO_ATTACHMENT", null));
/*     */       }
/*     */       
/* 259 */       String result = getManagementService().get(this.marshaller.marshal(req));
/*     */       
/* 261 */       OperationResult or = (OperationResult)this.unmarshaller.unmarshal(result);
/*     */       
/* 263 */       if (or.getReturnCode() != 0) { throw new Exception(or.getReturnCode() + " - " + or.getMessage());
/*     */       }
/* 265 */       Object[] resAtts = ((Stub)getManagementService()).getAttachments();
/* 266 */       if ((resAtts != null) && (resAtts.length > 0) && (outputFile != null))
/*     */       {
/* 268 */         is = ((AttachmentPart)resAtts[0]).getDataHandler().getInputStream();
/*     */         
/* 270 */         byte[] buffer = new byte['Ѐ'];
/* 271 */         OutputStream os = new FileOutputStream(outputFile);
/* 272 */         int bCount = 0;
/* 273 */         while ((bCount = is.read(buffer)) > 0)
/*     */         {
/* 275 */           os.write(buffer, 0, bCount);
/*     */         }
/* 277 */         is.close();
/* 278 */         os.close();
/*     */       }
/* 280 */       else if (outputFile != null)
/*     */       {
/* 282 */         throw new Exception("Attachment not present!");
/*     */       }
/*     */       
/* 285 */       InputStream is = (ResourceDescriptor)or.getResourceDescriptors().get(0);return is;
/*     */     } catch (Exception ex) {
/* 287 */       ex = ex;
/* 288 */       ex.printStackTrace();
/* 289 */       throw ex;
/*     */     }
/*     */     finally {}
/*     */   }
/*     */   
/*     */   public JasperPrint runReport(ResourceDescriptor descriptor, Map parameters)
/*     */     throws Exception
/*     */   {
/* 297 */     List args = new ArrayList(1);
/* 298 */     args.add(new Argument("RUN_OUTPUT_FORMAT", "JRPRINT"));
/* 299 */     Map attachments = runReport(descriptor, parameters, args);
/*     */     
/* 301 */     FileContent content = null;
/* 302 */     if ((attachments != null) && (!attachments.isEmpty()))
/*     */     {
/* 304 */       content = (FileContent)attachments.values().toArray()[0];
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 310 */     if (content == null) {
/* 311 */       throw new Exception("No JasperPrint");
/*     */     }
/*     */     
/* 314 */     InputStream is = new ByteArrayInputStream(content.getData());
/*     */     
/* 316 */     JasperPrint print = (JasperPrint)JRLoader.loadObject(is);
/* 317 */     return print;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Map runReport(ResourceDescriptor descriptor, Map parameters, List args)
/*     */     throws Exception
/*     */   {
/*     */     try
/*     */     {
/* 349 */       Request req = new Request();
/* 350 */       req.setOperationName("runReport");
/* 351 */       req.setLocale(getServer().getLocale());
/* 352 */       ResourceDescriptor newRUDescriptor = new ResourceDescriptor();
/* 353 */       newRUDescriptor.setUriString(descriptor.getUriString());
/* 354 */       for (Iterator i = parameters.keySet().iterator(); i.hasNext();)
/*     */       {
/* 356 */         String key = "" + i.next();
/* 357 */         Object value = parameters.get(key);
/* 358 */         if ((value instanceof Collection))
/*     */         {
/* 360 */           Iterator cIter = ((Collection)value).iterator();
/* 361 */           while (cIter.hasNext())
/*     */           {
/* 363 */             String item = "" + cIter.next();
/* 364 */             ListItem l = new ListItem(key + "", item);
/* 365 */             l.setIsListItem(true);
/* 366 */             newRUDescriptor.getParameters().add(l);
/*     */           }
/*     */         }
/*     */         else
/*     */         {
/* 371 */           newRUDescriptor.getParameters().add(new ListItem(key + "", parameters.get(key)));
/*     */         }
/*     */       }
/*     */       
/* 375 */       req.setResourceDescriptor(newRUDescriptor);
/* 376 */       req.getArguments().addAll(args);
/*     */       
/* 378 */       String result = getManagementService().runReport(this.marshaller.marshal(req));
/*     */       
/* 380 */       OperationResult or = (OperationResult)this.unmarshaller.unmarshal(result);
/*     */       
/* 382 */       if (or.getReturnCode() != 0) { throw new Exception(or.getReturnCode() + " - " + or.getMessage());
/*     */       }
/* 384 */       Map results = new HashMap();
/*     */       
/* 386 */       Object[] resAtts = ((Stub)getManagementService()).getAttachments();
/* 387 */       boolean attachFound = false;
/* 388 */       for (int i = 0; (resAtts != null) && (i < resAtts.length); i++)
/*     */       {
/* 390 */         attachFound = true;
/* 391 */         DataHandler actualDH = ((AttachmentPart)resAtts[i]).getDataHandler();
/* 392 */         String name = actualDH.getName();
/* 393 */         String contentId = ((AttachmentPart)resAtts[i]).getContentId();
/* 394 */         if (name == null) name = "attachment-" + i;
/* 395 */         if (contentId == null) { contentId = "attachment-" + i;
/*     */         }
/*     */         
/* 398 */         InputStream is = actualDH.getInputStream();
/* 399 */         ByteArrayOutputStream bos = new ByteArrayOutputStream();
/*     */         
/* 401 */         byte[] data = new byte['Ϩ'];
/*     */         
/*     */         int bytesRead;
/* 404 */         while ((bytesRead = is.read(data)) != -1) {
/* 405 */           bos.write(data, 0, bytesRead);
/*     */         }
/*     */         
/* 408 */         data = bos.toByteArray();
/*     */         
/* 410 */         String contentType = actualDH.getContentType();
/*     */         
/* 412 */         FileContent content = new FileContent();
/* 413 */         content.setData(data);
/* 414 */         content.setMimeType(contentType);
/* 415 */         content.setName(name);
/*     */         
/* 417 */         results.put(contentId, content);
/*     */       }
/*     */       
/* 420 */       if (!attachFound)
/*     */       {
/* 422 */         throw new Exception("Attachment not present!");
/*     */       }
/*     */       
/* 425 */       i = results;return i;
/* 426 */     } catch (Exception ex) { ex = ex;
/* 427 */       ex.printStackTrace();
/* 428 */       throw ex;
/*     */     }
/*     */     finally {}
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ResourceDescriptor addOrModifyResource(ResourceDescriptor descriptor, File inputFile)
/*     */     throws Exception
/*     */   {
/* 442 */     return modifyReportUnitResource(null, descriptor, inputFile);
/*     */   }
/*     */   
/*     */   public JServer getServer() {
/* 446 */     return this.server;
/*     */   }
/*     */   
/*     */   public void setServer(JServer server) {
/* 450 */     this.server = server;
/*     */   }
/*     */   
/*     */   public String getUsername() {
/* 454 */     return getServer().getUsername();
/*     */   }
/*     */   
/*     */   public String getPassword() {
/* 458 */     return getServer().getPassword();
/*     */   }
/*     */   
/*     */   public ResourceDescriptor modifyReportUnitResource(String reportUnitUri, ResourceDescriptor descriptor, File inputFile) throws Exception
/*     */   {
/*     */     try
/*     */     {
/* 465 */       Request req = new Request();
/* 466 */       req.setOperationName("put");
/* 467 */       req.setLocale(getServer().getLocale());
/*     */       
/* 469 */       if ((reportUnitUri != null) && (reportUnitUri.length() > 0))
/*     */       {
/* 471 */         req.getArguments().add(new Argument("MODIFY_REPORTUNIT_URI", reportUnitUri));
/*     */       }
/*     */       
/* 474 */       ManagementService ms = getManagementService();
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 483 */       if (inputFile != null)
/*     */       {
/* 485 */         descriptor.setHasData(true);
/*     */         
/* 487 */         DataHandler attachmentFile = new DataHandler(new FileDataSource(inputFile));
/*     */         
/*     */ 
/* 490 */         ((Stub)ms)._setProperty("attachment_encapsulation_format", "axis.attachment.style.dime");
/*     */         
/*     */ 
/* 493 */         ((Stub)ms).addAttachment(attachmentFile);
/*     */       }
/*     */       
/* 496 */       req.setResourceDescriptor(descriptor);
/*     */       
/* 498 */       String result = ms.put(this.marshaller.marshal(req));
/*     */       
/* 500 */       OperationResult or = (OperationResult)this.unmarshaller.unmarshal(result);
/*     */       
/* 502 */       if (or.getReturnCode() != 0) { throw new Exception(or.getReturnCode() + " - " + or.getMessage());
/*     */       }
/* 504 */       ResourceDescriptor localResourceDescriptor = (ResourceDescriptor)or.getResourceDescriptors().get(0);return localResourceDescriptor;
/*     */     } catch (Exception ex) {
/* 506 */       ex = ex;
/* 507 */       ex.printStackTrace();
/* 508 */       throw ex;
/*     */     }
/*     */     finally {}
/*     */   }
/*     */   
/*     */ 
/*     */   public String getWebservicesUri()
/*     */   {
/* 516 */     return this.webservicesUri;
/*     */   }
/*     */   
/*     */   public void setWebservicesUri(String webservicesUri) {
/* 520 */     this.webservicesUri = webservicesUri;
/*     */   }
/*     */   
/*     */   public ManagementService getManagementService()
/*     */     throws Exception
/*     */   {
/* 526 */     if (this.managementService == null)
/*     */     {
/* 528 */       ManagementServiceServiceLocator rsl = new ManagementServiceServiceLocator();
/* 529 */       this.managementService = rsl.getrepository(new URL(getWebservicesUri()));
/* 530 */       ((Stub)this.managementService).setUsername(getUsername());
/* 531 */       ((Stub)this.managementService).setPassword(getPassword());
/* 532 */       ((Stub)this.managementService).setMaintainSession(true);
/*     */     }
/*     */     
/*     */ 
/* 536 */     return this.managementService;
/*     */   }
/*     */   
/*     */   public void setManagementService(ManagementService managementService) {
/* 540 */     this.managementService = managementService;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-ireport-plugin-2.0.1.jar!\com\jaspersoft\jasperserver\irplugin\wsclient\WSClient.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */