/*     */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.organizations;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.organizations.attributes.OrganizationBatchAttributeAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.organizations.attributes.OrganizationSingleAttributeAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.JSClientException;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.authority.Organization;
/*     */ import java.io.IOException;
/*     */ import java.util.Collection;
/*     */ import org.apache.commons.logging.Log;
/*     */ import org.apache.commons.logging.LogFactory;
/*     */ import org.codehaus.jackson.map.AnnotationIntrospector;
/*     */ import org.codehaus.jackson.map.ObjectMapper;
/*     */ import org.codehaus.jackson.map.SerializationConfig;
/*     */ import org.codehaus.jackson.map.annotate.JsonSerialize.Inclusion;
/*     */ import org.codehaus.jackson.xc.JaxbAnnotationIntrospector;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SingleOrganizationAdapter
/*     */   extends AbstractAdapter
/*     */ {
/*  49 */   private static final Log log = LogFactory.getLog(SingleOrganizationAdapter.class);
/*     */   private final String organizationId;
/*     */   
/*     */   public SingleOrganizationAdapter(SessionStorage sessionStorage, String organizationId)
/*     */   {
/*  54 */     super(sessionStorage);
/*  55 */     this.organizationId = organizationId;
/*     */   }
/*     */   
/*     */   public OperationResult<Organization> get() {
/*  59 */     return buildRequest().get();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncGet(final Callback<OperationResult<Organization>, R> callback) {
/*  63 */     final JerseyRequest<Organization> request = buildRequest();
/*  64 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/*  67 */         callback.execute(request.get());
/*     */       }
/*  69 */     });
/*  70 */     ThreadPoolUtil.runAsynchronously(task);
/*  71 */     return task;
/*     */   }
/*     */   
/*     */   private String prepareJsonForUpdate(Organization clientTenant) {
/*  75 */     ObjectMapper mapper = new ObjectMapper();
/*  76 */     SerializationConfig serializationConfig = mapper.getSerializationConfig();
/*  77 */     serializationConfig = serializationConfig.withSerializationInclusion(JsonSerialize.Inclusion.NON_NULL);
/*  78 */     AnnotationIntrospector introspector = new JaxbAnnotationIntrospector();
/*  79 */     mapper.setSerializationConfig(serializationConfig);
/*  80 */     mapper.setAnnotationIntrospector(introspector);
/*     */     String json;
/*     */     try
/*     */     {
/*  84 */       json = mapper.writeValueAsString(clientTenant);
/*     */     } catch (IOException e) {
/*  86 */       log.error("Cannot marshal organization object.");
/*  87 */       throw new JSClientException("Cannot marshal organization object.");
/*     */     }
/*  89 */     return json;
/*     */   }
/*     */   
/*     */   public OperationResult<Organization> update(Organization clientTenant) {
/*  93 */     String json = prepareJsonForUpdate(clientTenant);
/*  94 */     return buildRequest().put(json);
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncUpdate(Organization clientTenant, final Callback<OperationResult<Organization>, R> callback) {
/*  98 */     final JerseyRequest<Organization> request = buildRequest();
/*  99 */     final String json = prepareJsonForUpdate(clientTenant);
/* 100 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 103 */         callback.execute(request.put(json));
/*     */       }
/* 105 */     });
/* 106 */     ThreadPoolUtil.runAsynchronously(task);
/* 107 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult delete() {
/* 111 */     return buildRequest().delete();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncDelete(final Callback<OperationResult, R> callback) {
/* 115 */     final JerseyRequest request = buildRequest();
/* 116 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 119 */         callback.execute(request.delete());
/*     */       }
/* 121 */     });
/* 122 */     ThreadPoolUtil.runAsynchronously(task);
/* 123 */     return task;
/*     */   }
/*     */   
/*     */   public OrganizationSingleAttributeAdapter attribute(String attributeName) {
/* 127 */     return new OrganizationSingleAttributeAdapter(this.sessionStorage, this.organizationId, attributeName);
/*     */   }
/*     */   
/*     */   public OrganizationSingleAttributeAdapter attribute() {
/* 131 */     return new OrganizationSingleAttributeAdapter(this.sessionStorage, this.organizationId);
/*     */   }
/*     */   
/*     */   public OrganizationBatchAttributeAdapter attributes(Collection<String> attributesNames) {
/* 135 */     return new OrganizationBatchAttributeAdapter(this.sessionStorage, this.organizationId, attributesNames);
/*     */   }
/*     */   
/*     */   public OrganizationBatchAttributeAdapter attributes(String... attributesNames) {
/* 139 */     return new OrganizationBatchAttributeAdapter(this.sessionStorage, this.organizationId, attributesNames);
/*     */   }
/*     */   
/*     */   public OrganizationBatchAttributeAdapter attributes() {
/* 143 */     return new OrganizationBatchAttributeAdapter(this.sessionStorage, this.organizationId);
/*     */   }
/*     */   
/*     */   private JerseyRequest<Organization> buildRequest() {
/* 147 */     return JerseyRequest.buildRequest(this.sessionStorage, Organization.class, new String[] { "/organizations", this.organizationId }, new DefaultErrorHandler());
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\authority\organizations\SingleOrganizationAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */