/*     */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.users.attributes;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.dto.authority.ClientUserAttribute;
/*     */ import com.jaspersoft.jasperserver.dto.authority.UserAttributesListWrapper;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.users.UsersAttributesParameter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import javax.ws.rs.core.MultivaluedHashMap;
/*     */ import javax.ws.rs.core.MultivaluedMap;
/*     */ 
/*     */ public class BatchAttributeAdapter extends AbstractAdapter
/*     */ {
/*     */   private MultivaluedMap<String, String> params;
/*     */   private StringBuilder uri;
/*     */   
/*     */   public BatchAttributeAdapter(SessionStorage sessionStorage, StringBuilder uri)
/*     */   {
/*  25 */     super(sessionStorage);
/*  26 */     this.uri = uri;
/*  27 */     this.params = new MultivaluedHashMap();
/*  28 */     if ((sessionStorage == null) || (uri == null)) {
/*  29 */       throw new IllegalArgumentException("Invalid parameters! Cannot be null");
/*     */     }
/*     */   }
/*     */   
/*     */   public BatchAttributeAdapter param(UsersAttributesParameter param, String value) {
/*  34 */     this.params.add(param.getParamName(), value);
/*  35 */     return this;
/*     */   }
/*     */   
/*     */   public OperationResult<UserAttributesListWrapper> get() {
/*  39 */     JerseyRequest<UserAttributesListWrapper> request = request();
/*  40 */     request.addParams(this.params);
/*  41 */     return request.get();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncGet(final Callback<OperationResult<UserAttributesListWrapper>, R> callback) {
/*  45 */     final JerseyRequest<UserAttributesListWrapper> request = request();
/*  46 */     request.addParams(this.params);
/*  47 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/*  50 */         callback.execute(request.get());
/*     */       }
/*  52 */     });
/*  53 */     ThreadPoolUtil.runAsynchronously(task);
/*  54 */     return task;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public OperationResult updateOrCreate(UserAttributesListWrapper newAttributes)
/*     */   {
/*  64 */     List<ClientUserAttribute> retrievedAttributes = ((UserAttributesListWrapper)request().get().getEntity()).getProfileAttributes();
/*  65 */     List<ClientUserAttribute> additionalAttributes = newAttributes.getProfileAttributes();
/*     */     
/*  67 */     for (Iterator i$ = retrievedAttributes.iterator(); i$.hasNext();) { retrievedAttribute = (ClientUserAttribute)i$.next();
/*  68 */       for (ClientUserAttribute additionalAttribute : additionalAttributes) {
/*  69 */         if (additionalAttribute.getName().equals(retrievedAttribute.getName())) {
/*  70 */           retrievedAttribute.setValue(additionalAttribute.getValue());
/*     */         }
/*     */       }
/*     */     }
/*     */     ClientUserAttribute retrievedAttribute;
/*  75 */     retrievedAttributes.addAll(additionalAttributes);
/*  76 */     newAttributes.setProfileAttributes(retrievedAttributes);
/*  77 */     return request().put(newAttributes);
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncCreateOrUpdate(final UserAttributesListWrapper attributesList, final Callback<OperationResult<UserAttributesListWrapper>, R> callback)
/*     */   {
/*  82 */     final JerseyRequest<UserAttributesListWrapper> request = request();
/*  83 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/*  86 */         callback.execute(request.put(attributesList));
/*     */       }
/*  88 */     });
/*  89 */     ThreadPoolUtil.runAsynchronously(task);
/*  90 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult delete() {
/*  94 */     JerseyRequest<UserAttributesListWrapper> request = request();
/*  95 */     request.addParams(this.params);
/*  96 */     return request.delete();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncDelete(final Callback<OperationResult<UserAttributesListWrapper>, R> callback) {
/* 100 */     final JerseyRequest<UserAttributesListWrapper> request = request();
/* 101 */     request.addParams(this.params);
/* 102 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 105 */         callback.execute(request.delete());
/*     */       }
/* 107 */     });
/* 108 */     ThreadPoolUtil.runAsynchronously(task);
/* 109 */     return task;
/*     */   }
/*     */   
/*     */   private JerseyRequest<UserAttributesListWrapper> request() {
/* 113 */     String u = this.uri.toString();
/* 114 */     return JerseyRequest.buildRequest(this.sessionStorage, UserAttributesListWrapper.class, new String[] { u, "/attributes" }, new com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler());
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\authority\users\attributes\BatchAttributeAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */