/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.users.attributes;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.dto.authority.ClientUserAttribute;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*    */ 
/*    */ public class SingleAttributeAdapter extends AbstractAdapter
/*    */ {
/*    */   private String attributeName;
/*    */   private final SessionStorage sessionStorage;
/*    */   private StringBuilder uri;
/*    */   
/*    */   public SingleAttributeAdapter(SessionStorage sessionStorage, StringBuilder uri)
/*    */   {
/* 20 */     super(sessionStorage);
/* 21 */     if ((sessionStorage == null) || (uri == null)) {
/* 22 */       throw new IllegalArgumentException("URI cannot be null.");
/*    */     }
/* 24 */     this.sessionStorage = sessionStorage;
/* 25 */     this.uri = uri;
/*    */   }
/*    */   
/*    */   public OperationResult<ClientUserAttribute> get(String attributeName) {
/* 29 */     this.attributeName = attributeName;
/* 30 */     return request().get();
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncGet(final Callback<OperationResult<ClientUserAttribute>, R> callback, String attributeName) {
/* 34 */     this.attributeName = attributeName;
/* 35 */     final JerseyRequest<ClientUserAttribute> request = request();
/* 36 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 39 */         callback.execute(request.get());
/*    */       }
/* 41 */     });
/* 42 */     ThreadPoolUtil.runAsynchronously(task);
/* 43 */     return task;
/*    */   }
/*    */   
/*    */   public OperationResult delete(String attributeName) {
/* 47 */     this.attributeName = attributeName;
/* 48 */     return request().delete();
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncDelete(final Callback<OperationResult, R> callback, String attributeName) {
/* 52 */     this.attributeName = attributeName;
/* 53 */     final JerseyRequest request = request();
/* 54 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 57 */         callback.execute(request.delete());
/*    */       }
/* 59 */     });
/* 60 */     ThreadPoolUtil.runAsynchronously(task);
/* 61 */     return task;
/*    */   }
/*    */   
/*    */   public OperationResult updateOrCreate(ClientUserAttribute attribute) {
/* 65 */     this.attributeName = attribute.getName();
/* 66 */     return request().put(attribute);
/*    */   }
/*    */   
/*    */ 
/*    */   public <R> RequestExecution asyncUpdateOrCreate(final ClientUserAttribute userAttribute, final Callback<OperationResult<ClientUserAttribute>, R> callback, String attributeName)
/*    */   {
/* 72 */     this.attributeName = attributeName;
/* 73 */     final JerseyRequest<ClientUserAttribute> request = request();
/* 74 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 77 */         callback.execute(request.put(userAttribute));
/*    */       }
/* 79 */     });
/* 80 */     ThreadPoolUtil.runAsynchronously(task);
/* 81 */     return task;
/*    */   }
/*    */   
/*    */   private JerseyRequest<ClientUserAttribute> request() {
/* 85 */     return JerseyRequest.buildRequest(this.sessionStorage, ClientUserAttribute.class, new String[] { this.uri.toString(), "/attributes", this.attributeName }, new com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler());
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\authority\users\attributes\SingleAttributeAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */