/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.permissions;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.dto.permissions.RepositoryPermission;
/*    */ import com.jaspersoft.jasperserver.dto.permissions.RepositoryPermissionListWrapper;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.MimeTypeUtil;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class PermissionsService
/*    */   extends AbstractAdapter
/*    */ {
/*    */   public PermissionsService(SessionStorage sessionStorage)
/*    */   {
/* 35 */     super(sessionStorage);
/*    */   }
/*    */   
/*    */   public PermissionResourceRequestAdapter resource(String resourceUri) {
/* 39 */     if ("".equals(resourceUri)) {
/* 40 */       throw new IllegalArgumentException("'resourceUri' mustn't be an empty string");
/*    */     }
/* 42 */     return new PermissionResourceRequestAdapter(this.sessionStorage, resourceUri);
/*    */   }
/*    */   
/*    */   public OperationResult createNew(RepositoryPermission permission) {
/* 46 */     return JerseyRequest.buildRequest(this.sessionStorage, Object.class, new String[] { "/permissions" }, new DefaultErrorHandler()).post(permission);
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncCreateNew(final RepositoryPermission permission, final Callback<OperationResult, R> callback) {
/* 50 */     final JerseyRequest request = JerseyRequest.buildRequest(this.sessionStorage, Object.class, new String[] { "/permissions" });
/* 51 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 54 */         callback.execute(request.post(permission));
/*    */       }
/* 56 */     });
/* 57 */     ThreadPoolUtil.runAsynchronously(task);
/* 58 */     return task;
/*    */   }
/*    */   
/*    */   public OperationResult createNew(RepositoryPermissionListWrapper permissions) {
/* 62 */     JerseyRequest request = JerseyRequest.buildRequest(this.sessionStorage, Object.class, new String[] { "/permissions" });
/* 63 */     request.setContentType(MimeTypeUtil.toCorrectContentMime(this.sessionStorage.getConfiguration(), "application/collection+{mime}"));
/* 64 */     return request.post(permissions);
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncCreateNew(final RepositoryPermissionListWrapper permissions, final Callback<OperationResult, R> callback) {
/* 68 */     final JerseyRequest request = JerseyRequest.buildRequest(this.sessionStorage, Object.class, new String[] { "/permissions" });
/* 69 */     request.setContentType(MimeTypeUtil.toCorrectContentMime(this.sessionStorage.getConfiguration(), "application/collection+{mime}"));
/* 70 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 73 */         callback.execute(request.post(permissions));
/*    */       }
/* 75 */     });
/* 76 */     ThreadPoolUtil.runAsynchronously(task);
/* 77 */     return task;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\permissions\PermissionsService.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */