/*     */ package com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.AccessDeniedException;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.AuthenticationFailedException;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.BadRequestException;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.ConflictException;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.HttpMethodNotAllowedException;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.InternalServerErrorException;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.JSClientWebException;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.RepresentationalTypeNotSupportedForResourceException;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.RequestedRepresentationNotAvailableForResourceException;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.ResourceNotFoundException;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.common.ErrorDescriptor;
/*     */ import java.lang.reflect.Constructor;
/*     */ import java.util.Arrays;
/*     */ import java.util.HashMap;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import javax.ws.rs.ProcessingException;
/*     */ import javax.ws.rs.core.Response;
/*     */ import javax.ws.rs.core.Response.StatusType;
/*     */ import org.glassfish.jersey.message.internal.MessageBodyProviderNotFoundException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class DefaultErrorHandler
/*     */   implements ErrorHandler
/*     */ {
/*  49 */   protected static final Map<Integer, Class<? extends JSClientWebException>> httpErrorCodeToTypeMap = new HashMap() {};
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void handleError(Response response)
/*     */   {
/*  64 */     if (response.hasEntity()) {
/*  65 */       response.bufferEntity();
/*     */     }
/*  67 */     handleBodyError(response);
/*  68 */     handleStatusCodeError(response, null);
/*     */   }
/*     */   
/*     */   protected <T> T readBody(Response response, Class<T> expectedType) {
/*  72 */     T entity = null;
/*     */     try {
/*  74 */       entity = response.readEntity(expectedType);
/*     */     }
/*     */     catch (MessageBodyProviderNotFoundException e) {}catch (ProcessingException e) {}
/*     */     
/*     */ 
/*     */ 
/*  80 */     return entity;
/*     */   }
/*     */   
/*     */   protected void handleBodyError(Response response) {
/*  84 */     String contentType = response.getHeaderString("Content-Type");
/*  85 */     if ((contentType != null) && (contentType.contains("text/html"))) {
/*  86 */       return;
/*     */     }
/*  88 */     ErrorDescriptor errorDescriptor = (ErrorDescriptor)readBody(response, ErrorDescriptor.class);
/*  89 */     if (errorDescriptor != null) {
/*  90 */       JSClientWebException exception = null;
/*     */       try {
/*  92 */         Class<? extends JSClientWebException> exceptionType = (Class)JRSExceptionsMapping.ERROR_CODE_TO_TYPE_MAP.get(errorDescriptor.getErrorCode());
/*  93 */         if (exceptionType != null) {
/*  94 */           String message = errorDescriptor.getMessage();
/*  95 */           exception = (JSClientWebException)exceptionType.getConstructor(new Class[] { String.class, List.class }).newInstance(new Object[] { message != null ? message : errorDescriptor.getErrorCode(), Arrays.asList(new ErrorDescriptor[] { errorDescriptor }) });
/*     */         }
/*     */       }
/*     */       catch (Exception e) {}
/*     */       
/* 100 */       if (exception != null) {
/* 101 */         throw exception;
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   protected void handleStatusCodeError(Response response, String overridingMessage) {
/* 107 */     Class<? extends JSClientWebException> exceptionType = (Class)httpErrorCodeToTypeMap.get(Integer.valueOf(response.getStatus()));
/* 108 */     String reasonPhrase = response.getStatusInfo().getReasonPhrase();
/* 109 */     JSClientWebException exception = new JSClientWebException(overridingMessage != null ? overridingMessage : reasonPhrase);
/*     */     try {
/* 111 */       exception = (JSClientWebException)exceptionType.getConstructor(new Class[] { String.class }).newInstance(new Object[] { overridingMessage != null ? overridingMessage : reasonPhrase });
/*     */     }
/*     */     catch (Exception e) {}
/*     */     
/* 115 */     throw exception;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\core\exceptions\handling\DefaultErrorHandler.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */