/*     */ package com.jaspersoft.jasperserver.jaxrs.client.dto.reports;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.dto.reports.ReportParameters;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.reporting.PageRange;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.reporting.ReportOutputFormat;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.JSClientException;
/*     */ import java.io.UnsupportedEncodingException;
/*     */ import java.net.URLEncoder;
/*     */ import javax.xml.bind.annotation.XmlRootElement;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ @XmlRootElement
/*     */ public class ReportExecutionRequest
/*     */ {
/*     */   private String reportUnitUri;
/*     */   private Boolean freshData;
/*     */   private Boolean saveDataSnapshot;
/*     */   private Boolean interactive;
/*     */   private Boolean ignorePagination;
/*     */   private Boolean async;
/*     */   private String transformerKey;
/*     */   private String outputFormat;
/*     */   private String attachmentsPrefix;
/*     */   private String pages;
/*     */   private ReportParameters parameters;
/*     */   
/*     */   public ReportExecutionRequest()
/*     */   {
/*  43 */     this.freshData = Boolean.valueOf(false);
/*  44 */     this.saveDataSnapshot = Boolean.valueOf(false);
/*     */     
/*  46 */     this.interactive = Boolean.valueOf(true);
/*  47 */     this.ignorePagination = Boolean.valueOf(false);
/*  48 */     this.async = Boolean.valueOf(false);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getReportUnitUri()
/*     */   {
/*  56 */     return this.reportUnitUri;
/*     */   }
/*     */   
/*     */   public ReportExecutionRequest setReportUnitUri(String reportUnitUri) {
/*  60 */     this.reportUnitUri = reportUnitUri;
/*  61 */     return this;
/*     */   }
/*     */   
/*     */   public Boolean getFreshData() {
/*  65 */     return this.freshData;
/*     */   }
/*     */   
/*     */   public ReportExecutionRequest setFreshData(Boolean freshData) {
/*  69 */     this.freshData = freshData;
/*  70 */     return this;
/*     */   }
/*     */   
/*     */   public Boolean getSaveDataSnapshot() {
/*  74 */     return this.saveDataSnapshot;
/*     */   }
/*     */   
/*     */   public ReportExecutionRequest setSaveDataSnapshot(Boolean saveDataSnapshot) {
/*  78 */     this.saveDataSnapshot = saveDataSnapshot;
/*  79 */     return this;
/*     */   }
/*     */   
/*     */   public Boolean getInteractive() {
/*  83 */     return this.interactive;
/*     */   }
/*     */   
/*     */   public ReportExecutionRequest setInteractive(Boolean interactive) {
/*  87 */     this.interactive = interactive;
/*  88 */     return this;
/*     */   }
/*     */   
/*     */   public Boolean getIgnorePagination() {
/*  92 */     return this.ignorePagination;
/*     */   }
/*     */   
/*     */   public ReportExecutionRequest setIgnorePagination(Boolean ignorePagination) {
/*  96 */     this.ignorePagination = ignorePagination;
/*  97 */     return this;
/*     */   }
/*     */   
/*     */   public Boolean getAsync() {
/* 101 */     return this.async;
/*     */   }
/*     */   
/*     */   public ReportExecutionRequest setAsync(Boolean async) {
/* 105 */     this.async = async;
/* 106 */     return this;
/*     */   }
/*     */   
/*     */   public String getTransformerKey() {
/* 110 */     return this.transformerKey;
/*     */   }
/*     */   
/*     */   public ReportExecutionRequest setTransformerKey(String transformerKey) {
/* 114 */     this.transformerKey = transformerKey;
/* 115 */     return this;
/*     */   }
/*     */   
/*     */   public String getOutputFormat() {
/* 119 */     return this.outputFormat;
/*     */   }
/*     */   
/*     */   public ReportExecutionRequest setOutputFormat(String outputFormat) {
/* 123 */     this.outputFormat = outputFormat;
/* 124 */     return this;
/*     */   }
/*     */   
/*     */   public String getAttachmentsPrefix() {
/* 128 */     return this.attachmentsPrefix;
/*     */   }
/*     */   
/*     */   public ReportExecutionRequest setAttachmentsPrefix(String attachmentsPrefix) {
/* 132 */     this.attachmentsPrefix = attachmentsPrefix;
/* 133 */     return this;
/*     */   }
/*     */   
/*     */   public String getPages() {
/* 137 */     return this.pages;
/*     */   }
/*     */   
/*     */   public ReportExecutionRequest setPages(String pages) {
/* 141 */     this.pages = pages;
/* 142 */     return this;
/*     */   }
/*     */   
/*     */   public ReportParameters getParameters() {
/* 146 */     return this.parameters;
/*     */   }
/*     */   
/*     */   public ReportExecutionRequest setParameters(ReportParameters parameters) {
/* 150 */     this.parameters = parameters;
/* 151 */     return this;
/*     */   }
/*     */   
/*     */   public boolean equals(Object o)
/*     */   {
/* 156 */     if (this == o) return true;
/* 157 */     if ((o == null) || (getClass() != o.getClass())) { return false;
/*     */     }
/* 159 */     ReportExecutionRequest that = (ReportExecutionRequest)o;
/*     */     
/* 161 */     if (this.async != null ? !this.async.equals(that.async) : that.async != null) return false;
/* 162 */     if (this.attachmentsPrefix != null ? !this.attachmentsPrefix.equals(that.attachmentsPrefix) : that.attachmentsPrefix != null)
/* 163 */       return false;
/* 164 */     if (this.freshData != null ? !this.freshData.equals(that.freshData) : that.freshData != null) return false;
/* 165 */     if (this.ignorePagination != null ? !this.ignorePagination.equals(that.ignorePagination) : that.ignorePagination != null)
/* 166 */       return false;
/* 167 */     if (this.interactive != null ? !this.interactive.equals(that.interactive) : that.interactive != null) return false;
/* 168 */     if (this.outputFormat != null ? !this.outputFormat.equals(that.outputFormat) : that.outputFormat != null) return false;
/* 169 */     if (this.pages != null ? !this.pages.equals(that.pages) : that.pages != null) return false;
/* 170 */     if (this.parameters != null ? !this.parameters.equals(that.parameters) : that.parameters != null) return false;
/* 171 */     if (this.reportUnitUri != null ? !this.reportUnitUri.equals(that.reportUnitUri) : that.reportUnitUri != null)
/* 172 */       return false;
/* 173 */     if (this.saveDataSnapshot != null ? !this.saveDataSnapshot.equals(that.saveDataSnapshot) : that.saveDataSnapshot != null)
/* 174 */       return false;
/* 175 */     if (this.transformerKey != null ? !this.transformerKey.equals(that.transformerKey) : that.transformerKey != null) {
/* 176 */       return false;
/*     */     }
/* 178 */     return true;
/*     */   }
/*     */   
/*     */   public int hashCode()
/*     */   {
/* 183 */     int result = this.reportUnitUri != null ? this.reportUnitUri.hashCode() : 0;
/* 184 */     result = 31 * result + (this.freshData != null ? this.freshData.hashCode() : 0);
/* 185 */     result = 31 * result + (this.saveDataSnapshot != null ? this.saveDataSnapshot.hashCode() : 0);
/* 186 */     result = 31 * result + (this.interactive != null ? this.interactive.hashCode() : 0);
/* 187 */     result = 31 * result + (this.ignorePagination != null ? this.ignorePagination.hashCode() : 0);
/* 188 */     result = 31 * result + (this.async != null ? this.async.hashCode() : 0);
/* 189 */     result = 31 * result + (this.transformerKey != null ? this.transformerKey.hashCode() : 0);
/* 190 */     result = 31 * result + (this.outputFormat != null ? this.outputFormat.hashCode() : 0);
/* 191 */     result = 31 * result + (this.attachmentsPrefix != null ? this.attachmentsPrefix.hashCode() : 0);
/* 192 */     result = 31 * result + (this.pages != null ? this.pages.hashCode() : 0);
/* 193 */     result = 31 * result + (this.parameters != null ? this.parameters.hashCode() : 0);
/* 194 */     return result;
/*     */   }
/*     */   
/*     */   public String toString()
/*     */   {
/* 199 */     return "ReportExecutionRequest{reportUnitUri='" + this.reportUnitUri + '\'' + ", freshData=" + this.freshData + ", saveDataSnapshot=" + this.saveDataSnapshot + ", interactive=" + this.interactive + ", ignorePagination=" + this.ignorePagination + ", async=" + this.async + ", transformerKey='" + this.transformerKey + '\'' + ", outputFormat='" + this.outputFormat + '\'' + ", attachmentsPrefix='" + this.attachmentsPrefix + '\'' + ", pages='" + this.pages + '\'' + ", parameters=" + this.parameters + '}';
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static class Builder
/*     */   {
/* 216 */     private ReportExecutionRequest request = new ReportExecutionRequest();
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     public Builder setReportUnitUri(String reportUnitUri)
/*     */     {
/* 226 */       this.request.setReportUnitUri(reportUnitUri);
/* 227 */       return this;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     public Builder setFreshData(Boolean freshData)
/*     */     {
/* 240 */       this.request.setFreshData(freshData);
/* 241 */       return this;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     public Builder setSaveDataSnapshot(Boolean saveDataSnapshot)
/*     */     {
/* 252 */       this.request.setSaveDataSnapshot(saveDataSnapshot);
/* 253 */       return this;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     public Builder setInteractive(Boolean interactive)
/*     */     {
/* 266 */       this.request.setInteractive(interactive);
/* 267 */       return this;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     public Builder setIgnorePagination(Boolean ignorePagination)
/*     */     {
/* 277 */       this.request.setIgnorePagination(ignorePagination);
/* 278 */       return this;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     public Builder setAsync(Boolean async)
/*     */     {
/* 293 */       this.request.setAsync(async);
/* 294 */       return this;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     public Builder setTransformerKey(String transformerKey)
/*     */     {
/* 307 */       this.request.setTransformerKey(transformerKey);
/* 308 */       return this;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     public Builder setOutputFormat(ReportOutputFormat outputFormat)
/*     */     {
/* 318 */       this.request.setOutputFormat(outputFormat.name());
/* 319 */       return this;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     public Builder setAttachmentsPrefix(String attachmentsPrefix)
/*     */     {
/*     */       try
/*     */       {
/* 334 */         attachmentsPrefix = URLEncoder.encode(attachmentsPrefix, "UTF-8");
/*     */       } catch (UnsupportedEncodingException e) {
/* 336 */         throw new JSClientException("Unable inFolder UrlEncode 'attachmentsPrefix'", e);
/*     */       }
/* 338 */       this.request.setAttachmentsPrefix(attachmentsPrefix);
/* 339 */       return this;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     public Builder setPages(PageRange pages)
/*     */     {
/* 348 */       this.request.setPages(pages.getRange());
/* 349 */       return this;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     public Builder setPages(int page)
/*     */     {
/* 358 */       this.request.setPages(String.valueOf(page));
/* 359 */       return this;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */     public Builder setParameters(ReportParameters parameters)
/*     */     {
/* 366 */       this.request.setParameters(parameters);
/* 367 */       return this;
/*     */     }
/*     */     
/*     */     public ReportExecutionRequest build() {
/* 371 */       return this.request;
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\dto\reports\ReportExecutionRequest.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */