/*     */ package com.jaspersoft.jasperserver.ws.xml;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.Argument;
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ListItem;
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.OperationResult;
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.Request;
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ResourceDescriptor;
/*     */ import com.jaspersoft.jasperserver.api.metadata.xml.domain.impl.ResourceProperty;
/*     */ import java.io.StringWriter;
/*     */ import java.util.Date;
/*     */ import java.util.List;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class Marshaller
/*     */ {
/*  33 */   private String currentIndentation = "";
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static void marshal(Object obj, StringWriter out)
/*     */   {
/*  41 */     Marshaller marshaller = new Marshaller();
/*  42 */     if ((obj instanceof Request))
/*     */     {
/*  44 */       out.write(marshaller.marshal((Request)obj));
/*     */     }
/*  46 */     else if ((obj instanceof OperationResult))
/*     */     {
/*  48 */       out.write(marshaller.marshal((OperationResult)obj));
/*     */     }
/*     */   }
/*     */   
/*  52 */   public static final String[] special_chars = { "&", "&amp;", "\"", "&quot;", "'", "&apos;", "<", "&lt;", ">", "&gt;" };
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  61 */   private String encoding = "UTF-8";
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static String xmlEscape(String text)
/*     */   {
/*  77 */     if (text == null) return "";
/*  78 */     int i = 0;
/*  79 */     String tmp = "";
/*  80 */     for (i = 0; i < special_chars.length; i += 2)
/*     */     {
/*  82 */       text = string_replace(special_chars[(i + 1)], special_chars[i], text);
/*     */     }
/*     */     
/*     */ 
/*  86 */     return text;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public static String string_replace(String s1, String s2, String s3)
/*     */   {
/*  93 */     String string = "";
/*  94 */     string = "";
/*     */     
/*  96 */     if ((s2 == null) || (s3 == null) || (s2.length() == 0)) { return s3;
/*     */     }
/*  98 */     int pos_i = 0;
/*  99 */     int pos_f = 0;
/*     */     
/* 101 */     int len = s2.length();
/* 102 */     while ((pos_f = s3.indexOf(s2, pos_i)) >= 0) {
/* 103 */       string = string + s3.substring(pos_i, pos_f) + s1;
/*     */       
/* 105 */       pos_f = pos_i = pos_f + len;
/*     */     }
/*     */     
/*     */ 
/* 109 */     string = string + s3.substring(pos_i);
/*     */     
/* 111 */     return string;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String marshal(Request request)
/*     */   {
/* 120 */     StringBuffer xml = new StringBuffer();
/* 121 */     xml.append("<?xml version=\"1.0\" encoding=\"" + getEncoding() + "\"?>\n");
/* 122 */     xml.append("<request operationName=\"" + request.getOperationName() + "\"");
/*     */     
/* 124 */     if (request.getLocale() != null) xml.append(" locale=\"" + request.getLocale() + "\"");
/* 125 */     xml.append(">\n");
/*     */     
/* 127 */     this.currentIndentation = "\t";
/*     */     
/* 129 */     for (int i = 0; i < request.getArguments().size(); i++)
/*     */     {
/* 131 */       Argument a = (Argument)request.getArguments().get(i);
/* 132 */       String value = "><![CDATA[" + a.getValue() + "]]></argument>";
/* 133 */       xml.append(this.currentIndentation + "<argument name=\"" + xmlEscape(a.getName()) + "\"" + value + "\n");
/*     */     }
/*     */     
/* 136 */     xml.append(writeResourceDescriptor(request.getResourceDescriptor()));
/*     */     
/* 138 */     xml.append("</request>\n");
/* 139 */     return xml.toString();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public String writeResourceDescriptor(ResourceDescriptor rd)
/*     */   {
/* 146 */     if (rd == null) { return "";
/*     */     }
/* 148 */     StringBuffer xml = new StringBuffer();
/* 149 */     xml.append(this.currentIndentation + "<resourceDescriptor");
/*     */     
/* 151 */     if ((rd.getName() != null) && (!rd.getName().equals(""))) {
/* 152 */       xml.append(" name=\"" + xmlEscape(rd.getName()) + "\"");
/*     */     }
/* 154 */     if ((rd.getWsType() != null) && (!rd.getWsType().equals(""))) {
/* 155 */       xml.append(" wsType=\"" + xmlEscape(rd.getWsType()) + "\"");
/* 156 */       if ((rd.getWsType().equals("reference")) && (rd.getReferenceType() != null) && (!rd.getReferenceType().equals(""))) {
/* 157 */         xml.append(" referenceType=\"" + xmlEscape(rd.getReferenceType()) + "\"");
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 162 */     if ((rd.getUriString() != null) && (!rd.getUriString().equals(""))) {
/* 163 */       xml.append(" uriString=\"" + xmlEscape(rd.getUriString()) + "\"");
/*     */     }
/* 165 */     xml.append(" isNew=\"" + rd.getIsNew() + "\"");
/* 166 */     xml.append(">\n");
/*     */     
/* 168 */     this.currentIndentation += "\t";
/*     */     
/* 170 */     if ((rd.getLabel() != null) && (!rd.getLabel().equals(""))) {
/* 171 */       xml.append(this.currentIndentation + "<label><![CDATA[" + rd.getLabel() + "]]></label>\n");
/*     */     }
/* 173 */     if ((rd.getDescription() != null) && (rd.getDescription().length() > 0))
/*     */     {
/* 175 */       xml.append(this.currentIndentation + "<description><![CDATA[" + rd.getDescription() + "]]></description>\n");
/*     */     }
/*     */     
/* 178 */     if (rd.getCreationDate() != null)
/*     */     {
/* 180 */       xml.append(this.currentIndentation);
/* 181 */       xml.append("<creationDate>");
/* 182 */       writeCreationDateText(rd, xml);
/* 183 */       xml.append("</creationDate>\n");
/*     */     }
/*     */     
/* 186 */     if (rd.getProperties() != null)
/*     */     {
/* 188 */       for (int i = 0; i < rd.getProperties().size(); i++)
/*     */       {
/*     */ 
/* 191 */         ResourceProperty rp = (ResourceProperty)rd.getProperties().get(i);
/*     */         
/* 193 */         String s = writeResourceProperty(rd, rp);
/* 194 */         xml.append(s);
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 199 */     if (rd.getChildren() != null)
/*     */     {
/* 201 */       for (int i = 0; i < rd.getChildren().size(); i++)
/*     */       {
/* 203 */         ResourceDescriptor rdchild = (ResourceDescriptor)rd.getChildren().get(i);
/* 204 */         xml.append(writeResourceDescriptor(rdchild));
/*     */       }
/*     */     }
/*     */     
/* 208 */     if (rd.getParameters() != null)
/*     */     {
/* 210 */       for (int i = 0; i < rd.getParameters().size(); i++)
/*     */       {
/* 212 */         ListItem rdchild = (ListItem)rd.getParameters().get(i);
/* 213 */         xml.append(writeResourceParameter(rdchild));
/*     */       }
/*     */     }
/*     */     
/* 217 */     this.currentIndentation = this.currentIndentation.substring(0, this.currentIndentation.length() - 1);
/* 218 */     xml.append(this.currentIndentation + "</resourceDescriptor>\n");
/* 219 */     return xml.toString();
/*     */   }
/*     */   
/*     */   protected void writeCreationDateText(ResourceDescriptor rd, StringBuffer xml)
/*     */   {
/* 224 */     long timestamp = rd.getCreationDate().getTime();
/* 225 */     xml.append(timestamp);
/*     */   }
/*     */   
/*     */   public String getEncoding() {
/* 229 */     return this.encoding;
/*     */   }
/*     */   
/*     */   public void setEncoding(String encoding) {
/* 233 */     this.encoding = encoding;
/*     */   }
/*     */   
/*     */   private String writeResourceProperty(ResourceDescriptor rd, ResourceProperty rp)
/*     */   {
/* 238 */     StringBuffer xml = new StringBuffer();
/* 239 */     xml.append(this.currentIndentation + "<resourceProperty name=\"" + xmlEscape(rp.getName()) + "\">\n");
/*     */     
/* 241 */     this.currentIndentation += "\t";
/* 242 */     if (rp.getValue() != null)
/*     */     {
/* 244 */       xml.append(this.currentIndentation + "<value><![CDATA[" + rp.getValue() + "]]></value>\n");
/*     */     }
/*     */     
/* 247 */     for (int i = 0; i < rp.getProperties().size(); i++)
/*     */     {
/* 249 */       ResourceProperty rpChild = (ResourceProperty)rp.getProperties().get(i);
/* 250 */       xml.append(writeResourceProperty(rd, rpChild));
/*     */     }
/*     */     
/* 253 */     this.currentIndentation = this.currentIndentation.substring(0, this.currentIndentation.length() - 1);
/* 254 */     xml.append(this.currentIndentation + "</resourceProperty>\n");
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 263 */     return xml.toString();
/*     */   }
/*     */   
/*     */   private String writeResourceParameter(ListItem rp)
/*     */   {
/* 268 */     StringBuffer xml = new StringBuffer();
/* 269 */     xml.append(this.currentIndentation + "<parameter name=\"" + xmlEscape(rp.getLabel()) + "\"");
/* 270 */     if (rp.isIsListItem())
/*     */     {
/* 272 */       xml.append(" isListItem=\"true\"");
/*     */     }
/*     */     
/* 275 */     xml.append("><![CDATA[");
/* 276 */     if (rp.getValue() != null)
/*     */     {
/* 278 */       xml.append(rp.getValue());
/*     */     }
/* 280 */     xml.append("]]></parameter>\n");
/*     */     
/* 282 */     return xml.toString();
/*     */   }
/*     */   
/*     */ 
/*     */   public String marshal(OperationResult response)
/*     */   {
/* 288 */     StringBuffer xml = new StringBuffer();
/* 289 */     xml.append("<?xml version=\"1.0\" encoding=\"" + getEncoding() + "\"?>\n");
/* 290 */     xml.append("<operationResult version=\"" + response.getVersion() + "\">\n");
/*     */     
/* 292 */     this.currentIndentation = "\t";
/*     */     
/* 294 */     xml.append(this.currentIndentation + "<returnCode><![CDATA[" + response.getReturnCode() + "]]></returnCode>\n");
/*     */     
/* 296 */     if ((response.getMessage() != null) && (response.getMessage().length() > 0))
/*     */     {
/* 298 */       xml.append(this.currentIndentation + "<returnMessage><![CDATA[" + response.getMessage() + "]]></returnMessage>\n");
/*     */     }
/*     */     
/*     */ 
/* 302 */     if (response.getResourceDescriptors() != null)
/*     */     {
/* 304 */       for (int i = 0; i < response.getResourceDescriptors().size(); i++)
/*     */       {
/* 306 */         ResourceDescriptor rd = (ResourceDescriptor)response.getResourceDescriptors().get(i);
/* 307 */         xml.append(writeResourceDescriptor(rd));
/*     */       }
/*     */     }
/*     */     
/* 311 */     this.currentIndentation = this.currentIndentation.substring(0, this.currentIndentation.length() - 1);
/* 312 */     xml.append("</operationResult>\n");
/* 313 */     return xml.toString();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-common-ws-6.0.jar!\com\jaspersoft\jasperserver\ws\xml\Marshaller.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */