/*     */ package com.netapp.asup.client.serialize;
/*     */ 
/*     */ import com.netapp.asup.client.arma.ARMAObject;
/*     */ import com.netapp.asup.client.arma.data.ARMAObjectInstance;
/*     */ import com.netapp.asup.client.arma.data.ARMAObjectInstanceIterator;
/*     */ import com.netapp.asup.client.helper.StatusCode;
/*     */ import com.netapp.asup.client.helper.XMLHelper;
/*     */ import com.netapp.asup.client.serialize.handler.SerializeHandler;
/*     */ import com.netapp.asup.common.AsupLogger;
/*     */ import com.netapp.asup.exception.ARMAException;
/*     */ import com.netapp.asupdata.client.ARMA.ARMAObjectInstanceImpl;
/*     */ import java.io.ByteArrayOutputStream;
/*     */ import java.io.UnsupportedEncodingException;
/*     */ import java.util.Map;
/*     */ import javax.xml.stream.FactoryConfigurationError;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import javax.xml.stream.XMLStreamWriter;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ObjectViewXMLSerializer
/*     */ {
/*  26 */   public static AsupLogger logger = AsupLogger.getLogger(ObjectViewXMLSerializer.class);
/*     */   
/*     */ 
/*     */ 
/*     */   public String serialize(ARMAObjectInstanceIterator instances, SerializeHandler handler, String serverUrl, String entityName, String bizKey)
/*     */     throws UnsupportedEncodingException, FactoryConfigurationError, XMLStreamException, ARMAException
/*     */   {
/*  33 */     String outputXml = null;
/*     */     
/*  35 */     if ((instances == null) || (instances.size() == 0)) {
/*  36 */       return outputXml;
/*     */     }
/*     */     
/*  39 */     ByteArrayOutputStream bos = new ByteArrayOutputStream();
/*  40 */     XMLStreamWriter writer = (XMLStreamWriter)handler.init(bos, bizKey);
/*     */     
/*  42 */     writeResponceStartTemplate(writer, entityName, bizKey, serverUrl, instances.size());
/*  43 */     while (instances.hasNext()) {
/*  44 */       serialize(writer, entityName, bizKey, instances.next(), handler, serverUrl);
/*     */     }
/*  46 */     writer.writeEndElement();
/*  47 */     writer.writeEndElement();
/*  48 */     writer.writeEndDocument();
/*     */     
/*  50 */     writer.flush();
/*  51 */     writer.close();
/*     */     
/*  53 */     outputXml = bos.toString("UTF-8");
/*     */     
/*  55 */     return outputXml;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public String serialize(ARMAObjectInstance instance, SerializeHandler handler, String serverUrl, String entityName, String bizKey)
/*     */     throws UnsupportedEncodingException, FactoryConfigurationError, XMLStreamException, ARMAException
/*     */   {
/*  63 */     String outputXml = null;
/*     */     
/*  65 */     if ((instance == null) || (instance.getAttributes().size() == 0)) {
/*  66 */       return outputXml;
/*     */     }
/*     */     
/*  69 */     ByteArrayOutputStream bos = new ByteArrayOutputStream();
/*  70 */     XMLStreamWriter writer = (XMLStreamWriter)handler.init(bos, bizKey);
/*     */     
/*  72 */     writeResponceStartTemplate(writer, entityName, bizKey, serverUrl, 1);
/*  73 */     serialize(writer, entityName, bizKey, instance, handler, serverUrl);
/*  74 */     writer.writeEndElement();
/*  75 */     writer.writeEndElement();
/*     */     
/*  77 */     writer.writeEndDocument();
/*     */     
/*  79 */     writer.flush();
/*  80 */     writer.close();
/*     */     
/*  82 */     outputXml = bos.toString("UTF-8");
/*  83 */     return outputXml;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public String serialize(String entityName, String bizKey, ARMAObjectInstanceIterator instances, SerializeHandler handler, String requestId, String clientId, String responseTime, String serverUrl)
/*     */     throws UnsupportedEncodingException, FactoryConfigurationError, XMLStreamException, ARMAException
/*     */   {
/*  91 */     String outputXml = null;
/*     */     
/*  93 */     ByteArrayOutputStream outStream = new ByteArrayOutputStream();
/*  94 */     XMLStreamWriter writer = (XMLStreamWriter)handler.init(outStream, bizKey, requestId, clientId, responseTime);
/*     */     
/*     */ 
/*  97 */     if ((instances == null) || (instances.size() == 0)) {
/*  98 */       outputXml = XMLHelper.writeDefaultXmlWithZeroResults(StatusCode.SUCCESS.getValue(), requestId, clientId, responseTime);
/*     */       
/*     */ 
/* 101 */       return outputXml;
/*     */     }
/*     */     
/* 104 */     writeResponceStartTemplate(writer, entityName, bizKey, serverUrl, instances.size());
/*     */     
/* 106 */     while (instances.hasNext()) {
/* 107 */       serialize(writer, entityName, bizKey, instances.next(), handler, serverUrl);
/*     */     }
/*     */     
/* 110 */     writeResponseEndTemplate(writer);
/*     */     
/* 112 */     outputXml = outStream.toString("UTF-8");
/* 113 */     return outputXml;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String serialize(String entityName, String bizKey, ARMAObjectInstance instance, SerializeHandler handler, String requestId, String clientId, String responseTime, String serverUrl)
/*     */     throws UnsupportedEncodingException, FactoryConfigurationError, XMLStreamException, ARMAException
/*     */   {
/* 123 */     String outputXml = null;
/* 124 */     ByteArrayOutputStream outStream = new ByteArrayOutputStream();
/* 125 */     XMLStreamWriter writer = (XMLStreamWriter)handler.init(outStream, bizKey, requestId, clientId, responseTime);
/*     */     
/*     */ 
/* 128 */     if ((instance == null) || (instance.getAttributes().size() == 0)) {
/* 129 */       outputXml = XMLHelper.writeDefaultXmlWithZeroResults(StatusCode.SUCCESS.getValue(), requestId, clientId, responseTime);
/*     */       
/*     */ 
/* 132 */       return outputXml;
/*     */     }
/*     */     
/* 135 */     writeResponceStartTemplate(writer, entityName, bizKey, serverUrl, 1);
/*     */     
/* 137 */     serialize(writer, entityName, bizKey, instance, handler, serverUrl);
/*     */     
/* 139 */     writeResponseEndTemplate(writer);
/*     */     
/* 141 */     outputXml = outStream.toString("UTF-8");
/* 142 */     return outputXml;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private void serialize(XMLStreamWriter writer, String entityName, String bizKey, ARMAObjectInstance instance, SerializeHandler handler, String serverUrl)
/*     */     throws UnsupportedEncodingException, FactoryConfigurationError, XMLStreamException, ARMAException
/*     */   {
/* 152 */     logger.debug(null, "start of xml serialization of instance : ");
/*     */     
/* 154 */     ARMAObjectInstanceImpl ins = (ARMAObjectInstanceImpl)instance;
/*     */     
/* 156 */     Utf8 insKey = ins.getInstanceKey();
/*     */     
/* 158 */     writer.writeStartElement("row");
/*     */     
/*     */ 
/* 161 */     handler.before(ins, serverUrl);
/* 162 */     XMLHelper.writeConfigAndStatusAttrs(writer, ins.getAttributes());
/*     */     
/* 164 */     XMLHelper.writeObjectViewElement(writer, XMLHelper.getObjectViewURL(entityName, XMLHelper.getEncodedURL(insKey.toString()), bizKey, serverUrl));
/*     */     
/*     */ 
/*     */ 
/* 168 */     if ((ins.getMetamodelObject().isOptionsAvailable()) && (ins.getOptions().size() > 0))
/*     */     {
/* 170 */       XMLHelper.writeOptions(writer, ins.getOptions(), entityName);
/*     */     }
/*     */     
/* 173 */     handler.after(ins, serverUrl);
/*     */     
/* 175 */     writer.writeEndElement();
/*     */   }
/*     */   
/*     */ 
/*     */   private void writeResponceStartTemplate(XMLStreamWriter writer, String entityName, String bizKey, String serverUrl, int instanceCount)
/*     */     throws XMLStreamException
/*     */   {
/* 182 */     writer.writeStartElement("object");
/* 183 */     writer.writeStartElement("name");
/* 184 */     writer.writeCharacters(entityName);
/* 185 */     writer.writeEndElement();
/* 186 */     XMLHelper.writeElement("object_view", XMLHelper.getObjectViewURL(entityName, null, bizKey, serverUrl), writer);
/*     */     
/*     */ 
/*     */ 
/* 190 */     XMLHelper.writeTagWithResultsCount(writer, "rows", instanceCount);
/*     */   }
/*     */   
/*     */   private void writeResponseEndTemplate(XMLStreamWriter writer) throws XMLStreamException
/*     */   {
/* 195 */     writer.writeEndElement();
/* 196 */     writer.writeEndElement();
/*     */     
/* 198 */     writer.writeEndDocument();
/* 199 */     XMLHelper.closeXmlWriter(writer);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\client\serialize\ObjectViewXMLSerializer.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */