/*    */ package com.netapp.asup.data.objects;
/*    */ 
/*    */ import java.io.IOException;
/*    */ import java.util.Map;
/*    */ import org.apache.avro.Schema;
/*    */ import org.apache.avro.Schema.Field;
/*    */ import org.apache.avro.Schema.Parser;
/*    */ import org.apache.avro.generic.GenericDatumReader;
/*    */ import org.apache.avro.generic.GenericDatumWriter;
/*    */ import org.apache.avro.generic.GenericRecord;
/*    */ 
/*    */ public enum ARMASchema
/*    */ {
/* 14 */   REQUEST("com/netapp/asup/data/schema/request", GenericRecord.class), 
/* 15 */   IDENTIFIER(REQUEST.getSchema().getField("identifier").schema(), GenericRecord.class), 
/* 16 */   SCHEMADATA(REQUEST.getSchema().getField("schemadata").schema(), GenericRecord.class), 
/* 17 */   PATH(IDENTIFIER.getSchema().getField("path").schema(), GenericRecord.class), 
/* 18 */   DEPENDENT_OBJECTS(REQUEST.getSchema().getField("dependentObjects").schema(), GenericRecord.class), 
/* 19 */   OBJECT_REQUEST(REQUEST.getSchema().getField("objects").schema().getValueType(), GenericRecord.class), 
/* 20 */   OPTION_REQUEST(REQUEST.getSchema().getField("objects").schema().getValueType().getField("options").schema(), GenericRecord.class), 
/* 21 */   PERFCOUNTERS_REQUEST((Schema)REQUEST.getSchema().getField("objects").schema().getValueType().getField("perfCounters").schema().getTypes().get(1), GenericRecord.class), 
/* 22 */   LOGEVENTS_REQUEST((Schema)REQUEST.getSchema().getField("objects").schema().getValueType().getField("logEvents").schema().getTypes().get(1), GenericRecord.class), 
/* 23 */   FIELDS_REQUEST(REQUEST.getSchema().getField("objects").schema().getValueType().getField("fields").schema(), GenericRecord.class), 
/* 24 */   FUNCTION_REQUEST(REQUEST.getSchema().getField("functions").schema(), GenericRecord.class), 
/* 25 */   FUNCTION_REQUEST_DATA(REQUEST.getSchema().getField("functions").schema().getElementType(), GenericRecord.class), 
/* 26 */   RESPONSE("com/netapp/asup/data/schema/response", GenericRecord.class), 
/* 27 */   OBJECTDATA(RESPONSE.getSchema().getField("objects").schema().getValueType(), GenericRecord.class), 
/* 28 */   INDEX_MAP(RESPONSE.getSchema().getField("objects").schema().getValueType().getField("indexMap").schema(), GenericRecord.class), 
/* 29 */   KEY_INDEX(RESPONSE.getSchema().getField("objects").schema().getValueType().getField("keyIndex").schema().getValueType(), GenericRecord.class), 
/* 30 */   OPTIONDATA(RESPONSE.getSchema().getField("options").schema().getValueType(), GenericRecord.class), 
/* 31 */   FUNCTION_DATA(RESPONSE.getSchema().getField("functions").schema().getField("functionData").schema(), GenericRecord.class), 
/* 32 */   FUNCTION_DATA_INSTANCE(RESPONSE.getSchema().getField("functions").schema().getField("functionData").schema().getValueType(), GenericRecord.class), 
/* 33 */   LOGEVENTS(RESPONSE.getSchema().getField("logEvents").schema(), GenericRecord.class), 
/* 34 */   PERFCOUNTERS(RESPONSE.getSchema().getField("perfCounters").schema(), Map.class), 
/* 35 */   PERFCOUNTERDATA(RESPONSE.getSchema().getField("perfCounters").schema().getValueType().getValueType(), GenericRecord.class), 
/* 36 */   OBJECTS(RESPONSE.getSchema().getField("objects").schema(), Map.class), 
/* 37 */   FUNCTIONS(RESPONSE.getSchema().getField("functions").schema(), Map.class), 
/* 38 */   STATUS_HEADER(RESPONSE.getSchema().getField("statusHeader").schema(), GenericRecord.class), 
/* 39 */   OPTIONS(RESPONSE.getSchema().getField("options").schema(), Map.class);
/*    */   
/*    */ 
/*    */   private final Schema schema;
/* 43 */   private final Schema.Parser parser = new Schema.Parser();
/*    */   private final GenericDatumWriter<?> writer;
/*    */   private final GenericDatumReader<?> reader;
/*    */   
/*    */   private <T> ARMASchema(String path, Class<T> type) {
/* 48 */     java.io.InputStream stream = ARMASchema.class.getClassLoader().getResourceAsStream(path);
/*    */     try {
/* 50 */       this.schema = this.parser.parse(stream);
/*    */     } catch (IOException e) {
/* 52 */       throw new RuntimeException(e);
/*    */     }
/* 54 */     this.writer = new GenericDatumWriter(this.schema);
/* 55 */     this.reader = new GenericDatumReader(this.schema);
/*    */   }
/*    */   
/*    */   private <T> ARMASchema(Schema schema, Class<T> type) {
/* 59 */     this.schema = schema;
/* 60 */     this.writer = new GenericDatumWriter(schema);
/* 61 */     this.reader = new GenericDatumReader(schema);
/*    */   }
/*    */   
/*    */   public Schema getSchema()
/*    */   {
/* 66 */     return this.schema;
/*    */   }
/*    */   
/*    */ 
/*    */   public <T> GenericDatumWriter<T> getWriter()
/*    */   {
/* 72 */     return this.writer;
/*    */   }
/*    */   
/*    */   public <T> GenericDatumReader<T> getReader()
/*    */   {
/* 77 */     return this.reader;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\objects\ARMASchema.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */