/*     */ package com.netapp.asup.data.objects;
/*     */ 
/*     */ import com.netapp.asup.common.AsupLogger;
/*     */ import com.netapp.asup.data.schema.SchemaHelper;
/*     */ import com.netapp.asup.data.store.BaseContainer;
/*     */ import com.netapp.asup.data.store.StoreContainer;
/*     */ import java.io.IOException;
/*     */ import java.io.ObjectInputStream;
/*     */ import java.io.ObjectOutputStream;
/*     */ import java.io.Serializable;
/*     */ import java.nio.ByteBuffer;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ import org.apache.avro.Schema;
/*     */ import org.apache.avro.generic.GenericData.Record;
/*     */ import org.apache.avro.generic.GenericDatumReader;
/*     */ import org.apache.avro.generic.GenericDatumWriter;
/*     */ import org.apache.avro.generic.GenericRecord;
/*     */ import org.apache.avro.io.BinaryDecoder;
/*     */ import org.apache.avro.io.BinaryEncoder;
/*     */ import org.apache.avro.io.DecoderFactory;
/*     */ import org.apache.avro.io.EncoderFactory;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class OptionData
/*     */   extends ByteWrappedGenericRecord<Map<Utf8, GenericRecord>, GenericRecord>
/*     */   implements Serializable
/*     */ {
/*     */   private static final long serialVersionUID = -2142305124580711030L;
/*  34 */   private Map<Utf8, GenericRecord> optionNameValueMap = new HashMap();
/*     */   
/*     */   public OptionData(Schema writerSchema, Schema readerSchema, String id) {
/*  37 */     super(ARMASchema.OPTIONDATA, writerSchema, readerSchema, id);
/*     */     
/*     */ 
/*  40 */     this.object = new GenericData.Record(ARMASchema.OPTIONDATA.getSchema());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String toString()
/*     */   {
/*  49 */     return "OptionData [optionNameValueMap=" + this.optionNameValueMap + "]";
/*     */   }
/*     */   
/*     */   public Map<Utf8, GenericRecord> getOptionNameValueMap() {
/*  53 */     return this.optionNameValueMap;
/*     */   }
/*     */   
/*     */   public OptionData(GenericRecord object, Schema writerSchema, Schema readerSchema, String id)
/*     */     throws IOException
/*     */   {
/*  59 */     super(ARMASchema.OPTIONDATA, writerSchema, readerSchema, id);
/*  60 */     this.object = object;
/*  61 */     this.optionNameValueMap = ((Map)deserializeData(((ByteBuffer)((GenericRecord)this.object).get("optionData")).array()));
/*     */   }
/*     */   
/*     */   public void addOptionData(byte[] data)
/*     */     throws IOException
/*     */   {
/*  67 */     if (data != null) {
/*  68 */       this.optionNameValueMap = ((Map)deserializeData(data));
/*     */     }
/*     */   }
/*     */   
/*     */   public void addOptionData(StatusHeader header, Utf8 optionGroupId, byte[] data, Schema writerSchema, Schema readerSchema) throws IOException
/*     */   {
/*  74 */     if (data != null) {
/*  75 */       this.optionNameValueMap = ((Map)deserializeData(writerSchema, readerSchema, data));
/*     */     }
/*     */     else {
/*  78 */       header.addErrorMessage("no option data found for option group ID : " + optionGroupId.toString());
/*     */     }
/*     */   }
/*     */   
/*     */   public GenericRecord getObject() throws IOException
/*     */   {
/*  84 */     ByteBuffer optionBytes = ByteBuffer.wrap(serializeData(this.optionNameValueMap));
/*     */     
/*  86 */     ((GenericRecord)this.object).put("optionData", optionBytes);
/*     */     
/*  88 */     return (GenericRecord)this.object;
/*     */   }
/*     */   
/*     */   private void writeObject(ObjectOutputStream oos)
/*     */     throws IOException
/*     */   {
/*  94 */     logger.info(null, "entered custom writeObject for optiondata..");
/*  95 */     if (this.schema == null) {
/*  96 */       this.schema = ARMASchema.OPTIONDATA;
/*     */     }
/*  98 */     SchemaHelper schemaHelper = BaseContainer.getInstance().getStoreContainer().getSchemaHelper();
/*     */     
/* 100 */     Schema writerSchema = schemaHelper.getLatestSchema("OPTION");
/* 101 */     if (this.reader == null) {
/* 102 */       this.reader = new GenericDatumReader(writerSchema, schemaHelper.getActiveSchema("OPTION"));
/*     */     }
/*     */     
/* 105 */     if (this.writer == null) {
/* 106 */       this.writer = new GenericDatumWriter(writerSchema);
/*     */     }
/*     */     
/*     */ 
/* 110 */     BinaryEncoder binEncoder = encoderFactory.binaryEncoder(oos, EncoderFactory.get().binaryEncoder(oos, null));
/*     */     try
/*     */     {
/* 113 */       oos.writeUTF(this.id);
/*     */       
/* 115 */       this.schema.getWriter().write(getObject(), binEncoder);
/* 116 */       binEncoder.flush();
/* 117 */       logger.info(null, "written optiondata using custom writeObject..");
/*     */     } catch (IOException e) {
/* 119 */       logger.info(null, "unable to serialize optiondata for saving it in memcache.." + e.getMessage());
/*     */     }
/*     */     finally
/*     */     {
/* 123 */       if (null != oos) {
/* 124 */         oos.close();
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */   private void readObject(ObjectInputStream ois) throws IOException, ClassNotFoundException
/*     */   {
/* 131 */     logger.info(null, "entered custom readobject for optiondata..");
/* 132 */     logger.info(null, "reading bytes data: " + ois.available());
/*     */     
/* 134 */     this.id = ois.readUTF();
/* 135 */     BinaryDecoder binaryDecoder = DecoderFactory.get().binaryDecoder(ois, null);
/*     */     
/* 137 */     GenericDatumReader<GenericRecord> reader = new GenericDatumReader(ARMASchema.OPTIONDATA.getSchema());
/*     */     
/* 139 */     this.object = new GenericData.Record(reader.getSchema());
/* 140 */     reader.read(this.object, binaryDecoder);
/*     */     
/*     */ 
/*     */ 
/* 144 */     SchemaHelper schemaHelper = BaseContainer.getInstance().getStoreContainer().getSchemaHelper();
/*     */     
/* 146 */     Schema writerSchema = schemaHelper.getLatestSchema("OPTION");
/* 147 */     Schema readerSchema = schemaHelper.getActiveSchema("OPTION");
/* 148 */     this.reader = new GenericDatumReader(writerSchema, readerSchema);
/*     */     
/* 150 */     this.writer = new GenericDatumWriter(writerSchema);
/*     */     
/* 152 */     if (((GenericRecord)this.object).get("optionData") != null) {
/* 153 */       this.optionNameValueMap = ((Map)deserializeData(((ByteBuffer)((GenericRecord)this.object).get("optionData")).array()));
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\objects\OptionData.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */