/*     */ package com.sun.xml.bind.v2.model.impl;
/*     */ 
/*     */ import com.sun.istack.FinalArrayList;
/*     */ import com.sun.xml.bind.v2.TODO;
/*     */ import com.sun.xml.bind.v2.model.annotation.AnnotationReader;
/*     */ import com.sun.xml.bind.v2.model.annotation.AnnotationSource;
/*     */ import com.sun.xml.bind.v2.model.annotation.Locatable;
/*     */ import com.sun.xml.bind.v2.model.core.Adapter;
/*     */ import com.sun.xml.bind.v2.model.core.ClassInfo;
/*     */ import com.sun.xml.bind.v2.model.core.ElementInfo;
/*     */ import com.sun.xml.bind.v2.model.core.ElementPropertyInfo;
/*     */ import com.sun.xml.bind.v2.model.core.ID;
/*     */ import com.sun.xml.bind.v2.model.core.NonElement;
/*     */ import com.sun.xml.bind.v2.model.core.PropertyInfo;
/*     */ import com.sun.xml.bind.v2.model.core.PropertyKind;
/*     */ import com.sun.xml.bind.v2.model.core.TypeRef;
/*     */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*     */ import com.sun.xml.bind.v2.runtime.IllegalAnnotationException;
/*     */ import com.sun.xml.bind.v2.runtime.Location;
/*     */ import com.sun.xml.bind.v2.runtime.SwaRefAdapter;
/*     */ import java.lang.annotation.Annotation;
/*     */ import java.util.Collection;
/*     */ import java.util.Collections;
/*     */ import java.util.List;
/*     */ import javax.activation.MimeType;
/*     */ import javax.xml.bind.JAXBElement;
/*     */ import javax.xml.bind.annotation.XmlAttachmentRef;
/*     */ import javax.xml.bind.annotation.XmlElementDecl;
/*     */ import javax.xml.bind.annotation.XmlElementDecl.GLOBAL;
/*     */ import javax.xml.bind.annotation.XmlID;
/*     */ import javax.xml.bind.annotation.XmlIDREF;
/*     */ import javax.xml.bind.annotation.XmlInlineBinaryData;
/*     */ import javax.xml.bind.annotation.XmlSchema;
/*     */ import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
/*     */ import javax.xml.namespace.QName;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ class ElementInfoImpl<T, C, F, M>
/*     */   extends TypeInfoImpl<T, C, F, M>
/*     */   implements ElementInfo<T, C>
/*     */ {
/*     */   private final QName tagName;
/*     */   private final NonElement<T, C> contentType;
/*     */   private final T elementType;
/*     */   private final ClassInfo<T, C> scope;
/*     */   private final XmlElementDecl anno;
/*     */   private ElementInfoImpl<T, C, F, M> substitutionHead;
/*     */   private FinalArrayList<ElementInfoImpl<T, C, F, M>> substitutionMembers;
/*     */   private final M method;
/*     */   private final Adapter<T, C> adapter;
/*     */   private final boolean isCollection;
/*     */   private final ID id;
/*     */   private final ElementInfoImpl<T, C, F, M>.PropertyImpl property;
/*     */   private final MimeType expectedMimeType;
/*     */   private final boolean inlineBinary;
/*     */   private final QName schemaType;
/*     */   
/*     */   protected class PropertyImpl
/*     */     implements ElementPropertyInfo<T, C>, TypeRef<T, C>, AnnotationSource
/*     */   {
/*     */     protected PropertyImpl() {}
/*     */     
/*     */     public NonElement<T, C> getTarget()
/*     */     {
/* 100 */       return ElementInfoImpl.this.contentType;
/*     */     }
/*     */     
/* 103 */     public QName getTagName() { return ElementInfoImpl.this.tagName; }
/*     */     
/*     */     public List<? extends TypeRef<T, C>> getTypes()
/*     */     {
/* 107 */       return Collections.singletonList(this);
/*     */     }
/*     */     
/*     */     public List<? extends NonElement<T, C>> ref() {
/* 111 */       return Collections.singletonList(ElementInfoImpl.this.contentType);
/*     */     }
/*     */     
/*     */     public QName getXmlName() {
/* 115 */       return ElementInfoImpl.this.tagName;
/*     */     }
/*     */     
/*     */     public boolean isCollectionNillable() {
/* 119 */       return true;
/*     */     }
/*     */     
/*     */     public boolean isNillable() {
/* 123 */       return true;
/*     */     }
/*     */     
/*     */     public String getDefaultValue() {
/* 127 */       String v = ElementInfoImpl.this.anno.defaultValue();
/* 128 */       if (v.equals("\000")) {
/* 129 */         return null;
/*     */       }
/* 131 */       return v;
/*     */     }
/*     */     
/*     */     public ElementInfoImpl<T, C, F, M> parent() {
/* 135 */       return ElementInfoImpl.this;
/*     */     }
/*     */     
/*     */     public String getName() {
/* 139 */       return "value";
/*     */     }
/*     */     
/*     */     public String displayName() {
/* 143 */       return "JAXBElement#value";
/*     */     }
/*     */     
/*     */     public boolean isCollection() {
/* 147 */       return ElementInfoImpl.this.isCollection;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */     public boolean isValueList()
/*     */     {
/* 154 */       return ElementInfoImpl.this.isCollection;
/*     */     }
/*     */     
/*     */     public boolean isRequired() {
/* 158 */       return true;
/*     */     }
/*     */     
/*     */     public PropertyKind kind() {
/* 162 */       return PropertyKind.ELEMENT;
/*     */     }
/*     */     
/*     */     public Adapter<T, C> getAdapter() {
/* 166 */       return ElementInfoImpl.this.adapter;
/*     */     }
/*     */     
/*     */     public ID id() {
/* 170 */       return ElementInfoImpl.this.id;
/*     */     }
/*     */     
/*     */     public MimeType getExpectedMimeType() {
/* 174 */       return ElementInfoImpl.this.expectedMimeType;
/*     */     }
/*     */     
/*     */     public QName getSchemaType() {
/* 178 */       return ElementInfoImpl.this.schemaType;
/*     */     }
/*     */     
/*     */     public boolean inlineBinaryData() {
/* 182 */       return ElementInfoImpl.this.inlineBinary;
/*     */     }
/*     */     
/*     */     public PropertyInfo<T, C> getSource() {
/* 186 */       return this;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     public <A extends Annotation> A readAnnotation(Class<A> annotationType)
/*     */     {
/* 195 */       return ElementInfoImpl.this.reader().getMethodAnnotation(annotationType, ElementInfoImpl.this.method, ElementInfoImpl.this);
/*     */     }
/*     */     
/*     */     public boolean hasAnnotation(Class<? extends Annotation> annotationType) {
/* 199 */       return ElementInfoImpl.this.reader().hasMethodAnnotation(annotationType, ElementInfoImpl.this.method);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public ElementInfoImpl(ModelBuilder<T, C, F, M> builder, RegistryInfoImpl<T, C, F, M> registry, M m)
/*     */     throws IllegalAnnotationException
/*     */   {
/* 209 */     super(builder, registry);
/*     */     
/* 211 */     this.method = m;
/* 212 */     this.anno = ((XmlElementDecl)reader().getMethodAnnotation(XmlElementDecl.class, m, this));
/* 213 */     assert (this.anno != null);
/* 214 */     assert ((this.anno instanceof Locatable));
/*     */     
/* 216 */     this.elementType = nav().getReturnType(m);
/* 217 */     T baseClass = nav().getBaseClass(this.elementType, nav().asDecl(JAXBElement.class));
/* 218 */     if (baseClass == null) {
/* 219 */       throw new IllegalAnnotationException(Messages.XML_ELEMENT_MAPPING_ON_NON_IXMLELEMENT_METHOD.format(new Object[] { nav().getMethodName(m) }), this.anno);
/*     */     }
/*     */     
/*     */ 
/* 223 */     this.tagName = parseElementName(this.anno);
/* 224 */     T[] methodParams = nav().getMethodParameters(m);
/*     */     
/*     */ 
/* 227 */     Adapter<T, C> a = null;
/* 228 */     if (methodParams.length > 0) {
/* 229 */       XmlJavaTypeAdapter adapter = (XmlJavaTypeAdapter)reader().getMethodAnnotation(XmlJavaTypeAdapter.class, m, this);
/* 230 */       if (adapter != null) {
/* 231 */         a = new Adapter(adapter, reader(), nav());
/*     */       } else {
/* 233 */         XmlAttachmentRef xsa = (XmlAttachmentRef)reader().getMethodAnnotation(XmlAttachmentRef.class, m, this);
/* 234 */         if (xsa != null) {
/* 235 */           TODO.prototype("in APT swaRefAdapter isn't avaialble, so this returns null");
/* 236 */           a = new Adapter(this.owner.nav.asDecl(SwaRefAdapter.class), this.owner.nav);
/*     */         }
/*     */       }
/*     */     }
/* 240 */     this.adapter = a;
/*     */     
/* 242 */     if (this.adapter == null)
/*     */     {
/* 244 */       T typeType = methodParams.length > 0 ? methodParams[0] : nav().getTypeArgument(baseClass, 0);
/*     */       
/*     */ 
/* 247 */       T list = nav().getBaseClass(typeType, nav().asDecl(List.class));
/* 248 */       if (list == null) {
/* 249 */         this.isCollection = false;
/* 250 */         this.contentType = builder.getTypeInfo(typeType, this);
/*     */       } else {
/* 252 */         this.isCollection = true;
/* 253 */         this.contentType = builder.getTypeInfo(nav().getTypeArgument(list, 0), this);
/*     */       }
/*     */     }
/*     */     else {
/* 257 */       this.contentType = builder.getTypeInfo(this.adapter.defaultType, this);
/* 258 */       this.isCollection = false;
/*     */     }
/*     */     
/*     */ 
/* 262 */     T s = reader().getClassValue(this.anno, "scope");
/* 263 */     if (s.equals(nav().ref(XmlElementDecl.GLOBAL.class))) {
/* 264 */       this.scope = null;
/*     */     }
/*     */     else {
/* 267 */       NonElement<T, C> scp = builder.getClassInfo(nav().asDecl(s), this);
/* 268 */       if (!(scp instanceof ClassInfo)) {
/* 269 */         throw new IllegalAnnotationException(Messages.SCOPE_IS_NOT_COMPLEXTYPE.format(new Object[] { nav().getTypeName(s) }), this.anno);
/*     */       }
/*     */       
/*     */ 
/* 273 */       this.scope = ((ClassInfo)scp);
/*     */     }
/*     */     
/* 276 */     this.id = calcId();
/*     */     
/* 278 */     this.property = createPropertyImpl();
/*     */     
/* 280 */     this.expectedMimeType = Util.calcExpectedMediaType(this.property, builder);
/* 281 */     this.inlineBinary = reader().hasMethodAnnotation(XmlInlineBinaryData.class, this.method);
/* 282 */     this.schemaType = Util.calcSchemaType(reader(), this.property, registry.registryClass, getContentInMemoryType(), this);
/*     */   }
/*     */   
/*     */   final QName parseElementName(XmlElementDecl e)
/*     */   {
/* 287 */     String local = e.name();
/* 288 */     String nsUri = e.namespace();
/* 289 */     if (nsUri.equals("##default"))
/*     */     {
/* 291 */       XmlSchema xs = (XmlSchema)reader().getPackageAnnotation(XmlSchema.class, nav().getDeclaringClassForMethod(this.method), this);
/*     */       
/* 293 */       if (xs != null) {
/* 294 */         nsUri = xs.namespace();
/*     */       } else {
/* 296 */         nsUri = this.builder.defaultNsUri;
/*     */       }
/*     */     }
/*     */     
/* 300 */     return new QName(nsUri.intern(), local.intern());
/*     */   }
/*     */   
/*     */   protected ElementInfoImpl<T, C, F, M>.PropertyImpl createPropertyImpl() {
/* 304 */     return new PropertyImpl();
/*     */   }
/*     */   
/*     */   public ElementPropertyInfo<T, C> getProperty() {
/* 308 */     return this.property;
/*     */   }
/*     */   
/*     */   public NonElement<T, C> getContentType() {
/* 312 */     return this.contentType;
/*     */   }
/*     */   
/*     */   public T getContentInMemoryType() {
/* 316 */     if (this.adapter == null) {
/* 317 */       return (T)this.contentType.getType();
/*     */     }
/* 319 */     return (T)this.adapter.customType;
/*     */   }
/*     */   
/*     */   public QName getElementName()
/*     */   {
/* 324 */     return this.tagName;
/*     */   }
/*     */   
/*     */   public T getType() {
/* 328 */     return (T)this.elementType;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public final boolean canBeReferencedByIDREF()
/*     */   {
/* 338 */     return false;
/*     */   }
/*     */   
/*     */   private ID calcId()
/*     */   {
/* 343 */     if (reader().hasMethodAnnotation(XmlID.class, this.method)) {
/* 344 */       return ID.ID;
/*     */     }
/* 346 */     if (reader().hasMethodAnnotation(XmlIDREF.class, this.method)) {
/* 347 */       return ID.IDREF;
/*     */     }
/* 349 */     return ID.NONE;
/*     */   }
/*     */   
/*     */   public ClassInfo<T, C> getScope()
/*     */   {
/* 354 */     return this.scope;
/*     */   }
/*     */   
/*     */   public ElementInfo<T, C> getSubstitutionHead() {
/* 358 */     return this.substitutionHead;
/*     */   }
/*     */   
/*     */   public Collection<? extends ElementInfoImpl<T, C, F, M>> getSubstitutionMembers() {
/* 362 */     if (this.substitutionMembers == null) {
/* 363 */       return Collections.emptyList();
/*     */     }
/* 365 */     return this.substitutionMembers;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   void link()
/*     */   {
/* 373 */     if (this.anno.substitutionHeadName().length() != 0) {
/* 374 */       QName name = new QName(this.anno.substitutionHeadNamespace(), this.anno.substitutionHeadName());
/*     */       
/* 376 */       this.substitutionHead = this.owner.getElementInfo(null, name);
/* 377 */       if (this.substitutionHead == null) {
/* 378 */         this.builder.reportError(new IllegalAnnotationException(Messages.NON_EXISTENT_ELEMENT_MAPPING.format(new Object[] { name.getNamespaceURI(), name.getLocalPart() }), this.anno));
/*     */ 
/*     */       }
/*     */       else
/*     */       {
/* 383 */         this.substitutionHead.addSubstitutionMember(this); }
/*     */     } else {
/* 385 */       this.substitutionHead = null; }
/* 386 */     super.link();
/*     */   }
/*     */   
/*     */   private void addSubstitutionMember(ElementInfoImpl<T, C, F, M> child) {
/* 390 */     if (this.substitutionMembers == null)
/* 391 */       this.substitutionMembers = new FinalArrayList();
/* 392 */     this.substitutionMembers.add(child);
/*     */   }
/*     */   
/*     */   public Location getLocation() {
/* 396 */     return nav().getMethodLocation(this.method);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\impl\ElementInfoImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */