/*     */ package com.sun.xml.bind.v2.model.impl;
/*     */ 
/*     */ import com.sun.xml.bind.v2.model.annotation.AnnotationReader;
/*     */ import com.sun.xml.bind.v2.model.core.BuiltinLeafInfo;
/*     */ import com.sun.xml.bind.v2.model.core.ClassInfo;
/*     */ import com.sun.xml.bind.v2.model.core.LeafInfo;
/*     */ import com.sun.xml.bind.v2.model.core.NonElement;
/*     */ import com.sun.xml.bind.v2.model.core.Ref;
/*     */ import com.sun.xml.bind.v2.model.core.TypeInfoSet;
/*     */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*     */ import com.sun.xml.bind.v2.runtime.IllegalAnnotationException;
/*     */ import com.sun.xml.bind.v2.runtime.RuntimeUtil;
/*     */ import com.sun.xml.bind.v2.runtime.RuntimeUtil.ToStringAdapter;
/*     */ import com.sun.xml.bind.v2.util.FlattenIterator;
/*     */ import java.util.Collections;
/*     */ import java.util.HashMap;
/*     */ import java.util.Iterator;
/*     */ import java.util.LinkedHashMap;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import javax.xml.bind.JAXBContext;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import javax.xml.bind.Marshaller;
/*     */ import javax.xml.bind.annotation.XmlNs;
/*     */ import javax.xml.bind.annotation.XmlNsForm;
/*     */ import javax.xml.bind.annotation.XmlRegistry;
/*     */ import javax.xml.bind.annotation.XmlSchema;
/*     */ import javax.xml.bind.annotation.XmlTransient;
/*     */ import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
/*     */ import javax.xml.namespace.QName;
/*     */ import javax.xml.transform.Result;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ class TypeInfoSetImpl<TypeT, ClassDeclT, FieldT, MethodT>
/*     */   implements TypeInfoSet<TypeT, ClassDeclT, FieldT, MethodT>
/*     */ {
/*     */   @XmlTransient
/*     */   public final Navigator<TypeT, ClassDeclT, FieldT, MethodT> nav;
/*     */   @XmlTransient
/*     */   public final AnnotationReader<TypeT, ClassDeclT, FieldT, MethodT> reader;
/*  57 */   private final Map<TypeT, BuiltinLeafInfo<TypeT, ClassDeclT>> builtins = new LinkedHashMap();
/*     */   
/*     */ 
/*     */ 
/*  61 */   private final Map<ClassDeclT, EnumLeafInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>> enums = new LinkedHashMap();
/*     */   
/*     */ 
/*     */ 
/*  65 */   private final Map<TypeT, ArrayInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>> arrays = new LinkedHashMap();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlJavaTypeAdapter(RuntimeUtil.ToStringAdapter.class)
/*  77 */   private final Map<ClassDeclT, ClassInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>> beans = new LinkedHashMap();
/*     */   
/*     */ 
/*     */   @XmlTransient
/*  81 */   private final Map<ClassDeclT, ClassInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>> beansView = Collections.unmodifiableMap(this.beans);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  87 */   private final Map<ClassDeclT, Map<QName, ElementInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>>> elementMappings = new LinkedHashMap();
/*     */   
/*     */ 
/*  90 */   private final Iterable<? extends ElementInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>> allElements = new Iterable()
/*     */   {
/*     */     public Iterator<ElementInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>> iterator() {
/*  93 */       return new FlattenIterator(TypeInfoSetImpl.this.elementMappings.values());
/*     */     }
/*     */   };
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private final NonElement<TypeT, ClassDeclT> anyType;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private Map<String, Map<String, String>> xmlNsCache;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public TypeInfoSetImpl(Navigator<TypeT, ClassDeclT, FieldT, MethodT> nav, AnnotationReader<TypeT, ClassDeclT, FieldT, MethodT> reader, Map<TypeT, ? extends BuiltinLeafInfoImpl<TypeT, ClassDeclT>> leaves)
/*     */   {
/* 115 */     this.nav = nav;
/* 116 */     this.reader = reader;
/* 117 */     this.builtins.putAll(leaves);
/*     */     
/* 119 */     this.anyType = createAnyType();
/*     */     
/*     */ 
/* 122 */     for (Map.Entry<Class, Class> e : RuntimeUtil.primitiveToBox.entrySet()) {
/* 123 */       this.builtins.put(nav.getPrimitive((Class)e.getKey()), leaves.get(nav.ref((Class)e.getValue())));
/*     */     }
/*     */     
/*     */ 
/* 127 */     this.elementMappings.put(null, new LinkedHashMap());
/*     */   }
/*     */   
/*     */   protected NonElement<TypeT, ClassDeclT> createAnyType() {
/* 131 */     return new AnyTypeImpl(this.nav);
/*     */   }
/*     */   
/*     */   public Navigator<TypeT, ClassDeclT, FieldT, MethodT> getNavigator() {
/* 135 */     return this.nav;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void add(ClassInfoImpl<TypeT, ClassDeclT, FieldT, MethodT> ci)
/*     */   {
/* 142 */     this.beans.put(ci.getClazz(), ci);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void add(EnumLeafInfoImpl<TypeT, ClassDeclT, FieldT, MethodT> li)
/*     */   {
/* 149 */     this.enums.put(li.clazz, li);
/*     */   }
/*     */   
/*     */   public void add(ArrayInfoImpl<TypeT, ClassDeclT, FieldT, MethodT> ai) {
/* 153 */     this.arrays.put(ai.getType(), ai);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public NonElement<TypeT, ClassDeclT> getTypeInfo(TypeT type)
/*     */   {
/* 164 */     type = this.nav.erasure(type);
/*     */     
/* 166 */     LeafInfo<TypeT, ClassDeclT> l = (LeafInfo)this.builtins.get(type);
/* 167 */     if (l != null) { return l;
/*     */     }
/* 169 */     if (this.nav.isArray(type)) {
/* 170 */       return (NonElement)this.arrays.get(type);
/*     */     }
/*     */     
/* 173 */     ClassDeclT d = this.nav.asDecl(type);
/* 174 */     if (d == null) return null;
/* 175 */     return getClassInfo(d);
/*     */   }
/*     */   
/*     */   public NonElement<TypeT, ClassDeclT> getAnyTypeInfo() {
/* 179 */     return this.anyType;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public NonElement<TypeT, ClassDeclT> getTypeInfo(Ref<TypeT, ClassDeclT> ref)
/*     */   {
/* 187 */     assert (!ref.valueList);
/* 188 */     ClassDeclT c = this.nav.asDecl(ref.type);
/* 189 */     if ((c != null) && (this.reader.getClassAnnotation(XmlRegistry.class, c, null) != null)) {
/* 190 */       return null;
/*     */     }
/* 192 */     return getTypeInfo(ref.type);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public Map<ClassDeclT, ? extends ClassInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>> beans()
/*     */   {
/* 199 */     return this.beansView;
/*     */   }
/*     */   
/*     */   public Map<TypeT, ? extends BuiltinLeafInfo<TypeT, ClassDeclT>> builtins() {
/* 203 */     return this.builtins;
/*     */   }
/*     */   
/*     */   public Map<ClassDeclT, ? extends EnumLeafInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>> enums() {
/* 207 */     return this.enums;
/*     */   }
/*     */   
/*     */   public Map<? extends TypeT, ? extends ArrayInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>> arrays() {
/* 211 */     return this.arrays;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public NonElement<TypeT, ClassDeclT> getClassInfo(ClassDeclT type)
/*     */   {
/* 226 */     LeafInfo<TypeT, ClassDeclT> l = (LeafInfo)this.builtins.get(this.nav.use(type));
/* 227 */     if (l != null) { return l;
/*     */     }
/* 229 */     l = (LeafInfo)this.enums.get(type);
/* 230 */     if (l != null) { return l;
/*     */     }
/* 232 */     if (this.nav.asDecl(Object.class).equals(type)) {
/* 233 */       return this.anyType;
/*     */     }
/* 235 */     return (NonElement)this.beans.get(type);
/*     */   }
/*     */   
/*     */   public ElementInfoImpl<TypeT, ClassDeclT, FieldT, MethodT> getElementInfo(ClassDeclT scope, QName name) {
/* 239 */     while (scope != null) {
/* 240 */       Map<QName, ElementInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>> m = (Map)this.elementMappings.get(scope);
/* 241 */       if (m != null) {
/* 242 */         ElementInfoImpl<TypeT, ClassDeclT, FieldT, MethodT> r = (ElementInfoImpl)m.get(name);
/* 243 */         if (r != null) return r;
/*     */       }
/* 245 */       scope = this.nav.getSuperClass(scope);
/*     */     }
/* 247 */     return (ElementInfoImpl)((Map)this.elementMappings.get(null)).get(name);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public final void add(ElementInfoImpl<TypeT, ClassDeclT, FieldT, MethodT> ei, ModelBuilder<TypeT, ClassDeclT, FieldT, MethodT> builder)
/*     */   {
/* 255 */     ClassDeclT scope = null;
/* 256 */     if (ei.getScope() != null) {
/* 257 */       scope = ei.getScope().getClazz();
/*     */     }
/* 259 */     Map<QName, ElementInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>> m = (Map)this.elementMappings.get(scope);
/* 260 */     if (m == null) {
/* 261 */       this.elementMappings.put(scope, m = new LinkedHashMap());
/*     */     }
/* 263 */     ElementInfoImpl<TypeT, ClassDeclT, FieldT, MethodT> existing = (ElementInfoImpl)m.put(ei.getElementName(), ei);
/*     */     
/* 265 */     if (existing != null) {
/* 266 */       QName en = ei.getElementName();
/* 267 */       builder.reportError(new IllegalAnnotationException(Messages.CONFLICTING_XML_ELEMENT_MAPPING.format(new Object[] { en.getNamespaceURI(), en.getLocalPart() }), ei, existing));
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public Map<QName, ? extends ElementInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>> getElementMappings(ClassDeclT scope)
/*     */   {
/* 275 */     return (Map)this.elementMappings.get(scope);
/*     */   }
/*     */   
/*     */   public Iterable<? extends ElementInfoImpl<TypeT, ClassDeclT, FieldT, MethodT>> getAllElements() {
/* 279 */     return this.allElements;
/*     */   }
/*     */   
/*     */   public Map<String, String> getXmlNs(String namespaceUri) {
/* 283 */     if (this.xmlNsCache == null) {
/* 284 */       this.xmlNsCache = new HashMap();
/*     */       
/* 286 */       for (ClassInfoImpl<TypeT, ClassDeclT, FieldT, MethodT> ci : beans().values()) {
/* 287 */         XmlSchema xs = (XmlSchema)this.reader.getPackageAnnotation(XmlSchema.class, ci.getClazz(), null);
/* 288 */         if (xs != null)
/*     */         {
/*     */ 
/* 291 */           String uri = xs.namespace();
/* 292 */           Map<String, String> m = (Map)this.xmlNsCache.get(uri);
/* 293 */           if (m == null) {
/* 294 */             this.xmlNsCache.put(uri, m = new HashMap());
/*     */           }
/* 296 */           for (XmlNs xns : xs.xmlns()) {
/* 297 */             m.put(xns.prefix(), xns.namespaceURI());
/*     */           }
/*     */         }
/*     */       }
/*     */     }
/* 302 */     Map<String, String> r = (Map)this.xmlNsCache.get(namespaceUri);
/* 303 */     if (r != null) return r;
/* 304 */     return Collections.emptyMap();
/*     */   }
/*     */   
/*     */   public final XmlNsForm getElementFormDefault(String nsUri) {
/* 308 */     for (ClassInfoImpl<TypeT, ClassDeclT, FieldT, MethodT> ci : beans().values()) {
/* 309 */       XmlSchema xs = (XmlSchema)this.reader.getPackageAnnotation(XmlSchema.class, ci.getClazz(), null);
/* 310 */       if ((xs != null) && 
/*     */       
/*     */ 
/* 313 */         (xs.namespace().equals(nsUri)))
/*     */       {
/*     */ 
/* 316 */         XmlNsForm xnf = xs.elementFormDefault();
/* 317 */         if (xnf != XmlNsForm.UNSET)
/* 318 */           return xnf;
/*     */       } }
/* 320 */     return XmlNsForm.UNSET;
/*     */   }
/*     */   
/*     */   public final XmlNsForm getAttributeFormDefault(String nsUri) {
/* 324 */     for (ClassInfoImpl<TypeT, ClassDeclT, FieldT, MethodT> ci : beans().values()) {
/* 325 */       XmlSchema xs = (XmlSchema)this.reader.getPackageAnnotation(XmlSchema.class, ci.getClazz(), null);
/* 326 */       if ((xs != null) && 
/*     */       
/*     */ 
/* 329 */         (xs.namespace().equals(nsUri)))
/*     */       {
/*     */ 
/* 332 */         XmlNsForm xnf = xs.attributeFormDefault();
/* 333 */         if (xnf != XmlNsForm.UNSET)
/* 334 */           return xnf;
/*     */       } }
/* 336 */     return XmlNsForm.UNSET;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void dump(Result out)
/*     */     throws JAXBException
/*     */   {
/* 347 */     JAXBContext context = JAXBContext.newInstance(new Class[] { getClass() });
/* 348 */     Marshaller m = context.createMarshaller();
/* 349 */     m.marshal(this, out);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\impl\TypeInfoSetImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */