/*     */ package com.sun.xml.bind.v2.runtime;
/*     */ 
/*     */ import com.sun.istack.NotNull;
/*     */ import com.sun.xml.bind.api.TypeReference;
/*     */ import com.sun.xml.bind.marshaller.SAX2DOMEx;
/*     */ import com.sun.xml.bind.v2.runtime.output.SAXOutput;
/*     */ import com.sun.xml.bind.v2.runtime.output.XMLStreamWriterOutput;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallerImpl;
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.io.OutputStream;
/*     */ import javax.xml.bind.JAXBElement;
/*     */ import javax.xml.bind.JAXBException;
/*     */ import javax.xml.bind.Marshaller;
/*     */ import javax.xml.bind.Unmarshaller;
/*     */ import javax.xml.namespace.NamespaceContext;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import javax.xml.stream.XMLStreamReader;
/*     */ import javax.xml.stream.XMLStreamWriter;
/*     */ import javax.xml.transform.Result;
/*     */ import javax.xml.transform.Source;
/*     */ import org.w3c.dom.Node;
/*     */ import org.xml.sax.ContentHandler;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ final class BridgeImpl<T>
/*     */   extends InternalBridge<T>
/*     */ {
/*     */   private final Name tagName;
/*     */   private final JaxBeanInfo<T> bi;
/*     */   private final TypeReference typeRef;
/*     */   
/*     */   public BridgeImpl(JAXBContextImpl context, Name tagName, JaxBeanInfo<T> bi, TypeReference typeRef)
/*     */   {
/*  46 */     super(context);
/*  47 */     this.tagName = tagName;
/*  48 */     this.bi = bi;
/*  49 */     this.typeRef = typeRef;
/*     */   }
/*     */   
/*     */   public void marshal(Marshaller _m, T t, XMLStreamWriter output) throws JAXBException {
/*  53 */     MarshallerImpl m = (MarshallerImpl)_m;
/*  54 */     m.write(this.tagName, this.bi, t, XMLStreamWriterOutput.create(output), new StAXPostInitAction(output, m.serializer));
/*     */   }
/*     */   
/*     */   public void marshal(Marshaller _m, T t, OutputStream output, NamespaceContext nsContext) throws JAXBException {
/*  58 */     MarshallerImpl m = (MarshallerImpl)_m;
/*     */     
/*  60 */     Runnable pia = null;
/*  61 */     if (nsContext != null) {
/*  62 */       pia = new StAXPostInitAction(nsContext, m.serializer);
/*     */     }
/*  64 */     m.write(this.tagName, this.bi, t, m.createWriter(output), pia);
/*     */   }
/*     */   
/*     */   public void marshal(Marshaller _m, T t, Node output) throws JAXBException {
/*  68 */     MarshallerImpl m = (MarshallerImpl)_m;
/*  69 */     m.write(this.tagName, this.bi, t, new SAXOutput(new SAX2DOMEx(output)), new DomPostInitAction(output, m.serializer));
/*     */   }
/*     */   
/*     */   public void marshal(Marshaller _m, T t, ContentHandler contentHandler) throws JAXBException {
/*  73 */     MarshallerImpl m = (MarshallerImpl)_m;
/*  74 */     m.write(this.tagName, this.bi, t, new SAXOutput(contentHandler), null);
/*     */   }
/*     */   
/*     */   public void marshal(Marshaller _m, T t, Result result) throws JAXBException {
/*  78 */     MarshallerImpl m = (MarshallerImpl)_m;
/*  79 */     m.write(this.tagName, this.bi, t, m.createXmlOutput(result), m.createPostInitAction(result));
/*     */   }
/*     */   
/*     */   @NotNull
/*  83 */   public T unmarshal(Unmarshaller _u, XMLStreamReader in) throws JAXBException { UnmarshallerImpl u = (UnmarshallerImpl)_u;
/*  84 */     return (T)((JAXBElement)u.unmarshal0(in, this.bi)).getValue();
/*     */   }
/*     */   
/*     */   @NotNull
/*  88 */   public T unmarshal(Unmarshaller _u, Source in) throws JAXBException { UnmarshallerImpl u = (UnmarshallerImpl)_u;
/*  89 */     return (T)((JAXBElement)u.unmarshal0(in, this.bi)).getValue();
/*     */   }
/*     */   
/*     */   @NotNull
/*  93 */   public T unmarshal(Unmarshaller _u, InputStream in) throws JAXBException { UnmarshallerImpl u = (UnmarshallerImpl)_u;
/*  94 */     return (T)((JAXBElement)u.unmarshal0(in, this.bi)).getValue();
/*     */   }
/*     */   
/*     */   @NotNull
/*  98 */   public T unmarshal(Unmarshaller _u, Node n) throws JAXBException { UnmarshallerImpl u = (UnmarshallerImpl)_u;
/*  99 */     return (T)((JAXBElement)u.unmarshal0(n, this.bi)).getValue();
/*     */   }
/*     */   
/*     */   public TypeReference getTypeReference() {
/* 103 */     return this.typeRef;
/*     */   }
/*     */   
/*     */   public void marshal(T value, XMLSerializer out) throws IOException, SAXException, XMLStreamException {
/* 107 */     out.startElement(this.tagName, null);
/* 108 */     if (value == null) {
/* 109 */       out.writeXsiNilTrue();
/*     */     } else {
/* 111 */       out.childAsXsiType(value, null, this.bi);
/*     */     }
/* 113 */     out.endElement();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\BridgeImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */