/*     */ package com.sun.xml.bind.v2.runtime.output;
/*     */ 
/*     */ import java.io.IOException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class Encoded
/*     */ {
/*     */   public byte[] buf;
/*     */   public int len;
/*     */   
/*     */   public Encoded(String text)
/*     */   {
/*  20 */     set(text);
/*     */   }
/*     */   
/*     */   public void ensureSize(int size) {
/*  24 */     if ((this.buf == null) || (this.buf.length < size))
/*  25 */       this.buf = new byte[size];
/*     */   }
/*     */   
/*     */   public final void set(String text) {
/*  29 */     int length = text.length();
/*     */     
/*  31 */     ensureSize(length * 3 + 1);
/*     */     
/*  33 */     int ptr = 0;
/*     */     
/*  35 */     for (int i = 0; i < length; i++) {
/*  36 */       char chr = text.charAt(i);
/*  37 */       if (chr > '') {
/*  38 */         if (chr > '߿') {
/*  39 */           if ((55296 <= chr) && (chr <= 57343))
/*     */           {
/*  41 */             int uc = ((chr & 0x3FF) << '\n' | text.charAt(++i) & 0x3FF) + 65536;
/*     */             
/*  43 */             this.buf[(ptr++)] = ((byte)(0xF0 | uc >> 18));
/*  44 */             this.buf[(ptr++)] = ((byte)(0x80 | uc >> 12 & 0x3F));
/*  45 */             this.buf[(ptr++)] = ((byte)(0x80 | uc >> 6 & 0x3F));
/*  46 */             this.buf[(ptr++)] = ((byte)(128 + (uc & 0x3F)));
/*  47 */             continue;
/*     */           }
/*  49 */           this.buf[(ptr++)] = ((byte)(224 + (chr >> '\f')));
/*  50 */           this.buf[(ptr++)] = ((byte)(128 + (chr >> '\006' & 0x3F)));
/*     */         } else {
/*  52 */           this.buf[(ptr++)] = ((byte)(192 + (chr >> '\006')));
/*     */         }
/*  54 */         this.buf[(ptr++)] = ((byte)('' + (chr & 0x3F)));
/*     */       } else {
/*  56 */         this.buf[(ptr++)] = ((byte)chr);
/*     */       }
/*     */     }
/*     */     
/*  60 */     this.len = ptr;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final void setEscape(String text, boolean isAttribute)
/*     */   {
/*  71 */     int length = text.length();
/*  72 */     ensureSize(length * 6 + 1);
/*     */     
/*  74 */     int ptr = 0;
/*     */     
/*  76 */     for (int i = 0; i < length; i++) {
/*  77 */       char chr = text.charAt(i);
/*     */       
/*  79 */       int ptr1 = ptr;
/*  80 */       if (chr > '') {
/*  81 */         if (chr > '߿') {
/*  82 */           if ((55296 <= chr) && (chr <= 57343))
/*     */           {
/*  84 */             int uc = ((chr & 0x3FF) << '\n' | text.charAt(++i) & 0x3FF) + 65536;
/*     */             
/*  86 */             this.buf[(ptr++)] = ((byte)(0xF0 | uc >> 18));
/*  87 */             this.buf[(ptr++)] = ((byte)(0x80 | uc >> 12 & 0x3F));
/*  88 */             this.buf[(ptr++)] = ((byte)(0x80 | uc >> 6 & 0x3F));
/*  89 */             this.buf[(ptr++)] = ((byte)(128 + (uc & 0x3F)));
/*  90 */             continue;
/*     */           }
/*  92 */           this.buf[(ptr1++)] = ((byte)(224 + (chr >> '\f')));
/*  93 */           this.buf[(ptr1++)] = ((byte)(128 + (chr >> '\006' & 0x3F)));
/*     */         } else {
/*  95 */           this.buf[(ptr1++)] = ((byte)(192 + (chr >> '\006')));
/*     */         }
/*  97 */         this.buf[(ptr1++)] = ((byte)('' + (chr & 0x3F)));
/*     */       }
/*     */       else {
/*     */         byte[] ent;
/* 101 */         if ((ent = attributeEntities[chr]) != null)
/*     */         {
/*     */ 
/*     */ 
/*     */ 
/* 106 */           if ((isAttribute) || (entities[chr] != null)) {
/* 107 */             ptr1 = writeEntity(ent, ptr1);
/*     */           } else
/* 109 */             this.buf[(ptr1++)] = ((byte)chr);
/*     */         } else
/* 111 */           this.buf[(ptr1++)] = ((byte)chr);
/*     */       }
/* 113 */       ptr = ptr1;
/*     */     }
/* 115 */     this.len = ptr;
/*     */   }
/*     */   
/*     */   private int writeEntity(byte[] entity, int ptr) {
/* 119 */     System.arraycopy(entity, 0, this.buf, ptr, entity.length);
/* 120 */     return ptr + entity.length;
/*     */   }
/*     */   
/*     */ 
/*     */   public final void write(UTF8XmlOutput out)
/*     */     throws IOException
/*     */   {
/* 127 */     out.write(this.buf, 0, this.len);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public void append(char b)
/*     */   {
/* 135 */     this.buf[(this.len++)] = ((byte)b);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public void compact()
/*     */   {
/* 143 */     byte[] b = new byte[this.len];
/* 144 */     System.arraycopy(this.buf, 0, b, 0, this.len);
/* 145 */     this.buf = b;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 154 */   private static final byte[][] entities = new byte[''][];
/* 155 */   private static final byte[][] attributeEntities = new byte[''][];
/*     */   
/*     */   static {
/* 158 */     add('&', "&amp;", false);
/* 159 */     add('<', "&lt;", false);
/* 160 */     add('>', "&gt;", false);
/* 161 */     add('"', "&quot;", false);
/* 162 */     add('\t', "&#x9;", true);
/* 163 */     add('\r', "&#xD;", false);
/* 164 */     add('\n', "&#xA;", true);
/*     */   }
/*     */   
/*     */   private static void add(char c, String s, boolean attOnly) {
/* 168 */     byte[] image = UTF8XmlOutput.toBytes(s);
/* 169 */     attributeEntities[c] = image;
/* 170 */     if (!attOnly) {
/* 171 */       entities[c] = image;
/*     */     }
/*     */   }
/*     */   
/*     */   public Encoded() {}
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\output\Encoded.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */