/*     */ package com.sun.xml.bind.v2.runtime.output;
/*     */ 
/*     */ import com.sun.istack.NotNull;
/*     */ import com.sun.istack.Nullable;
/*     */ import com.sun.xml.bind.marshaller.NamespacePrefixMapper;
/*     */ import com.sun.xml.bind.v2.runtime.Name;
/*     */ import com.sun.xml.bind.v2.runtime.NameList;
/*     */ import com.sun.xml.bind.v2.runtime.NamespaceContext2;
/*     */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*     */ import java.io.IOException;
/*     */ import java.util.Collections;
/*     */ import java.util.Iterator;
/*     */ import java.util.Set;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class NamespaceContextImpl
/*     */   implements NamespaceContext2
/*     */ {
/*     */   private final XMLSerializer owner;
/*  32 */   private String[] prefixes = new String[4];
/*  33 */   private String[] nsUris = new String[4];
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private int size;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private Element current;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private final Element top;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  78 */   private NamespacePrefixMapper prefixMapper = defaultNamespacePrefixMapper;
/*     */   
/*     */ 
/*     */   public boolean collectionMode;
/*     */   
/*     */ 
/*     */ 
/*     */   public NamespaceContextImpl(XMLSerializer owner)
/*     */   {
/*  87 */     this.owner = owner;
/*     */     
/*  89 */     this.current = (this.top = new Element(this, null, null));
/*     */     
/*  91 */     put("http://www.w3.org/XML/1998/namespace", "xml");
/*     */   }
/*     */   
/*     */   public void setPrefixMapper(NamespacePrefixMapper mapper) {
/*  95 */     if (mapper == null)
/*  96 */       mapper = defaultNamespacePrefixMapper;
/*  97 */     this.prefixMapper = mapper;
/*     */   }
/*     */   
/*     */   public NamespacePrefixMapper getPrefixMapper() {
/* 101 */     return this.prefixMapper;
/*     */   }
/*     */   
/*     */   public void reset() {
/* 105 */     this.current = this.top;
/* 106 */     this.size = 1;
/* 107 */     this.collectionMode = false;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public int declareNsUri(String uri, String preferedPrefix, boolean requirePrefix)
/*     */   {
/* 115 */     preferedPrefix = this.prefixMapper.getPreferredPrefix(uri, preferedPrefix, requirePrefix);
/*     */     
/* 117 */     if (uri.length() == 0) {
/* 118 */       for (int i = this.size - 1; i >= 0; i--) {
/* 119 */         if (this.nsUris[i].length() == 0)
/* 120 */           return i;
/* 121 */         if (this.prefixes[i].length() == 0)
/*     */         {
/*     */ 
/* 124 */           assert ((this.current.defaultPrefixIndex == -1) && (this.current.oldDefaultNamespaceUriIndex == -1));
/*     */           
/* 126 */           String oldUri = this.nsUris[i];
/* 127 */           String[] knownURIs = this.owner.nameList.namespaceURIs;
/*     */           
/* 129 */           if (this.current.baseIndex <= i)
/*     */           {
/*     */ 
/* 132 */             this.nsUris[i] = "";
/*     */             
/* 134 */             int subst = put(oldUri, null);
/*     */             
/*     */ 
/* 137 */             for (int j = knownURIs.length - 1; j >= 0; j--) {
/* 138 */               if (knownURIs[j].equals(oldUri)) {
/* 139 */                 this.owner.knownUri2prefixIndexMap[j] = subst;
/* 140 */                 break;
/*     */               }
/*     */             }
/*     */             
/* 144 */             return i;
/*     */           }
/*     */           
/*     */ 
/*     */ 
/* 149 */           for (int j = knownURIs.length - 1; j >= 0; j--) {
/* 150 */             if (knownURIs[j].equals(oldUri)) {
/* 151 */               this.current.defaultPrefixIndex = i;
/* 152 */               this.current.oldDefaultNamespaceUriIndex = j;
/* 153 */               assert (this.owner.knownUri2prefixIndexMap[j] == this.current.defaultPrefixIndex);
/*     */               
/* 155 */               this.owner.knownUri2prefixIndexMap[j] = this.size;
/* 156 */               break;
/*     */             }
/*     */           }
/*     */           
/* 160 */           put(this.nsUris[i], null);
/* 161 */           return put("", "");
/*     */         }
/*     */       }
/*     */       
/*     */ 
/*     */ 
/* 167 */       return put("", "");
/*     */     }
/*     */     
/* 170 */     for (int i = this.size - 1; i >= 0; i--) {
/* 171 */       String p = this.prefixes[i];
/* 172 */       if ((this.nsUris[i].equals(uri)) && (
/* 173 */         (!requirePrefix) || (p.length() > 0))) {
/* 174 */         return i;
/*     */       }
/*     */       
/* 177 */       if (p.equals(preferedPrefix))
/*     */       {
/* 179 */         preferedPrefix = null;
/*     */       }
/*     */     }
/*     */     
/* 183 */     if ((preferedPrefix == null) && (requirePrefix))
/*     */     {
/*     */ 
/* 186 */       preferedPrefix = makeUniquePrefix();
/*     */     }
/*     */     
/*     */ 
/* 190 */     return put(uri, preferedPrefix);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public int put(@NotNull String uri, @Nullable String prefix)
/*     */   {
/* 201 */     if (this.size == this.nsUris.length)
/*     */     {
/* 203 */       String[] u = new String[this.nsUris.length * 2];
/* 204 */       String[] p = new String[this.prefixes.length * 2];
/* 205 */       System.arraycopy(this.nsUris, 0, u, 0, this.nsUris.length);
/* 206 */       System.arraycopy(this.prefixes, 0, p, 0, this.prefixes.length);
/* 207 */       this.nsUris = u;
/* 208 */       this.prefixes = p;
/*     */     }
/* 210 */     if (prefix == null) {
/* 211 */       if (this.size == 1) {
/* 212 */         prefix = "";
/*     */       }
/*     */       else {
/* 215 */         prefix = makeUniquePrefix();
/*     */       }
/*     */     }
/* 218 */     this.nsUris[this.size] = uri;
/* 219 */     this.prefixes[this.size] = prefix;
/*     */     
/* 221 */     return this.size++;
/*     */   }
/*     */   
/*     */   private String makeUniquePrefix()
/*     */   {
/* 226 */     String prefix = 5 + "ns" + this.size;
/* 227 */     while (getNamespaceURI(prefix) != null) {
/* 228 */       prefix = prefix + '_';
/*     */     }
/* 230 */     return prefix;
/*     */   }
/*     */   
/*     */   public Element getCurrent()
/*     */   {
/* 235 */     return this.current;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public int getPrefixIndex(String uri)
/*     */   {
/* 243 */     for (int i = this.size - 1; i >= 0; i--) {
/* 244 */       if (this.nsUris[i].equals(uri))
/* 245 */         return i;
/*     */     }
/* 247 */     throw new IllegalStateException();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getPrefix(int prefixIndex)
/*     */   {
/* 256 */     return this.prefixes[prefixIndex];
/*     */   }
/*     */   
/*     */   public String getNamespaceURI(int prefixIndex) {
/* 260 */     return this.nsUris[prefixIndex];
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getNamespaceURI(String prefix)
/*     */   {
/* 270 */     for (int i = this.size - 1; i >= 0; i--)
/* 271 */       if (this.prefixes[i].equals(prefix))
/* 272 */         return this.nsUris[i];
/* 273 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getPrefix(String uri)
/*     */   {
/* 281 */     if (this.collectionMode) {
/* 282 */       return declareNamespace(uri, null, false);
/*     */     }
/* 284 */     for (int i = this.size - 1; i >= 0; i--)
/* 285 */       if (this.nsUris[i].equals(uri))
/* 286 */         return this.prefixes[i];
/* 287 */     return null;
/*     */   }
/*     */   
/*     */   public Iterator<String> getPrefixes(String uri)
/*     */   {
/* 292 */     String prefix = getPrefix(uri);
/* 293 */     if (prefix == null) {
/* 294 */       return Collections.emptySet().iterator();
/*     */     }
/* 296 */     return Collections.singleton(uri).iterator();
/*     */   }
/*     */   
/*     */   public String declareNamespace(String namespaceUri, String preferedPrefix, boolean requirePrefix) {
/* 300 */     int idx = declareNsUri(namespaceUri, preferedPrefix, requirePrefix);
/* 301 */     return getPrefix(idx);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public int count()
/*     */   {
/* 308 */     return this.size;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final class Element
/*     */   {
/*     */     public final NamespaceContextImpl context;
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */     private final Element prev;
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */     private Element next;
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */     private int oldDefaultNamespaceUriIndex;
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */     private int defaultPrefixIndex;
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */     private int baseIndex;
/*     */     
/*     */ 
/*     */ 
/*     */     private final int depth;
/*     */     
/*     */ 
/*     */ 
/*     */     private int elementNamePrefix;
/*     */     
/*     */ 
/*     */ 
/*     */     private String elementLocalName;
/*     */     
/*     */ 
/*     */ 
/*     */     private Name elementName;
/*     */     
/*     */ 
/*     */ 
/*     */     private Object outerPeer;
/*     */     
/*     */ 
/*     */ 
/*     */     private Object innerPeer;
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */     private Element(NamespaceContextImpl context, Element prev)
/*     */     {
/* 373 */       this.context = context;
/* 374 */       this.prev = prev;
/* 375 */       this.depth = (prev == null ? 0 : prev.depth + 1);
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */     public boolean isRootElement()
/*     */     {
/* 383 */       return this.depth == 1;
/*     */     }
/*     */     
/*     */     public Element push() {
/* 387 */       if (this.next == null)
/* 388 */         this.next = new Element(NamespaceContextImpl.this, this.context, this);
/* 389 */       this.next.onPushed();
/* 390 */       return this.next;
/*     */     }
/*     */     
/*     */     public Element pop() {
/* 394 */       if (this.oldDefaultNamespaceUriIndex >= 0)
/*     */       {
/* 396 */         this.context.owner.knownUri2prefixIndexMap[this.oldDefaultNamespaceUriIndex] = this.defaultPrefixIndex;
/*     */       }
/* 398 */       this.context.size = this.baseIndex;
/* 399 */       this.context.current = this.prev;
/* 400 */       return this.prev;
/*     */     }
/*     */     
/*     */     private void onPushed() {
/* 404 */       this.oldDefaultNamespaceUriIndex = (this.defaultPrefixIndex = -1);
/* 405 */       this.baseIndex = this.context.size;
/* 406 */       this.context.current = this;
/*     */     }
/*     */     
/*     */     public void setTagName(int prefix, String localName, Object outerPeer) {
/* 410 */       assert (localName != null);
/* 411 */       this.elementNamePrefix = prefix;
/* 412 */       this.elementLocalName = localName;
/* 413 */       this.elementName = null;
/* 414 */       this.outerPeer = outerPeer;
/*     */     }
/*     */     
/*     */     public void setTagName(Name tagName, Object outerPeer) {
/* 418 */       assert (tagName != null);
/* 419 */       this.elementName = tagName;
/* 420 */       this.outerPeer = outerPeer;
/*     */     }
/*     */     
/*     */     public void startElement(XmlOutput out, Object innerPeer) throws IOException, XMLStreamException {
/* 424 */       this.innerPeer = innerPeer;
/* 425 */       if (this.elementName != null) {
/* 426 */         out.beginStartTag(this.elementName);
/*     */       } else {
/* 428 */         out.beginStartTag(this.elementNamePrefix, this.elementLocalName);
/*     */       }
/*     */     }
/*     */     
/*     */     public void endElement(XmlOutput out) throws IOException, SAXException, XMLStreamException {
/* 433 */       if (this.elementName != null) {
/* 434 */         out.endTag(this.elementName);
/* 435 */         this.elementName = null;
/*     */       } else {
/* 437 */         out.endTag(this.elementNamePrefix, this.elementLocalName);
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */     public final int count()
/*     */     {
/* 445 */       return this.context.size - this.baseIndex;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     public final String getPrefix(int idx)
/*     */     {
/* 455 */       return this.context.prefixes[(this.baseIndex + idx)];
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     public final String getNsUri(int idx)
/*     */     {
/* 465 */       return this.context.nsUris[(this.baseIndex + idx)];
/*     */     }
/*     */     
/*     */     public int getBase() {
/* 469 */       return this.baseIndex;
/*     */     }
/*     */     
/*     */     public Object getOuterPeer() {
/* 473 */       return this.outerPeer;
/*     */     }
/*     */     
/*     */     public Object getInnerPeer() {
/* 477 */       return this.innerPeer;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */     public Element getParent()
/*     */     {
/* 484 */       return this.prev;
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 493 */   private static final NamespacePrefixMapper defaultNamespacePrefixMapper = new NamespacePrefixMapper() {
/*     */     public String getPreferredPrefix(String namespaceUri, String suggestion, boolean requirePrefix) {
/* 495 */       if (namespaceUri.equals("http://www.w3.org/2001/XMLSchema-instance"))
/* 496 */         return "xsi";
/* 497 */       if (namespaceUri.equals("http://www.w3.org/2001/XMLSchema"))
/* 498 */         return "xs";
/* 499 */       if (namespaceUri.equals("http://www.w3.org/2005/05/xmlmime"))
/* 500 */         return "xmime";
/* 501 */       return suggestion;
/*     */     }
/*     */   };
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\output\NamespaceContextImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */