/*     */ package com.sun.xml.bind.v2.runtime.unmarshaller;
/*     */ 
/*     */ import com.sun.xml.bind.v2.runtime.JAXBContextImpl;
/*     */ import javax.xml.bind.annotation.DomHandler;
/*     */ import javax.xml.transform.Result;
/*     */ import javax.xml.transform.sax.TransformerHandler;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class DomLoader<ResultT extends Result>
/*     */   extends Loader
/*     */ {
/*     */   private final DomHandler<?, ResultT> dom;
/*     */   
/*     */   private final class State
/*     */   {
/*  27 */     private final TransformerHandler handler = JAXBContextImpl.createTransformerHandler();
/*     */     
/*     */ 
/*     */     private final ResultT result;
/*     */     
/*     */ 
/*  33 */     int depth = 1;
/*     */     
/*     */     public State(UnmarshallingContext context) throws SAXException {
/*  36 */       this.result = DomLoader.this.dom.createUnmarshaller(context);
/*     */       
/*  38 */       this.handler.setResult(this.result);
/*     */       
/*     */       try
/*     */       {
/*  42 */         this.handler.setDocumentLocator(context.getLocator());
/*  43 */         this.handler.startDocument();
/*  44 */         declarePrefixes(context, context.getAllDeclaredPrefixes());
/*     */       } catch (SAXException e) {
/*  46 */         context.handleError(e);
/*  47 */         throw e;
/*     */       }
/*     */     }
/*     */     
/*     */     public Object getElement() {
/*  52 */       return DomLoader.this.dom.getElement(this.result);
/*     */     }
/*     */     
/*     */     private void declarePrefixes(UnmarshallingContext context, String[] prefixes) throws SAXException {
/*  56 */       for (int i = prefixes.length - 1; i >= 0; i--) {
/*  57 */         String nsUri = context.getNamespaceURI(prefixes[i]);
/*  58 */         if (nsUri == null) throw new IllegalStateException("prefix '" + prefixes[i] + "' isn't bound");
/*  59 */         this.handler.startPrefixMapping(prefixes[i], nsUri);
/*     */       }
/*     */     }
/*     */     
/*     */     private void undeclarePrefixes(String[] prefixes) throws SAXException {
/*  64 */       for (int i = prefixes.length - 1; i >= 0; i--)
/*  65 */         this.handler.endPrefixMapping(prefixes[i]);
/*     */     }
/*     */   }
/*     */   
/*     */   public DomLoader(DomHandler<?, ResultT> dom) {
/*  70 */     super(true);
/*  71 */     this.dom = dom;
/*     */   }
/*     */   
/*     */   public void startElement(UnmarshallingContext.State state, TagName ea) throws SAXException {
/*  75 */     UnmarshallingContext context = state.getContext();
/*  76 */     if (state.target == null) {
/*  77 */       state.target = new State(context);
/*     */     }
/*  79 */     DomLoader<ResultT>.State s = (State)state.target;
/*     */     try {
/*  81 */       s.declarePrefixes(context, context.getNewlyDeclaredPrefixes());
/*  82 */       s.handler.startElement(ea.uri, ea.local, ea.getQname(), ea.atts);
/*     */     } catch (SAXException e) {
/*  84 */       context.handleError(e);
/*  85 */       throw e;
/*     */     }
/*     */   }
/*     */   
/*     */   public void childElement(UnmarshallingContext.State state, TagName ea) throws SAXException
/*     */   {
/*  91 */     state.loader = this;
/*  92 */     DomLoader<ResultT>.State s = (State)state.prev.target;
/*  93 */     s.depth += 1;
/*  94 */     state.target = s;
/*     */   }
/*     */   
/*     */   public void text(UnmarshallingContext.State state, CharSequence text) throws SAXException {
/*  98 */     if (text.length() == 0)
/*  99 */       return;
/*     */     try {
/* 101 */       DomLoader<ResultT>.State s = (State)state.target;
/* 102 */       s.handler.characters(text.toString().toCharArray(), 0, text.length());
/*     */     } catch (SAXException e) {
/* 104 */       state.getContext().handleError(e);
/* 105 */       throw e;
/*     */     }
/*     */   }
/*     */   
/*     */   public void leaveElement(UnmarshallingContext.State state, TagName ea) throws SAXException {
/* 110 */     DomLoader<ResultT>.State s = (State)state.target;
/* 111 */     UnmarshallingContext context = state.getContext();
/*     */     try
/*     */     {
/* 114 */       s.handler.endElement(ea.uri, ea.local, ea.getQname());
/* 115 */       s.undeclarePrefixes(context.getNewlyDeclaredPrefixes());
/*     */     } catch (SAXException e) {
/* 117 */       context.handleError(e);
/* 118 */       throw e;
/*     */     }
/*     */     
/* 121 */     if (--s.depth == 0)
/*     */     {
/*     */       try {
/* 124 */         s.undeclarePrefixes(context.getAllDeclaredPrefixes());
/* 125 */         s.handler.endDocument();
/*     */       } catch (SAXException e) {
/* 127 */         context.handleError(e);
/* 128 */         throw e;
/*     */       }
/*     */       
/*     */ 
/* 132 */       state.target = s.getElement();
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\unmarshaller\DomLoader.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */