/*     */ package org.codehaus.commons.compiler.samples;
/*     */ 
/*     */ import java.io.PrintStream;
/*     */ import org.codehaus.commons.compiler.CompilerFactoryFactory;
/*     */ import org.codehaus.commons.compiler.IClassBodyEvaluator;
/*     */ import org.codehaus.commons.compiler.ICompilerFactory;
/*     */ import org.codehaus.commons.compiler.ICookable;
/*     */ import org.codehaus.commons.compiler.IExpressionEvaluator;
/*     */ import org.codehaus.commons.compiler.IScriptEvaluator;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class ExpressionDemo
/*     */   extends DemoBase
/*     */ {
/*     */   public static void main(String[] args)
/*     */     throws Exception
/*     */   {
/*  37 */     Class optionalExpressionType = null;
/*  38 */     String[] parameterNames = new String[0];
/*  39 */     Class[] parameterTypes = new Class[0];
/*  40 */     Class[] thrownExceptions = new Class[0];
/*  41 */     String[] optionalDefaultImports = null;
/*     */     
/*     */ 
/*  44 */     for (int i = 0; i < args.length; i++) {
/*  45 */       String arg = args[i];
/*  46 */       if (!arg.startsWith("-")) break;
/*  47 */       if (arg.equals("-et")) {
/*  48 */         optionalExpressionType = DemoBase.stringToType(args[(++i)]);
/*     */       }
/*  50 */       else if (arg.equals("-pn")) {
/*  51 */         parameterNames = DemoBase.explode(args[(++i)]);
/*     */       }
/*  53 */       else if (arg.equals("-pt")) {
/*  54 */         parameterTypes = DemoBase.stringToTypes(args[(++i)]);
/*     */       }
/*  56 */       else if (arg.equals("-te")) {
/*  57 */         thrownExceptions = DemoBase.stringToTypes(args[(++i)]);
/*     */       }
/*  59 */       else if (arg.equals("-di")) {
/*  60 */         optionalDefaultImports = DemoBase.explode(args[(++i)]);
/*     */       }
/*  62 */       else if (arg.equals("-help")) {
/*  63 */         System.err.println("Usage:");
/*  64 */         System.err.println("  ExpressionDemo { <option> } <expression> { <parameter-value> }");
/*  65 */         System.err.println("Compiles and evaluates the given expression and prints its value.");
/*  66 */         System.err.println("Valid options are");
/*  67 */         System.err.println(" -et <expression-type>                        (default: any)");
/*  68 */         System.err.println(" -pn <comma-separated-parameter-names>        (default: none)");
/*  69 */         System.err.println(" -pt <comma-separated-parameter-types>        (default: none)");
/*  70 */         System.err.println(" -te <comma-separated-thrown-exception-types> (default: none)");
/*  71 */         System.err.println(" -di <comma-separated-default-imports>        (default: none)");
/*  72 */         System.err.println(" -help");
/*  73 */         System.err.println("The number of parameter names, types and values must be identical.");
/*  74 */         System.exit(0);
/*     */       }
/*     */       else {
/*  77 */         System.err.println("Invalid command line option \"" + arg + "\"; try \"-help\".");
/*  78 */         System.exit(1);
/*     */       }
/*     */     }
/*     */     
/*  82 */     if (i >= args.length) {
/*  83 */       System.err.println("Expression missing; try \"-help\".");
/*  84 */       System.exit(1);
/*     */     }
/*  86 */     String expression = args[(i++)];
/*     */     
/*  88 */     if (parameterTypes.length != parameterNames.length) {
/*  89 */       System.err.println("Parameter type count (" + parameterTypes.length + ") and parameter name count (" + parameterNames.length + ") do not match; try \"-help\".");
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  96 */       System.exit(1);
/*     */     }
/*     */     
/*     */ 
/* 100 */     if (args.length - i != parameterNames.length) {
/* 101 */       System.err.println("Parameter value count (" + (args.length - i) + ") and parameter name count (" + parameterNames.length + ") do not match; try \"-help\".");
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 108 */       System.exit(1);
/*     */     }
/*     */     
/*     */ 
/* 112 */     Object[] arguments = new Object[parameterNames.length];
/* 113 */     for (int j = 0; j < parameterNames.length; j++) {
/* 114 */       arguments[j] = DemoBase.createObject(parameterTypes[j], args[(i + j)]);
/*     */     }
/*     */     
/*     */ 
/* 118 */     IExpressionEvaluator ee = CompilerFactoryFactory.getDefaultCompilerFactory().newExpressionEvaluator();
/* 119 */     ee.setExpressionType(optionalExpressionType);
/* 120 */     ee.setDefaultImports(optionalDefaultImports);
/* 121 */     ee.setParameters(parameterNames, parameterTypes);
/* 122 */     ee.setThrownExceptions(thrownExceptions);
/* 123 */     ee.cook(expression);
/*     */     
/*     */ 
/* 126 */     Object res = ee.evaluate(arguments);
/*     */     
/*     */ 
/* 129 */     System.out.println("Result = " + DemoBase.toString(res));
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\commons\compiler\samples\ExpressionDemo.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */