/*     */ package org.codehaus.jackson.impl;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.io.OutputStream;
/*     */ import org.codehaus.jackson.JsonParser.Feature;
/*     */ import org.codehaus.jackson.io.IOContext;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class StreamBasedParserBase
/*     */   extends JsonNumericParserBase
/*     */ {
/*     */   protected InputStream _inputStream;
/*     */   protected byte[] _inputBuffer;
/*     */   protected boolean _bufferRecyclable;
/*     */   
/*     */   protected StreamBasedParserBase(IOContext ctxt, int features, InputStream in, byte[] inputBuffer, int start, int end, boolean bufferRecyclable)
/*     */   {
/*  66 */     super(ctxt, features);
/*  67 */     this._inputStream = in;
/*  68 */     this._inputBuffer = inputBuffer;
/*  69 */     this._inputPtr = start;
/*  70 */     this._inputEnd = end;
/*  71 */     this._bufferRecyclable = bufferRecyclable;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public int releaseBuffered(OutputStream out)
/*     */     throws IOException
/*     */   {
/*  83 */     int count = this._inputEnd - this._inputPtr;
/*  84 */     if (count < 1) {
/*  85 */       return 0;
/*     */     }
/*     */     
/*  88 */     int origPtr = this._inputPtr;
/*  89 */     out.write(this._inputBuffer, origPtr, count);
/*  90 */     return count;
/*     */   }
/*     */   
/*     */   public Object getInputSource()
/*     */   {
/*  95 */     return this._inputStream;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final boolean loadMore()
/*     */     throws IOException
/*     */   {
/* 108 */     this._currInputProcessed += this._inputEnd;
/* 109 */     this._currInputRowStart -= this._inputEnd;
/*     */     
/* 111 */     if (this._inputStream != null) {
/* 112 */       int count = this._inputStream.read(this._inputBuffer, 0, this._inputBuffer.length);
/* 113 */       if (count > 0) {
/* 114 */         this._inputPtr = 0;
/* 115 */         this._inputEnd = count;
/* 116 */         return true;
/*     */       }
/*     */       
/* 119 */       _closeInput();
/*     */       
/* 121 */       if (count == 0) {
/* 122 */         throw new IOException("InputStream.read() returned 0 characters when trying to read " + this._inputBuffer.length + " bytes");
/*     */       }
/*     */     }
/* 125 */     return false;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final boolean _loadToHaveAtLeast(int minAvailable)
/*     */     throws IOException
/*     */   {
/* 138 */     if (this._inputStream == null) {
/* 139 */       return false;
/*     */     }
/*     */     
/* 142 */     int amount = this._inputEnd - this._inputPtr;
/* 143 */     if ((amount > 0) && (this._inputPtr > 0)) {
/* 144 */       this._currInputProcessed += this._inputPtr;
/* 145 */       this._currInputRowStart -= this._inputPtr;
/* 146 */       System.arraycopy(this._inputBuffer, this._inputPtr, this._inputBuffer, 0, amount);
/* 147 */       this._inputEnd = amount;
/*     */     } else {
/* 149 */       this._inputEnd = 0;
/*     */     }
/* 151 */     this._inputPtr = 0;
/* 152 */     while (this._inputEnd < minAvailable) {
/* 153 */       int count = this._inputStream.read(this._inputBuffer, this._inputEnd, this._inputBuffer.length - this._inputEnd);
/* 154 */       if (count < 1)
/*     */       {
/* 156 */         _closeInput();
/*     */         
/* 158 */         if (count == 0) {
/* 159 */           throw new IOException("InputStream.read() returned 0 characters when trying to read " + amount + " bytes");
/*     */         }
/* 161 */         return false;
/*     */       }
/* 163 */       this._inputEnd += count;
/*     */     }
/* 165 */     return true;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected void _closeInput()
/*     */     throws IOException
/*     */   {
/* 175 */     if (this._inputStream != null) {
/* 176 */       if ((this._ioContext.isResourceManaged()) || (isEnabled(JsonParser.Feature.AUTO_CLOSE_SOURCE))) {
/* 177 */         this._inputStream.close();
/*     */       }
/* 179 */       this._inputStream = null;
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected void _releaseBuffers()
/*     */     throws IOException
/*     */   {
/* 192 */     super._releaseBuffers();
/* 193 */     if (this._bufferRecyclable) {
/* 194 */       byte[] buf = this._inputBuffer;
/* 195 */       if (buf != null) {
/* 196 */         this._inputBuffer = null;
/* 197 */         this._ioContext.releaseReadIOBuffer(buf);
/*     */       }
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\impl\StreamBasedParserBase.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */