/*     */ package org.codehaus.jackson.map;
/*     */ 
/*     */ import java.text.DateFormat;
/*     */ import java.util.HashMap;
/*     */ import org.codehaus.jackson.map.annotate.JsonSerialize.Inclusion;
/*     */ import org.codehaus.jackson.map.annotate.JsonSerialize.Typing;
/*     */ import org.codehaus.jackson.map.introspect.Annotated;
/*     */ import org.codehaus.jackson.map.introspect.AnnotatedClass;
/*     */ import org.codehaus.jackson.map.introspect.VisibilityChecker;
/*     */ import org.codehaus.jackson.map.jsontype.SubtypeResolver;
/*     */ import org.codehaus.jackson.map.jsontype.TypeResolverBuilder;
/*     */ import org.codehaus.jackson.map.ser.FilterProvider;
/*     */ import org.codehaus.jackson.map.type.ClassKey;
/*     */ import org.codehaus.jackson.map.type.TypeFactory;
/*     */ import org.codehaus.jackson.map.util.ClassUtil;
/*     */ import org.codehaus.jackson.type.JavaType;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SerializationConfig
/*     */   extends MapperConfig<SerializationConfig>
/*     */ {
/*     */   public static enum Feature
/*     */   {
/*  56 */     USE_ANNOTATIONS(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  75 */     AUTO_DETECT_GETTERS(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  91 */     AUTO_DETECT_IS_GETTERS(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 108 */     AUTO_DETECT_FIELDS(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 118 */     CAN_OVERRIDE_ACCESS_MODIFIERS(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 140 */     WRITE_NULL_PROPERTIES(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 153 */     USE_STATIC_TYPING(false), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 171 */     DEFAULT_VIEW_INCLUSION(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 186 */     WRAP_ROOT_VALUE(false), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 205 */     INDENT_OUTPUT(false), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 219 */     SORT_PROPERTIES_ALPHABETICALLY(false), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 242 */     FAIL_ON_EMPTY_BEANS(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 262 */     WRAP_EXCEPTIONS(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 286 */     CLOSE_CLOSEABLE(false), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 300 */     FLUSH_AFTER_WRITE_VALUE(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 319 */     WRITE_DATES_AS_TIMESTAMPS(true), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 329 */     WRITE_CHAR_ARRAYS_AS_JSON_ARRAYS(false), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 344 */     WRITE_ENUMS_USING_TO_STRING(false), 
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 354 */     WRITE_NULL_MAP_VALUES(true);
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */     final boolean _defaultState;
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */     public static int collectDefaults()
/*     */     {
/* 366 */       int flags = 0;
/* 367 */       for (Feature f : values()) {
/* 368 */         if (f.enabledByDefault()) {
/* 369 */           flags |= f.getMask();
/*     */         }
/*     */       }
/* 372 */       return flags;
/*     */     }
/*     */     
/*     */     private Feature(boolean defaultState) {
/* 376 */       this._defaultState = defaultState;
/*     */     }
/*     */     
/* 379 */     public boolean enabledByDefault() { return this._defaultState; }
/*     */     
/* 381 */     public int getMask() { return 1 << ordinal(); }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 388 */   protected static final int DEFAULT_FEATURE_FLAGS = ;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 396 */   protected int _featureFlags = DEFAULT_FEATURE_FLAGS;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 410 */   protected JsonSerialize.Inclusion _serializationInclusion = null;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected Class<?> _serializationView;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected FilterProvider _filterProvider;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public SerializationConfig(ClassIntrospector<? extends BeanDescription> intr, AnnotationIntrospector annIntr, VisibilityChecker<?> vc, SubtypeResolver subtypeResolver, PropertyNamingStrategy propertyNamingStrategy, TypeFactory typeFactory, HandlerInstantiator handlerInstantiator)
/*     */   {
/* 441 */     super(intr, annIntr, vc, subtypeResolver, propertyNamingStrategy, typeFactory, handlerInstantiator);
/* 442 */     this._filterProvider = null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected SerializationConfig(SerializationConfig src)
/*     */   {
/* 449 */     this(src, src._base);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected SerializationConfig(SerializationConfig src, HashMap<ClassKey, Class<?>> mixins, SubtypeResolver str)
/*     */   {
/* 460 */     this(src, src._base);
/* 461 */     this._mixInAnnotations = mixins;
/* 462 */     this._subtypeResolver = str;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   protected SerializationConfig(SerializationConfig src, MapperConfig.Base base)
/*     */   {
/* 470 */     super(src, base, src._subtypeResolver);
/* 471 */     this._featureFlags = src._featureFlags;
/* 472 */     this._serializationInclusion = src._serializationInclusion;
/* 473 */     this._serializationView = src._serializationView;
/* 474 */     this._filterProvider = src._filterProvider;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   protected SerializationConfig(SerializationConfig src, FilterProvider filters)
/*     */   {
/* 482 */     super(src);
/* 483 */     this._featureFlags = src._featureFlags;
/* 484 */     this._serializationInclusion = src._serializationInclusion;
/* 485 */     this._serializationView = src._serializationView;
/* 486 */     this._filterProvider = filters;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   protected SerializationConfig(SerializationConfig src, Class<?> view)
/*     */   {
/* 494 */     super(src);
/* 495 */     this._featureFlags = src._featureFlags;
/* 496 */     this._serializationInclusion = src._serializationInclusion;
/* 497 */     this._serializationView = view;
/* 498 */     this._filterProvider = src._filterProvider;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public SerializationConfig withClassIntrospector(ClassIntrospector<? extends BeanDescription> ci)
/*     */   {
/* 509 */     return new SerializationConfig(this, this._base.withClassIntrospector(ci));
/*     */   }
/*     */   
/*     */   public SerializationConfig withAnnotationIntrospector(AnnotationIntrospector ai)
/*     */   {
/* 514 */     return new SerializationConfig(this, this._base.withAnnotationIntrospector(ai));
/*     */   }
/*     */   
/*     */   public SerializationConfig withVisibilityChecker(VisibilityChecker<?> vc)
/*     */   {
/* 519 */     return new SerializationConfig(this, this._base.withVisibilityChecker(vc));
/*     */   }
/*     */   
/*     */   public SerializationConfig withTypeResolverBuilder(TypeResolverBuilder<?> trb)
/*     */   {
/* 524 */     return new SerializationConfig(this, this._base.withTypeResolverBuilder(trb));
/*     */   }
/*     */   
/*     */   public SerializationConfig withSubtypeResolver(SubtypeResolver str)
/*     */   {
/* 529 */     SerializationConfig cfg = new SerializationConfig(this);
/* 530 */     cfg._subtypeResolver = str;
/* 531 */     return cfg;
/*     */   }
/*     */   
/*     */   public SerializationConfig withPropertyNamingStrategy(PropertyNamingStrategy pns)
/*     */   {
/* 536 */     return new SerializationConfig(this, this._base.withPropertyNamingStrategy(pns));
/*     */   }
/*     */   
/*     */   public SerializationConfig withTypeFactory(TypeFactory tf)
/*     */   {
/* 541 */     return new SerializationConfig(this, this._base.withTypeFactory(tf));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public SerializationConfig withDateFormat(DateFormat df)
/*     */   {
/* 551 */     SerializationConfig cfg = new SerializationConfig(this, this._base.withDateFormat(df));
/*     */     
/* 553 */     cfg.set(Feature.WRITE_DATES_AS_TIMESTAMPS, df == null);
/* 554 */     return cfg;
/*     */   }
/*     */   
/*     */   public SerializationConfig withHandlerInstantiator(HandlerInstantiator hi)
/*     */   {
/* 559 */     return new SerializationConfig(this, this._base.withHandlerInstantiator(hi));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public SerializationConfig withFilters(FilterProvider filterProvider)
/*     */   {
/* 572 */     return new SerializationConfig(this, filterProvider);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public SerializationConfig withView(Class<?> view)
/*     */   {
/* 579 */     return new SerializationConfig(this, view);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void fromAnnotations(Class<?> cls)
/*     */   {
/* 615 */     AnnotationIntrospector ai = getAnnotationIntrospector();
/* 616 */     AnnotatedClass ac = AnnotatedClass.construct(cls, ai, null);
/* 617 */     this._base = this._base.withVisibilityChecker(ai.findAutoDetectVisibility(ac, getDefaultVisibilityChecker()));
/*     */     
/*     */ 
/*     */ 
/* 621 */     JsonSerialize.Inclusion incl = ai.findSerializationInclusion(ac, null);
/* 622 */     if (incl != this._serializationInclusion) {
/* 623 */       setSerializationInclusion(incl);
/*     */     }
/*     */     
/* 626 */     JsonSerialize.Typing typing = ai.findSerializationTyping(ac);
/* 627 */     if (typing != null) {
/* 628 */       set(Feature.USE_STATIC_TYPING, typing == JsonSerialize.Typing.STATIC);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   public SerializationConfig createUnshared(SubtypeResolver subtypeResolver)
/*     */   {
/* 635 */     HashMap<ClassKey, Class<?>> mixins = this._mixInAnnotations;
/* 636 */     this._mixInAnnotationsShared = true;
/* 637 */     return new SerializationConfig(this, mixins, subtypeResolver);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public AnnotationIntrospector getAnnotationIntrospector()
/*     */   {
/* 646 */     if (isEnabled(Feature.USE_ANNOTATIONS)) {
/* 647 */       return super.getAnnotationIntrospector();
/*     */     }
/* 649 */     return AnnotationIntrospector.nopInstance();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public <T extends BeanDescription> T introspectClassAnnotations(Class<?> cls)
/*     */   {
/* 661 */     return getClassIntrospector().forClassAnnotations(this, cls, this);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public <T extends BeanDescription> T introspectDirectClassAnnotations(Class<?> cls)
/*     */   {
/* 674 */     return getClassIntrospector().forDirectClassAnnotations(this, cls, this);
/*     */   }
/*     */   
/*     */   public boolean isAnnotationProcessingEnabled()
/*     */   {
/* 679 */     return isEnabled(Feature.USE_ANNOTATIONS);
/*     */   }
/*     */   
/*     */   public boolean canOverrideAccessModifiers()
/*     */   {
/* 684 */     return isEnabled(Feature.CAN_OVERRIDE_ACCESS_MODIFIERS);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void enable(Feature f)
/*     */   {
/* 697 */     this._featureFlags |= f.getMask();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public void disable(Feature f)
/*     */   {
/* 704 */     this._featureFlags &= (f.getMask() ^ 0xFFFFFFFF);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public void set(Feature f, boolean state)
/*     */   {
/* 712 */     if (state) {
/* 713 */       enable(f);
/*     */     } else {
/* 715 */       disable(f);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final boolean isEnabled(Feature f)
/*     */   {
/* 725 */     return (this._featureFlags & f.getMask()) != 0;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Class<?> getSerializationView()
/*     */   {
/* 740 */     return this._serializationView;
/*     */   }
/*     */   
/*     */   public JsonSerialize.Inclusion getSerializationInclusion() {
/* 744 */     if (this._serializationInclusion != null) {
/* 745 */       return this._serializationInclusion;
/*     */     }
/* 747 */     return isEnabled(Feature.WRITE_NULL_PROPERTIES) ? JsonSerialize.Inclusion.ALWAYS : JsonSerialize.Inclusion.NON_NULL;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setSerializationInclusion(JsonSerialize.Inclusion props)
/*     */   {
/* 761 */     this._serializationInclusion = props;
/*     */     
/* 763 */     if (props == JsonSerialize.Inclusion.NON_NULL) {
/* 764 */       disable(Feature.WRITE_NULL_PROPERTIES);
/*     */     } else {
/* 766 */       enable(Feature.WRITE_NULL_PROPERTIES);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public FilterProvider getFilterProvider()
/*     */   {
/* 779 */     return this._filterProvider;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public <T extends BeanDescription> T introspect(JavaType type)
/*     */   {
/* 794 */     return getClassIntrospector().forSerialization(this, type, this);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public JsonSerializer<Object> serializerInstance(Annotated annotated, Class<? extends JsonSerializer<?>> serClass)
/*     */   {
/* 806 */     HandlerInstantiator hi = getHandlerInstantiator();
/* 807 */     if (hi != null) {
/* 808 */       JsonSerializer<?> ser = hi.serializerInstance(this, annotated, serClass);
/* 809 */       if (ser != null) {
/* 810 */         return ser;
/*     */       }
/*     */     }
/* 813 */     return (JsonSerializer)ClassUtil.createInstance(serClass, canOverrideAccessModifiers());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @Deprecated
/*     */   public SerializationConfig createUnshared(TypeResolverBuilder<?> typer, VisibilityChecker<?> vc, SubtypeResolver str)
/*     */   {
/* 830 */     return createUnshared(str).withTypeResolverBuilder(typer).withVisibilityChecker(vc);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @Deprecated
/*     */   public final void setDateFormat(DateFormat df)
/*     */   {
/* 844 */     super.setDateFormat(df);
/* 845 */     set(Feature.WRITE_DATES_AS_TIMESTAMPS, df == null);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @Deprecated
/*     */   public void setSerializationView(Class<?> view)
/*     */   {
/* 859 */     this._serializationView = view;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String toString()
/*     */   {
/* 870 */     return "[SerializationConfig: flags=0x" + Integer.toHexString(this._featureFlags) + "]";
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\SerializationConfig.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */