/*     */ package org.codehaus.jackson.map.deser;
/*     */ 
/*     */ import java.util.Collection;
/*     */ import java.util.HashMap;
/*     */ import java.util.HashSet;
/*     */ import java.util.Iterator;
/*     */ import org.codehaus.jackson.map.BeanProperty;
/*     */ import org.codehaus.jackson.map.JsonDeserializer;
/*     */ import org.codehaus.jackson.map.deser.impl.BeanPropertyMap;
/*     */ import org.codehaus.jackson.map.introspect.BasicBeanDescription;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class BeanDeserializerBuilder
/*     */ {
/*     */   protected final BasicBeanDescription _beanDesc;
/*  38 */   protected final HashMap<String, SettableBeanProperty> _properties = new HashMap();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected HashMap<String, SettableBeanProperty> _backRefProperties;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected HashSet<String> _ignorableProps;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected CreatorContainer _creators;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected SettableAnyProperty _anySetter;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected boolean _ignoreAllUnknown;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public BeanDeserializerBuilder(BasicBeanDescription beanDesc)
/*     */   {
/*  78 */     this._beanDesc = beanDesc;
/*     */   }
/*     */   
/*     */   public void setCreators(CreatorContainer creators) {
/*  82 */     this._creators = creators;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public void addOrReplaceProperty(SettableBeanProperty prop, boolean allowOverride)
/*     */   {
/*  90 */     this._properties.put(prop.getName(), prop);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void addProperty(SettableBeanProperty prop)
/*     */   {
/* 100 */     SettableBeanProperty old = (SettableBeanProperty)this._properties.put(prop.getName(), prop);
/* 101 */     if ((old != null) && (old != prop)) {
/* 102 */       throw new IllegalArgumentException("Duplicate property '" + prop.getName() + "' for " + this._beanDesc.getType());
/*     */     }
/*     */   }
/*     */   
/*     */   public void addBackReferenceProperty(String referenceName, SettableBeanProperty prop)
/*     */   {
/* 108 */     if (this._backRefProperties == null) {
/* 109 */       this._backRefProperties = new HashMap(4);
/*     */     }
/* 111 */     this._backRefProperties.put(referenceName, prop);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void addIgnorable(String propName)
/*     */   {
/* 120 */     if (this._ignorableProps == null) {
/* 121 */       this._ignorableProps = new HashSet();
/*     */     }
/* 123 */     this._ignorableProps.add(propName);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Iterator<SettableBeanProperty> getProperties()
/*     */   {
/* 133 */     return this._properties.values().iterator();
/*     */   }
/*     */   
/*     */   public boolean hasProperty(String propertyName) {
/* 137 */     return this._properties.containsKey(propertyName);
/*     */   }
/*     */   
/*     */   public SettableBeanProperty removeProperty(String name)
/*     */   {
/* 142 */     return (SettableBeanProperty)this._properties.remove(name);
/*     */   }
/*     */   
/*     */   public void setAnySetter(SettableAnyProperty s)
/*     */   {
/* 147 */     if ((this._anySetter != null) && (s != null)) {
/* 148 */       throw new IllegalStateException("_anySetter already set to non-null");
/*     */     }
/* 150 */     this._anySetter = s;
/*     */   }
/*     */   
/*     */   public void setIgnoreUnknownProperties(boolean ignore) {
/* 154 */     this._ignoreAllUnknown = ignore;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public JsonDeserializer<?> build(BeanProperty forProperty)
/*     */   {
/* 165 */     BeanPropertyMap propertyMap = new BeanPropertyMap(this._properties.values());
/* 166 */     propertyMap.assignIndexes();
/*     */     
/* 168 */     return new BeanDeserializer(this._beanDesc.getClassInfo(), this._beanDesc.getType(), forProperty, this._creators, propertyMap, this._backRefProperties, this._ignorableProps, this._ignoreAllUnknown, this._anySetter);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\deser\BeanDeserializerBuilder.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */