/*     */ package org.codehaus.jackson.map.introspect;
/*     */ 
/*     */ import java.lang.reflect.Member;
/*     */ import java.lang.reflect.Method;
/*     */ import java.lang.reflect.Type;
/*     */ import org.codehaus.jackson.map.type.TypeBindings;
/*     */ import org.codehaus.jackson.type.JavaType;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class AnnotatedMethod
/*     */   extends AnnotatedWithParams
/*     */ {
/*     */   protected final Method _method;
/*     */   protected Class<?>[] _paramTypes;
/*     */   
/*     */   public AnnotatedMethod(Method method, AnnotationMap classAnn, AnnotationMap[] paramAnnotations)
/*     */   {
/*  25 */     super(classAnn, paramAnnotations);
/*  26 */     this._method = method;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public AnnotatedMethod withMethod(Method m)
/*     */   {
/*  37 */     return new AnnotatedMethod(m, this._annotations, this._paramAnnotations);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Method getAnnotated()
/*     */   {
/*  47 */     return this._method;
/*     */   }
/*     */   
/*  50 */   public int getModifiers() { return this._method.getModifiers(); }
/*     */   
/*     */   public String getName() {
/*  53 */     return this._method.getName();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Type getGenericType()
/*     */   {
/*  62 */     return this._method.getGenericReturnType();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Class<?> getRawType()
/*     */   {
/*  72 */     return this._method.getReturnType();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public JavaType getType(TypeBindings bindings)
/*     */   {
/*  82 */     return getType(bindings, this._method.getTypeParameters());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Class<?> getDeclaringClass()
/*     */   {
/*  92 */     return this._method.getDeclaringClass();
/*     */   }
/*     */   
/*  95 */   public Member getMember() { return this._method; }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public AnnotatedParameter getParameter(int index)
/*     */   {
/* 105 */     return new AnnotatedParameter(this, getParameterType(index), this._paramAnnotations[index]);
/*     */   }
/*     */   
/*     */   public int getParameterCount()
/*     */   {
/* 110 */     return getParameterTypes().length;
/*     */   }
/*     */   
/*     */   public Type[] getParameterTypes() {
/* 114 */     return this._method.getGenericParameterTypes();
/*     */   }
/*     */   
/*     */ 
/*     */   public Class<?> getParameterClass(int index)
/*     */   {
/* 120 */     Class<?>[] types = this._method.getParameterTypes();
/* 121 */     return index >= types.length ? null : types[index];
/*     */   }
/*     */   
/*     */ 
/*     */   public Type getParameterType(int index)
/*     */   {
/* 127 */     Type[] types = this._method.getGenericParameterTypes();
/* 128 */     return index >= types.length ? null : types[index];
/*     */   }
/*     */   
/*     */   public Class<?>[] getParameterClasses()
/*     */   {
/* 133 */     if (this._paramTypes == null) {
/* 134 */       this._paramTypes = this._method.getParameterTypes();
/*     */     }
/* 136 */     return this._paramTypes;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getFullName()
/*     */   {
/* 144 */     return getDeclaringClass().getName() + "#" + getName() + "(" + getParameterCount() + " params)";
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String toString()
/*     */   {
/* 157 */     return "[method " + getName() + ", annotations: " + this._annotations + "]";
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\introspect\AnnotatedMethod.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */