/*     */ package org.codehaus.janino;
/*     */ 
/*     */ import java.io.File;
/*     */ import java.io.IOException;
/*     */ import java.io.PrintStream;
/*     */ import org.apache.tools.ant.taskdefs.Javac;
/*     */ import org.apache.tools.ant.taskdefs.compilers.DefaultCompilerAdapter;
/*     */ import org.apache.tools.ant.types.Path;
/*     */ import org.codehaus.commons.compiler.CompileException;
/*     */ import org.codehaus.commons.compiler.LocatedException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class AntCompilerAdapter
/*     */   extends DefaultCompilerAdapter
/*     */ {
/*     */   public boolean execute()
/*     */   {
/*  76 */     File[] sourceFiles = this.compileList;
/*     */     
/*     */ 
/*  79 */     File destinationDirectory = this.destDir == null ? Compiler.NO_DESTINATION_DIRECTORY : this.destDir;
/*     */     
/*     */ 
/*  82 */     File[] optionalSourcePath = pathToFiles(this.compileSourcepath != null ? this.compileSourcepath : this.src);
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  89 */     File[] classPath = pathToFiles(this.compileClasspath, new File[] { new File(".") });
/*     */     
/*     */ 
/*  92 */     File[] optionalExtDirs = pathToFiles(this.extdirs);
/*     */     
/*     */ 
/*  95 */     File[] optionalBootClassPath = pathToFiles(this.bootclasspath);
/*     */     
/*     */ 
/*  98 */     String optionalCharacterEncoding = this.encoding;
/*     */     
/*     */ 
/* 101 */     boolean verbose = this.verbose;
/*     */     boolean debugSource;
/*     */     boolean debugVars;
/*     */     boolean debugLines;
/* 105 */     boolean debugSource; if (!this.debug) { boolean debugVars;
/* 106 */       boolean debugLines; debugSource = debugLines = debugVars = 0;
/*     */     } else {
/* 108 */       String debugLevel = this.attributes.getDebugLevel();
/* 109 */       boolean debugVars; if (debugLevel == null) {
/* 110 */         boolean debugSource = true;
/* 111 */         boolean debugLines = true;
/* 112 */         debugVars = false;
/*     */       } else {
/* 114 */         debugSource = debugLines = debugVars = 0;
/* 115 */         if (debugLevel.indexOf("source") != -1) debugSource = true;
/* 116 */         if (debugLevel.indexOf("lines") != -1) debugLines = true;
/* 117 */         if (debugLevel.indexOf("vars") != -1) { debugVars = true;
/*     */         }
/*     */       }
/*     */     }
/*     */     try
/*     */     {
/* 123 */       new Compiler(optionalSourcePath, classPath, optionalExtDirs, optionalBootClassPath, destinationDirectory, optionalCharacterEncoding, verbose, debugSource, debugLines, debugVars, Compiler.DEFAULT_WARNING_HANDLE_PATTERNS, false).compile(sourceFiles);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     }
/*     */     catch (CompileException e)
/*     */     {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 138 */       System.out.println(e.getMessage());
/* 139 */       return false;
/*     */     } catch (IOException e) {
/* 141 */       System.out.println(e.getMessage());
/* 142 */       return false;
/*     */     }
/* 144 */     return true;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private static File[] pathToFiles(Path path)
/*     */   {
/* 154 */     if (path == null) { return null;
/*     */     }
/* 156 */     String[] fileNames = path.list();
/* 157 */     File[] files = new File[fileNames.length];
/* 158 */     for (int i = 0; i < fileNames.length; i++) files[i] = new File(fileNames[i]);
/* 159 */     return files;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private static File[] pathToFiles(Path path, File[] defaultValue)
/*     */   {
/* 170 */     if (path == null) return defaultValue;
/* 171 */     return pathToFiles(path);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\AntCompilerAdapter.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */