/*     */ package org.codehaus.janino.util.iterator;
/*     */ 
/*     */ import java.io.File;
/*     */ import java.io.FilenameFilter;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import org.codehaus.janino.JaninoRuntimeException;
/*     */ import org.codehaus.janino.util.Producer;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class DirectoryIterator
/*     */   extends ProducerIterator
/*     */ {
/*     */   public DirectoryIterator(File rootDirectory, FilenameFilter directoryNameFilter, FilenameFilter fileNameFilter)
/*     */   {
/*  60 */     super(new Producer() {
/*     */       private final List stateStack;
/*     */       
/*  63 */       public Object produce() { while (!this.stateStack.isEmpty()) {
/*  64 */           State state = (State)this.stateStack.get(this.stateStack.size() - 1);
/*  65 */           if (state.directories.hasNext()) {
/*  66 */             this.stateStack.add(new State((File)state.directories.next()));
/*     */           } else {
/*  68 */             if (state.files.hasNext()) {
/*  69 */               return (File)state.files.next();
/*     */             }
/*     */             
/*  72 */             this.stateStack.remove(this.stateStack.size() - 1);
/*     */           }
/*     */         }
/*  75 */         return null; }
/*     */       
/*     */       class State { final Iterator directories;
/*     */         final Iterator files;
/*     */         
/*  80 */         State(File dir) { File[] entries = dir.listFiles();
/*  81 */           if (entries == null) {
/*  82 */             throw new JaninoRuntimeException("Directory \"" + dir + "\" could not be read");
/*     */           }
/*  84 */           List directoryList = new ArrayList();
/*  85 */           List fileList = new ArrayList();
/*  86 */           for (int i = 0; i < entries.length; i++) {
/*  87 */             File entry = entries[i];
/*  88 */             if (entry.isDirectory()) {
/*  89 */               if (DirectoryIterator.1.this.val$directoryNameFilter.accept(dir, entry.getName())) directoryList.add(entry);
/*     */             }
/*  91 */             else if ((entry.isFile()) && 
/*  92 */               (DirectoryIterator.1.this.val$fileNameFilter.accept(dir, entry.getName()))) { fileList.add(entry);
/*     */             }
/*     */           }
/*  95 */           this.directories = directoryList.iterator();
/*  96 */           this.files = fileList.iterator();
/*     */         }
/*     */       }
/*     */     });
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private final FilenameFilter val$directoryNameFilter;
/*     */   
/*     */ 
/*     */ 
/*     */   private final FilenameFilter val$fileNameFilter;
/*     */   
/*     */ 
/*     */ 
/*     */   public static Iterator traverseDirectories(File[] rootDirectories, FilenameFilter directoryNameFilter, FilenameFilter fileNameFilter)
/*     */   {
/* 115 */     List result = new ArrayList();
/* 116 */     for (int i = 0; i < rootDirectories.length; i++) {
/* 117 */       result.add(new DirectoryIterator(rootDirectories[i], directoryNameFilter, fileNameFilter));
/*     */     }
/* 119 */     return new MultiDimensionalIterator(result.iterator(), 2);
/*     */   }
/*     */   
/*     */   private static ArrayList newArrayList(Object initialElement) {
/* 123 */     ArrayList result = new ArrayList();
/* 124 */     result.add(initialElement);
/* 125 */     return result;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\util\iterator\DirectoryIterator.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */