package com.jaspersoft.jasperserver.api.engine.common.service;

import com.jaspersoft.jasperserver.api.JasperServerAPI;
import com.jaspersoft.jasperserver.api.common.domain.ExecutionContext;
import com.jaspersoft.jasperserver.api.common.domain.ValidationResult;
import com.jaspersoft.jasperserver.api.engine.common.domain.Request;
import com.jaspersoft.jasperserver.api.engine.common.domain.Result;
import com.jaspersoft.jasperserver.api.metadata.common.domain.InputControlsContainer;
import com.jaspersoft.jasperserver.api.metadata.common.domain.Resource;
import com.jaspersoft.jasperserver.api.metadata.common.domain.ResourceLookup;
import com.jaspersoft.jasperserver.api.metadata.common.domain.ResourceReference;
import com.jaspersoft.jasperserver.api.metadata.jasperreports.domain.CustomDomainMetaData;
import com.jaspersoft.jasperserver.api.metadata.jasperreports.domain.CustomReportDataSource;
import com.jaspersoft.jasperserver.api.metadata.jasperreports.domain.ReportDataSource;
import com.jaspersoft.jasperserver.api.metadata.jasperreports.domain.ReportUnit;
import com.jaspersoft.jasperserver.api.metadata.jasperreports.service.ReportDataSourceService;
import java.util.List;
import java.util.Map;
import java.util.Set;
import net.sf.jasperreports.engine.JasperReport;
import org.apache.commons.collections.OrderedMap;

@JasperServerAPI
public abstract interface EngineService
{
  public static final String JS_DATASOURCE_URI = "datasourceURI";
  
  public abstract Result execute(ExecutionContext paramExecutionContext, Request paramRequest);
  
  public abstract Resource[] getResources(ResourceReference paramResourceReference);
  
  public abstract ValidationResult validate(ExecutionContext paramExecutionContext, ReportUnit paramReportUnit);
  
  public abstract JasperReport getMainJasperReport(ExecutionContext paramExecutionContext, String paramString);
  
  public abstract JasperReport getMainJasperReport(ExecutionContext paramExecutionContext, InputControlsContainer paramInputControlsContainer);
  
  public abstract void release();
  
  public abstract void clearCaches(Class paramClass, String paramString);
  
  public abstract ReportDataSourceService createDataSourceService(ReportDataSource paramReportDataSource);
  
  public abstract void exportToPdf(ExecutionContext paramExecutionContext, String paramString, Map paramMap);
  
  public abstract OrderedMap executeQuery(ExecutionContext paramExecutionContext, ResourceReference paramResourceReference1, String paramString, String[] paramArrayOfString, ResourceReference paramResourceReference2);
  
  public abstract OrderedMap executeQuery(ExecutionContext paramExecutionContext, ResourceReference paramResourceReference1, String paramString, String[] paramArrayOfString, ResourceReference paramResourceReference2, Map paramMap);
  
  public abstract OrderedMap executeQuery(ExecutionContext paramExecutionContext, ResourceReference paramResourceReference1, String paramString, String[] paramArrayOfString, ResourceReference paramResourceReference2, Map paramMap, Map<String, Class<?>> paramMap1, boolean paramBoolean);
  
  public abstract ResourceLookup[] getDataSources(ExecutionContext paramExecutionContext, String paramString);
  
  public abstract Set getDataSourceTypes(ExecutionContext paramExecutionContext, String paramString);
  
  public abstract String getQueryLanguage(ExecutionContext paramExecutionContext, ResourceReference paramResourceReference);
  
  @Deprecated
  public abstract Map getReportInputControlDefaultValues(ExecutionContext paramExecutionContext, String paramString, Map paramMap);
  
  public abstract ReportInputControlsInformation getReportInputControlsInformation(ExecutionContext paramExecutionContext, String paramString, Map paramMap);
  
  public abstract ReportInputControlsInformation getReportInputControlsInformation(ExecutionContext paramExecutionContext, InputControlsContainer paramInputControlsContainer, Map paramMap);
  
  public abstract ExecutionContext getRuntimeExecutionContext();
  
  public abstract boolean cancelExecution(String paramString);
  
  public abstract List<ReportExecutionStatusInformation> getReportExecutionStatusList();
  
  public abstract List<ReportExecutionStatusInformation> getReportExecutionStatusList(ReportExecutionStatusSearchCriteria paramReportExecutionStatusSearchCriteria);
  
  public abstract List<ReportExecutionStatusInformation> getSchedulerReportExecutionStatusList();
  
  public abstract List<ReportExecutionStatusInformation> getSchedulerReportExecutionStatusList(SchedulerReportExecutionStatusSearchCriteria paramSchedulerReportExecutionStatusSearchCriteria);
  
  public abstract CustomDomainMetaData getMetaDataFromConnector(CustomReportDataSource paramCustomReportDataSource)
    throws Exception;
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-api-engine-6.0.jar!\com\jaspersoft\jasperserver\api\engine\common\service\EngineService.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */