/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.authority.users;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.dto.authority.UsersListWrapper;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*    */ import javax.ws.rs.core.MultivaluedHashMap;
/*    */ import javax.ws.rs.core.MultivaluedMap;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class BatchUsersRequestAdapter
/*    */   extends AbstractAdapter
/*    */ {
/*    */   private MultivaluedMap<String, String> params;
/*    */   private final String uri;
/*    */   
/*    */   public BatchUsersRequestAdapter(SessionStorage sessionStorage, String organizationId)
/*    */   {
/* 41 */     super(sessionStorage);
/* 42 */     this.params = new MultivaluedHashMap();
/* 43 */     if (organizationId != null) {
/* 44 */       this.uri = ("/organizations/" + organizationId + "/users");
/*    */     } else {
/* 46 */       this.uri = "/users";
/*    */     }
/*    */   }
/*    */   
/*    */   public BatchUsersRequestAdapter param(UsersParameter userParam, String value) {
/* 51 */     this.params.add(userParam.getParamName(), value);
/* 52 */     return this;
/*    */   }
/*    */   
/*    */   public OperationResult<UsersListWrapper> get() {
/* 56 */     JerseyRequest<UsersListWrapper> request = JerseyRequest.buildRequest(this.sessionStorage, UsersListWrapper.class, new String[] { this.uri }, new DefaultErrorHandler());
/*    */     
/* 58 */     request.addParams(this.params);
/* 59 */     return request.get();
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncGet(final Callback<OperationResult<UsersListWrapper>, R> callback) {
/* 63 */     final JerseyRequest<UsersListWrapper> request = JerseyRequest.buildRequest(this.sessionStorage, UsersListWrapper.class, new String[] { this.uri }, new DefaultErrorHandler());
/* 64 */     request.addParams(this.params);
/* 65 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 68 */         callback.execute(request.get());
/*    */       }
/* 70 */     });
/* 71 */     ThreadPoolUtil.runAsynchronously(task);
/* 72 */     return task;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\authority\users\BatchUsersRequestAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */