/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.importexport.importservice;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestBuilder;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.dto.importexport.StateDto;
/*    */ import java.io.File;
/*    */ import java.io.InputStream;
/*    */ import javax.ws.rs.core.MultivaluedHashMap;
/*    */ import javax.ws.rs.core.MultivaluedMap;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class ImportTaskRequestAdapter
/*    */   extends AbstractAdapter
/*    */ {
/*    */   private final MultivaluedMap<String, String> params;
/*    */   
/*    */   public ImportTaskRequestAdapter(SessionStorage sessionStorage)
/*    */   {
/* 46 */     super(sessionStorage);
/* 47 */     this.params = new MultivaluedHashMap();
/*    */   }
/*    */   
/*    */   public ImportTaskRequestAdapter parameter(ImportParameter parameter, boolean value) {
/* 51 */     this.params.add(parameter.getParamName(), Boolean.toString(value));
/* 52 */     return this;
/*    */   }
/*    */   
/*    */   public OperationResult<StateDto> create(File zipArchive) {
/* 56 */     return createImport(zipArchive);
/*    */   }
/*    */   
/*    */   public OperationResult<StateDto> create(InputStream zipArchive) {
/* 60 */     return createImport(zipArchive);
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncCreate(File zipArchive, Callback<OperationResult<StateDto>, R> callback) {
/* 64 */     return asyncCreateImport(zipArchive, callback);
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncCreate(InputStream zipArchive, Callback<OperationResult<StateDto>, R> callback) {
/* 68 */     return asyncCreateImport(zipArchive, callback);
/*    */   }
/*    */   
/*    */   private OperationResult<StateDto> createImport(Object zipArchive) {
/* 72 */     JerseyRequest<StateDto> request = JerseyRequest.buildRequest(this.sessionStorage, StateDto.class, new String[] { "/import" }, new DefaultErrorHandler());
/* 73 */     request.setContentType("application/zip").addParams(this.params);
/* 74 */     return request.post(zipArchive);
/*    */   }
/*    */   
/*    */   private <R> RequestExecution asyncCreateImport(final Object zipArchive, final Callback<OperationResult<StateDto>, R> callback) {
/* 78 */     final JerseyRequest<StateDto> request = JerseyRequest.buildRequest(this.sessionStorage, StateDto.class, new String[] { "/import" });
/* 79 */     request.setContentType("application/zip").addParams(this.params);
/* 80 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 83 */         callback.execute(request.post(zipArchive));
/*    */       }
/*    */       
/* 86 */     });
/* 87 */     ThreadPoolUtil.runAsynchronously(task);
/* 88 */     return task;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\importexport\importservice\ImportTaskRequestAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */