/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.reporting;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.dto.reports.ReportExecutionDescriptor;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.dto.reports.ReportExecutionRequest;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class ReportingService
/*    */   extends AbstractAdapter
/*    */ {
/*    */   public ReportingService(SessionStorage sessionStorage)
/*    */   {
/* 35 */     super(sessionStorage);
/*    */   }
/*    */   
/*    */   public OperationResult<ReportExecutionDescriptor> newReportExecutionRequest(ReportExecutionRequest request) {
/* 39 */     return JerseyRequest.buildRequest(this.sessionStorage, ReportExecutionDescriptor.class, new String[] { "/reportExecutions" }).post(request);
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncNewReportExecutionRequest(final ReportExecutionRequest reportExecutionRequest, final Callback<OperationResult<ReportExecutionDescriptor>, R> callback)
/*    */   {
/* 44 */     final JerseyRequest<ReportExecutionDescriptor> request = JerseyRequest.buildRequest(this.sessionStorage, ReportExecutionDescriptor.class, new String[] { "/reportExecutions" });
/* 45 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 48 */         callback.execute(request.post(reportExecutionRequest));
/*    */       }
/* 50 */     });
/* 51 */     ThreadPoolUtil.runAsynchronously(task);
/* 52 */     return task;
/*    */   }
/*    */   
/*    */   public ReportExecutionRequestBuilder reportExecutionRequest(String requestId) {
/* 56 */     return new ReportExecutionRequestBuilder(this.sessionStorage, requestId);
/*    */   }
/*    */   
/*    */   public ReportsAndJobsSearchAdapter runningReportsAndJobs() {
/* 60 */     return new ReportsAndJobsSearchAdapter(this.sessionStorage);
/*    */   }
/*    */   
/*    */   public ReportsAdapter report(String reportUnitUri) {
/* 64 */     return new ReportsAdapter(this.sessionStorage, reportUnitUri);
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\reporting\ReportingService.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */