/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.reporting.reportparameters;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.dto.reports.ReportParameters;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.dto.reports.inputcontrols.InputControlStateListWrapper;
/*    */ import javax.ws.rs.core.MultivaluedMap;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class ReportParametersValuesAdapter
/*    */   extends AbstractAdapter
/*    */ {
/*    */   protected final String reportUnitUri;
/*    */   protected MultivaluedMap<String, String> params;
/*    */   private String idsPathSegment;
/*    */   
/*    */   public ReportParametersValuesAdapter(SessionStorage sessionStorage, String reportUnitUri)
/*    */   {
/* 43 */     super(sessionStorage);
/* 44 */     this.reportUnitUri = reportUnitUri;
/*    */   }
/*    */   
/*    */   public ReportParametersValuesAdapter(SessionStorage sessionStorage, String reportUnitUri, String idsPathSegment, MultivaluedMap<String, String> params)
/*    */   {
/* 49 */     this(sessionStorage, reportUnitUri);
/* 50 */     this.idsPathSegment = idsPathSegment;
/* 51 */     this.params = params;
/*    */   }
/*    */   
/*    */   public OperationResult<InputControlStateListWrapper> get() {
/* 55 */     JerseyRequest<InputControlStateListWrapper> request = prepareRequest();
/* 56 */     return request.post(ReportParametersUtils.toReportParameters(this.params));
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncGet(final Callback<OperationResult<InputControlStateListWrapper>, R> callback) {
/* 60 */     final JerseyRequest<InputControlStateListWrapper> request = prepareRequest();
/* 61 */     final ReportParameters reportParameters = ReportParametersUtils.toReportParameters(this.params);
/*    */     
/* 63 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 66 */         callback.execute(request.post(reportParameters));
/*    */       }
/*    */       
/* 69 */     });
/* 70 */     ThreadPoolUtil.runAsynchronously(task);
/* 71 */     return task;
/*    */   }
/*    */   
/*    */   private JerseyRequest<InputControlStateListWrapper> prepareRequest() {
/* 75 */     JerseyRequest<InputControlStateListWrapper> request = JerseyRequest.buildRequest(this.sessionStorage, InputControlStateListWrapper.class, new String[] { "/reports", this.reportUnitUri, "/inputControls" }, new DefaultErrorHandler());
/*    */     
/*    */ 
/* 78 */     if (this.idsPathSegment != null) {
/* 79 */       request.setPath(this.idsPathSegment);
/*    */     }
/* 81 */     request.setPath("values");
/* 82 */     request.setContentType("application/xml");
/* 83 */     request.setAccept("application/xml");
/*    */     
/* 85 */     return request;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\reporting\reportparameters\ReportParametersValuesAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */