/*    */ package com.netapp.asup.client.serialize;
/*    */ 
/*    */ import com.netapp.asup.common.AsupLogger;
/*    */ import com.netapp.asup.exception.ARMAException;
/*    */ 
/*    */ public class RequestIdentifier
/*    */ {
/*  8 */   public static AsupLogger logger = AsupLogger.getLogger(RequestIdentifier.class);
/*    */   private final String clusterId;
/*    */   private final String systemId;
/*    */   private final String sysSerNo;
/*    */   private final String bizKey;
/*    */   private final IdType type;
/*    */   
/*    */   public static enum IdType
/*    */   {
/* 17 */     CLUSTER_ID("clusterId"),  SYSID_SYS_SER_NO("sysIdSysSerNo"),  BIZ_KEY("bizKey");
/*    */     
/*    */     private final String idType;
/*    */     
/*    */     private IdType(String type)
/*    */     {
/* 23 */       this.idType = type;
/*    */     }
/*    */     
/*    */     public String getIdType() {
/* 27 */       return this.idType;
/*    */     }
/*    */   }
/*    */   
/*    */ 
/*    */   public RequestIdentifier(IdType type, String... identifiers)
/*    */     throws ARMAException
/*    */   {
/* 35 */     switch (type) {
/*    */     case CLUSTER_ID: 
/* 37 */       this.clusterId = identifiers[0];
/* 38 */       this.type = type;
/* 39 */       this.systemId = null;
/* 40 */       this.sysSerNo = null;
/* 41 */       this.bizKey = null;
/* 42 */       break;
/*    */     
/*    */     case BIZ_KEY: 
/* 45 */       this.bizKey = identifiers[0];
/* 46 */       this.type = type;
/* 47 */       this.clusterId = null;
/* 48 */       this.systemId = null;
/* 49 */       this.sysSerNo = null;
/* 50 */       break;
/*    */     
/*    */     case SYSID_SYS_SER_NO: 
/* 53 */       this.systemId = identifiers[0];
/* 54 */       this.sysSerNo = identifiers[1];
/* 55 */       this.type = type;
/* 56 */       this.bizKey = null;
/* 57 */       this.clusterId = null;
/* 58 */       break;
/*    */     
/*    */     default: 
/* 61 */       this.clusterId = null;
/* 62 */       this.type = null;
/* 63 */       this.bizKey = null;
/* 64 */       this.systemId = null;
/* 65 */       this.sysSerNo = null;
/* 66 */       throw new ARMAException(logger, "-9999", "Request identifier type " + type.getIdType() + " not supported.");
/*    */     }
/*    */     
/*    */   }
/*    */   
/*    */ 
/*    */   public String getClusterId()
/*    */   {
/* 74 */     return this.clusterId;
/*    */   }
/*    */   
/*    */   public String getSystemId() {
/* 78 */     return this.systemId;
/*    */   }
/*    */   
/*    */   public String getSysSerNo() {
/* 82 */     return this.sysSerNo;
/*    */   }
/*    */   
/*    */   public String getBizKey() {
/* 86 */     return this.bizKey;
/*    */   }
/*    */   
/*    */   public IdType getType() {
/* 90 */     return this.type;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\client\serialize\RequestIdentifier.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */