/*    */ package com.netapp.asup.data.function.handler;
/*    */ 
/*    */ import com.netapp.asup.data.function.FunctionOutputHandler;
/*    */ import java.io.IOException;
/*    */ import java.io.InputStream;
/*    */ import java.util.HashMap;
/*    */ import java.util.Map;
/*    */ import java.util.Map.Entry;
/*    */ import org.apache.avro.Schema;
/*    */ import org.apache.avro.Schema.Parser;
/*    */ import org.apache.avro.generic.GenericData.Record;
/*    */ import org.apache.avro.generic.GenericRecord;
/*    */ import org.apache.avro.util.Utf8;
/*    */ 
/*    */ 
/*    */ 
/*    */ public class MapOutputHandler
/*    */   implements FunctionOutputHandler<Map<String, String>>
/*    */ {
/*    */   private static final String FIELD = "field";
/*    */   private static final String SCHEMA_PATH = "com/netapp/asup/data/function/schema/MapFunctionOutput";
/*    */   
/*    */   public Map<String, String> handleOutput(GenericRecord output)
/*    */   {
/* 25 */     Map<Utf8, Utf8> object = (Map)output.get("field");
/* 26 */     Map<String, String> map = new HashMap();
/* 27 */     for (Map.Entry<Utf8, Utf8> entry : object.entrySet()) {
/* 28 */       map.put(((Utf8)entry.getKey()).toString(), ((Utf8)entry.getValue()).toString());
/*    */     }
/* 30 */     return map;
/*    */   }
/*    */   
/*    */ 
/*    */   public GenericRecord handleOutput(Map<String, String> output)
/*    */   {
/* 36 */     InputStream stream = ClassLoader.getSystemResourceAsStream("com/netapp/asup/data/function/schema/MapFunctionOutput");
/* 37 */     Schema.Parser parser = new Schema.Parser();
/*    */     try {
/* 39 */       Schema schema = parser.parse(stream);
/* 40 */       GenericRecord record = new GenericData.Record(schema);
/* 41 */       Map<Utf8, Utf8> object = new HashMap();
/* 42 */       for (String key : output.keySet()) {
/* 43 */         object.put(new Utf8(key), new Utf8((String)output.get(key)));
/*    */       }
/* 45 */       record.put("field", object);
/* 46 */       return record;
/*    */     } catch (IOException e) {
/* 48 */       throw new IllegalArgumentException("Unable to parse the schema file:com/netapp/asup/data/function/schema/MapFunctionOutput");
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\function\handler\MapOutputHandler.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */