/*    */ package com.netapp.asup.data.objects;
/*    */ 
/*    */ import com.netapp.asup.client.arma.ARMAFilter;
/*    */ import com.netapp.asupdata.client.ARMA.ARMAFilterImpl;
/*    */ import com.netapp.asupdata.client.ARMA.ARMAObjectImpl;
/*    */ import java.util.Map;
/*    */ import java.util.TreeMap;
/*    */ 
/*    */ 
/*    */ public class Filter
/*    */ {
/*    */   private final Identifier id;
/*    */   
/*    */   public Filter(Identifier id)
/*    */   {
/* 16 */     this.id = id;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/* 21 */   private Map<String, ARMAFilter> graphFilter = new TreeMap();
/*    */   
/*    */   public Identifier setFilterToIdentifier() {
/* 24 */     Map<String, Map<String, String>> filterMap = getAllFilters();
/* 25 */     this.id.setFilter(filterMap);
/* 26 */     return this.id;
/*    */   }
/*    */   
/*    */   public Map<String, Map<String, String>> getAllFilters()
/*    */   {
/* 31 */     Map<String, Map<String, String>> allFilters = new TreeMap();
/* 32 */     Map<String, String> filterForObject = null;
/* 33 */     for (String objectName : this.graphFilter.keySet())
/*    */     {
/*    */ 
/*    */ 
/* 37 */       filterForObject = ((ARMAFilter)this.graphFilter.get(objectName)).getAllFilterForObject();
/*    */       
/* 39 */       if (0 < filterForObject.size()) {
/* 40 */         allFilters.put(objectName, filterForObject);
/*    */       }
/*    */     }
/* 43 */     return allFilters;
/*    */   }
/*    */   
/*    */   public ARMAFilter getFilter(ARMAObjectImpl object) {
/* 47 */     ARMAFilterImpl armaFilter = (ARMAFilterImpl)this.graphFilter.get(object.getObjectName().toUpperCase());
/*    */     
/* 49 */     if (null == armaFilter) {
/* 50 */       armaFilter = new ARMAFilterImpl(object);
/* 51 */       this.graphFilter.put(object.getObjectName().toUpperCase(), armaFilter);
/*    */     }
/* 53 */     return armaFilter;
/*    */   }
/*    */   
/*    */   public boolean clearFilters() {
/* 57 */     boolean isFilterRemoved = false;
/*    */     
/* 59 */     boolean isFilterRemovedForObject = false;
/*    */     
/* 61 */     for (ARMAFilter filter : this.graphFilter.values()) {
/* 62 */       isFilterRemovedForObject = filter.removeAllFilterForObject();
/*    */       
/*    */ 
/* 65 */       if ((false == isFilterRemoved) && (isFilterRemovedForObject)) {
/* 66 */         isFilterRemoved = isFilterRemovedForObject;
/*    */       }
/*    */     }
/*    */     
/* 70 */     this.graphFilter.clear();
/* 71 */     return isFilterRemoved;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\objects\Filter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */