package com.netapp.asup.data.store;

import com.netapp.asup.adapter.Adapter;
import com.netapp.asup.avro.AvroReader;
import com.netapp.asup.cache.server.AsupGenericCache;
import com.netapp.asup.data.function.FunctionRegistry;
import com.netapp.asup.data.pojo.ARMAPOJORegistry;
import com.netapp.asup.data.schema.SchemaHelper;
import com.netapp.asup.exception.ARMAConfigurationException;
import com.netapp.asup.metamodel.MetaModelFactory;
import com.netapp.asupdata.client.ARMA.ResultInitializer;
import java.io.IOException;
import org.apache.avro.Schema;

public abstract interface StoreContainer
{
  public abstract StoreContainer initializeContainer()
    throws ARMAConfigurationException;
  
  public abstract void destroyContainer();
  
  public abstract DataStore getStore();
  
  public abstract Adapter getAdapter();
  
  public abstract AsupGenericCache<String, Object> getCache();
  
  public abstract MetaModelFactory getMetaModelprovider();
  
  public abstract AvroReader getAvroReader();
  
  public abstract SchemaHelper getSchemaHelper();
  
  public abstract ResultInitializer getResultInitializer();
  
  public abstract FunctionRegistry getFunctionRegistry();
  
  public abstract ARMAPOJORegistry getPOJORegistry();
  
  public abstract void clearCache();
  
  public abstract String getCacheStats();
  
  public abstract String getMode();
  
  public abstract void removeServer(String paramString)
    throws Exception;
  
  public abstract Schema getSchemaFromHDFS(String paramString)
    throws IOException;
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\store\StoreContainer.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */