/*    */ package com.sun.xml.bind.v2.model.impl;
/*    */ 
/*    */ import com.sun.xml.bind.v2.model.annotation.AnnotationReader;
/*    */ import com.sun.xml.bind.v2.model.annotation.Locatable;
/*    */ import com.sun.xml.bind.v2.model.nav.Navigator;
/*    */ import com.sun.xml.bind.v2.runtime.Location;
/*    */ import java.beans.Introspector;
/*    */ import java.lang.annotation.Annotation;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ class GetterSetterPropertySeed<TypeT, ClassDeclT, FieldT, MethodT>
/*    */   implements PropertySeed<TypeT, ClassDeclT, FieldT, MethodT>
/*    */ {
/*    */   protected final MethodT getter;
/*    */   protected final MethodT setter;
/*    */   private ClassInfoImpl<TypeT, ClassDeclT, FieldT, MethodT> parent;
/*    */   
/*    */   GetterSetterPropertySeed(ClassInfoImpl<TypeT, ClassDeclT, FieldT, MethodT> parent, MethodT getter, MethodT setter)
/*    */   {
/* 24 */     this.parent = parent;
/* 25 */     this.getter = getter;
/* 26 */     this.setter = setter;
/*    */     
/* 28 */     if ((getter == null) && (setter == null))
/* 29 */       throw new IllegalArgumentException();
/*    */   }
/*    */   
/*    */   public TypeT getRawType() {
/* 33 */     if (this.getter != null) {
/* 34 */       return (TypeT)this.parent.nav().getReturnType(this.getter);
/*    */     }
/* 36 */     return (TypeT)this.parent.nav().getMethodParameters(this.setter)[0];
/*    */   }
/*    */   
/*    */   public <A extends Annotation> A readAnnotation(Class<A> annotation) {
/* 40 */     return this.parent.reader().getMethodAnnotation(annotation, this.getter, this.setter, this);
/*    */   }
/*    */   
/*    */   public boolean hasAnnotation(Class<? extends Annotation> annotationType) {
/* 44 */     return this.parent.reader().hasMethodAnnotation(annotationType, getName(), this.getter, this.setter, this);
/*    */   }
/*    */   
/*    */   public String getName() {
/* 48 */     if (this.getter != null) {
/* 49 */       return getName(this.getter);
/*    */     }
/* 51 */     return getName(this.setter);
/*    */   }
/*    */   
/*    */   private String getName(MethodT m) {
/* 55 */     String seed = this.parent.nav().getMethodName(m);
/* 56 */     String lseed = seed.toLowerCase();
/* 57 */     if ((lseed.startsWith("get")) || (lseed.startsWith("set")))
/* 58 */       return camelize(seed.substring(3));
/* 59 */     if (lseed.startsWith("is"))
/* 60 */       return camelize(seed.substring(2));
/* 61 */     return seed;
/*    */   }
/*    */   
/*    */   private static String camelize(String s)
/*    */   {
/* 66 */     return Introspector.decapitalize(s);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public Locatable getUpstream()
/*    */   {
/* 73 */     return this.parent;
/*    */   }
/*    */   
/*    */   public Location getLocation() {
/* 77 */     if (this.getter != null) {
/* 78 */       return this.parent.nav().getMethodLocation(this.getter);
/*    */     }
/* 80 */     return this.parent.nav().getMethodLocation(this.setter);
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\impl\GetterSetterPropertySeed.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */