/*    */ package com.sun.xml.bind.v2.runtime;
/*    */ 
/*    */ import com.sun.xml.bind.v2.model.core.ErrorHandler;
/*    */ import java.util.ArrayList;
/*    */ import java.util.Collections;
/*    */ import java.util.List;
/*    */ import javax.xml.bind.JAXBException;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class IllegalAnnotationsException
/*    */   extends JAXBException
/*    */ {
/*    */   private final List<IllegalAnnotationException> errors;
/*    */   private static final long serialVersionUID = 1L;
/*    */   
/*    */   public IllegalAnnotationsException(List<IllegalAnnotationException> errors)
/*    */   {
/* 28 */     super(errors.size() + " counts of IllegalAnnotationExceptions");
/* 29 */     assert (!errors.isEmpty()) : "there must be at least one error";
/* 30 */     this.errors = Collections.unmodifiableList(new ArrayList(errors));
/*    */   }
/*    */   
/*    */   public String toString() {
/* 34 */     StringBuilder sb = new StringBuilder(super.toString());
/* 35 */     sb.append('\n');
/*    */     
/* 37 */     for (IllegalAnnotationException error : this.errors) {
/* 38 */       sb.append(error.toString()).append('\n');
/*    */     }
/* 40 */     return sb.toString();
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public List<IllegalAnnotationException> getErrors()
/*    */   {
/* 51 */     return this.errors;
/*    */   }
/*    */   
/*    */   public static class Builder implements ErrorHandler {
/* 55 */     private final List<IllegalAnnotationException> list = new ArrayList();
/*    */     
/* 57 */     public void error(IllegalAnnotationException e) { this.list.add(e); }
/*    */     
/*    */ 
/*    */ 
/*    */     public void check()
/*    */       throws IllegalAnnotationsException
/*    */     {
/* 64 */       if (this.list.isEmpty())
/* 65 */         return;
/* 66 */       throw new IllegalAnnotationsException(this.list);
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\IllegalAnnotationsException.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */