/*    */ package com.sun.xml.bind.v2.runtime;
/*    */ 
/*    */ import com.sun.xml.bind.api.AccessorException;
/*    */ import java.io.IOException;
/*    */ import javax.xml.namespace.QName;
/*    */ import javax.xml.stream.XMLStreamException;
/*    */ import org.xml.sax.SAXException;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class SchemaTypeTransducer<V>
/*    */   extends FilterTransducer<V>
/*    */ {
/*    */   private final QName schemaType;
/*    */   
/*    */   public SchemaTypeTransducer(Transducer<V> core, QName schemaType)
/*    */   {
/* 28 */     super(core);
/* 29 */     this.schemaType = schemaType;
/*    */   }
/*    */   
/*    */   public CharSequence print(V o) throws AccessorException
/*    */   {
/* 34 */     XMLSerializer w = XMLSerializer.getInstance();
/* 35 */     QName old = w.setSchemaType(this.schemaType);
/*    */     try {
/* 37 */       return this.core.print(o);
/*    */     } finally {
/* 39 */       w.setSchemaType(old);
/*    */     }
/*    */   }
/*    */   
/*    */   public void writeText(XMLSerializer w, V o, String fieldName) throws IOException, SAXException, XMLStreamException, AccessorException
/*    */   {
/* 45 */     QName old = w.setSchemaType(this.schemaType);
/*    */     try {
/* 47 */       this.core.writeText(w, o, fieldName);
/*    */     } finally {
/* 49 */       w.setSchemaType(old);
/*    */     }
/*    */   }
/*    */   
/*    */   public void writeLeafElement(XMLSerializer w, Name tagName, V o, String fieldName) throws IOException, SAXException, XMLStreamException, AccessorException
/*    */   {
/* 55 */     QName old = w.setSchemaType(this.schemaType);
/*    */     try {
/* 57 */       this.core.writeLeafElement(w, tagName, o, fieldName);
/*    */     } finally {
/* 59 */       w.setSchemaType(old);
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\SchemaTypeTransducer.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */