/*    */ package com.sun.xml.bind.v2.runtime.reflect;
/*    */ 
/*    */ import com.sun.xml.bind.api.AccessorException;
/*    */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*    */ import java.util.Map;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ final class PrimitiveArrayListerDouble<BeanT>
/*    */   extends Lister<BeanT, double[], Double, DoubleArrayPack>
/*    */ {
/*    */   static void register()
/*    */   {
/* 19 */     Lister.primitiveArrayListers.put(Double.TYPE, new PrimitiveArrayListerDouble());
/*    */   }
/*    */   
/*    */   public ListIterator<Double> iterator(final double[] objects, XMLSerializer context) {
/* 23 */     new ListIterator() {
/* 24 */       int idx = 0;
/*    */       
/* 26 */       public boolean hasNext() { return this.idx < objects.length; }
/*    */       
/*    */       public Double next()
/*    */       {
/* 30 */         return Double.valueOf(objects[(this.idx++)]);
/*    */       }
/*    */     };
/*    */   }
/*    */   
/*    */   public DoubleArrayPack startPacking(BeanT current, Accessor<BeanT, double[]> acc) {
/* 36 */     return new DoubleArrayPack();
/*    */   }
/*    */   
/*    */   public void addToPack(DoubleArrayPack objects, Double o) {
/* 40 */     objects.add(o);
/*    */   }
/*    */   
/*    */   public void endPacking(DoubleArrayPack pack, BeanT bean, Accessor<BeanT, double[]> acc) throws AccessorException {
/* 44 */     acc.set(bean, pack.build());
/*    */   }
/*    */   
/*    */   public void reset(BeanT o, Accessor<BeanT, double[]> acc) throws AccessorException {
/* 48 */     acc.set(o, new double[0]);
/*    */   }
/*    */   
/*    */   static final class DoubleArrayPack {
/* 52 */     double[] buf = new double[16];
/*    */     int size;
/*    */     
/*    */     void add(Double b) {
/* 56 */       if (this.buf.length == this.size)
/*    */       {
/* 58 */         double[] nb = new double[this.buf.length * 2];
/* 59 */         System.arraycopy(this.buf, 0, nb, 0, this.buf.length);
/* 60 */         this.buf = nb;
/*    */       }
/* 62 */       this.buf[(this.size++)] = b.doubleValue();
/*    */     }
/*    */     
/*    */     double[] build() {
/* 66 */       if (this.buf.length == this.size)
/*    */       {
/* 68 */         return this.buf;
/*    */       }
/* 70 */       double[] r = new double[this.size];
/* 71 */       System.arraycopy(this.buf, 0, r, 0, this.size);
/* 72 */       return r;
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\reflect\PrimitiveArrayListerDouble.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */