/*    */ package com.sun.xml.bind.v2.runtime.reflect;
/*    */ 
/*    */ import com.sun.xml.bind.api.AccessorException;
/*    */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*    */ import java.util.Map;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ final class PrimitiveArrayListerShort<BeanT>
/*    */   extends Lister<BeanT, short[], Short, ShortArrayPack>
/*    */ {
/*    */   static void register()
/*    */   {
/* 19 */     Lister.primitiveArrayListers.put(Short.TYPE, new PrimitiveArrayListerShort());
/*    */   }
/*    */   
/*    */   public ListIterator<Short> iterator(final short[] objects, XMLSerializer context) {
/* 23 */     new ListIterator() {
/* 24 */       int idx = 0;
/*    */       
/* 26 */       public boolean hasNext() { return this.idx < objects.length; }
/*    */       
/*    */       public Short next()
/*    */       {
/* 30 */         return Short.valueOf(objects[(this.idx++)]);
/*    */       }
/*    */     };
/*    */   }
/*    */   
/*    */   public ShortArrayPack startPacking(BeanT current, Accessor<BeanT, short[]> acc) {
/* 36 */     return new ShortArrayPack();
/*    */   }
/*    */   
/*    */   public void addToPack(ShortArrayPack objects, Short o) {
/* 40 */     objects.add(o);
/*    */   }
/*    */   
/*    */   public void endPacking(ShortArrayPack pack, BeanT bean, Accessor<BeanT, short[]> acc) throws AccessorException {
/* 44 */     acc.set(bean, pack.build());
/*    */   }
/*    */   
/*    */   public void reset(BeanT o, Accessor<BeanT, short[]> acc) throws AccessorException {
/* 48 */     acc.set(o, new short[0]);
/*    */   }
/*    */   
/*    */   static final class ShortArrayPack {
/* 52 */     short[] buf = new short[16];
/*    */     int size;
/*    */     
/*    */     void add(Short b) {
/* 56 */       if (this.buf.length == this.size)
/*    */       {
/* 58 */         short[] nb = new short[this.buf.length * 2];
/* 59 */         System.arraycopy(this.buf, 0, nb, 0, this.buf.length);
/* 60 */         this.buf = nb;
/*    */       }
/* 62 */       this.buf[(this.size++)] = b.shortValue();
/*    */     }
/*    */     
/*    */     short[] build() {
/* 66 */       if (this.buf.length == this.size)
/*    */       {
/* 68 */         return this.buf;
/*    */       }
/* 70 */       short[] r = new short[this.size];
/* 71 */       System.arraycopy(this.buf, 0, r, 0, this.size);
/* 72 */       return r;
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\reflect\PrimitiveArrayListerShort.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */