package net.rubyeye.xmemcached.networking;

import com.google.code.yanf4j.core.Controller;
import com.google.code.yanf4j.core.Session;
import com.google.code.yanf4j.core.SocketOption;
import java.io.IOException;
import java.net.InetSocketAddress;
import java.util.List;
import java.util.Map;
import java.util.Queue;
import java.util.Set;
import java.util.concurrent.Future;
import net.rubyeye.xmemcached.FlowControl;
import net.rubyeye.xmemcached.MemcachedSessionLocator;
import net.rubyeye.xmemcached.buffer.BufferAllocator;
import net.rubyeye.xmemcached.command.Command;
import net.rubyeye.xmemcached.exception.MemcachedException;
import net.rubyeye.xmemcached.impl.ReconnectRequest;
import net.rubyeye.xmemcached.utils.InetSocketAddressWrapper;

public abstract interface Connector
  extends Controller
{
  public abstract void setOptimizeMergeBuffer(boolean paramBoolean);
  
  public abstract void setMergeFactor(int paramInt);
  
  public abstract void setOptimizeGet(boolean paramBoolean);
  
  public abstract void removeSession(Session paramSession);
  
  public abstract Queue<Session> getSessionByAddress(InetSocketAddress paramInetSocketAddress);
  
  public abstract List<Session> getStandbySessionListByMainNodeAddr(InetSocketAddress paramInetSocketAddress);
  
  public abstract Set<Session> getSessionSet();
  
  public abstract void setHealSessionInterval(long paramLong);
  
  public abstract long getHealSessionInterval();
  
  public abstract void send(Command paramCommand)
    throws MemcachedException;
  
  public abstract void setConnectionPoolSize(int paramInt);
  
  public abstract void setBufferAllocator(BufferAllocator paramBufferAllocator);
  
  public abstract void removeReconnectRequest(InetSocketAddress paramInetSocketAddress);
  
  public abstract void addToWatingQueue(ReconnectRequest paramReconnectRequest);
  
  public abstract void setSocketOptions(Map<SocketOption, Object> paramMap);
  
  public abstract Future<Boolean> connect(InetSocketAddressWrapper paramInetSocketAddressWrapper)
    throws IOException;
  
  public abstract void updateSessions();
  
  public abstract void setSessionLocator(MemcachedSessionLocator paramMemcachedSessionLocator);
  
  public abstract void quitAllSessions();
  
  public abstract Queue<ReconnectRequest> getReconnectRequestQueue();
  
  public abstract void setFailureMode(boolean paramBoolean);
  
  public abstract FlowControl getNoReplyOpsFlowControl();
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\networking\Connector.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */