/*    */ package net.rubyeye.xmemcached.transcoders;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public final class TranscoderUtils
/*    */ {
/*    */   private boolean packZeros;
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public TranscoderUtils(boolean pack)
/*    */   {
/* 20 */     this.packZeros = pack;
/*    */   }
/*    */   
/*    */   public final boolean isPackZeros() {
/* 24 */     return this.packZeros;
/*    */   }
/*    */   
/*    */   public final void setPackZeros(boolean packZeros) {
/* 28 */     this.packZeros = packZeros;
/*    */   }
/*    */   
/*    */   public final byte[] encodeNum(long l, int maxBytes) {
/* 32 */     byte[] rv = new byte[maxBytes];
/* 33 */     for (int i = 0; i < rv.length; i++) {
/* 34 */       int pos = rv.length - i - 1;
/* 35 */       rv[pos] = ((byte)(int)(l >> 8 * i & 0xFF));
/*    */     }
/* 37 */     if (this.packZeros) {
/* 38 */       int firstNon0 = 0;
/* 39 */       while ((firstNon0 < rv.length) && (rv[firstNon0] == 0)) { firstNon0++;
/*    */       }
/*    */       
/* 42 */       if (firstNon0 > 0) {
/* 43 */         byte[] tmp = new byte[rv.length - firstNon0];
/* 44 */         System.arraycopy(rv, firstNon0, tmp, 0, rv.length - firstNon0);
/* 45 */         rv = tmp;
/*    */       }
/*    */     }
/* 48 */     return rv;
/*    */   }
/*    */   
/*    */   public final byte[] encodeLong(long l) {
/* 52 */     return encodeNum(l, 8);
/*    */   }
/*    */   
/*    */   public final long decodeLong(byte[] b) {
/* 56 */     assert (b.length <= 8) : ("Too long to be an long (" + b.length + ") bytes");
/*    */     
/* 58 */     long rv = 0L;
/* 59 */     for (byte i : b) {
/* 60 */       rv = rv << 8 | (i < 0 ? 256 + i : i);
/*    */     }
/* 62 */     return rv;
/*    */   }
/*    */   
/*    */   public final byte[] encodeInt(int in) {
/* 66 */     return encodeNum(in, 4);
/*    */   }
/*    */   
/*    */   public final int decodeInt(byte[] in) {
/* 70 */     assert (in.length <= 4) : ("Too long to be an int (" + in.length + ") bytes");
/*    */     
/* 72 */     return (int)decodeLong(in);
/*    */   }
/*    */   
/*    */   public final byte[] encodeByte(byte in) {
/* 76 */     return new byte[] { in };
/*    */   }
/*    */   
/*    */   public final byte decodeByte(byte[] in) {
/* 80 */     assert (in.length <= 1) : "Too long for a byte";
/* 81 */     byte rv = 0;
/* 82 */     if (in.length == 1) {
/* 83 */       rv = in[0];
/*    */     }
/* 85 */     return rv;
/*    */   }
/*    */   
/*    */   public final byte[] encodeBoolean(boolean b) {
/* 89 */     byte[] rv = new byte[1];
/* 90 */     rv[0] = ((byte)(b ? 49 : 48));
/* 91 */     return rv;
/*    */   }
/*    */   
/*    */   public final boolean decodeBoolean(byte[] in) {
/* 95 */     assert (in.length == 1) : "Wrong length for a boolean";
/* 96 */     return in[0] == 49;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\transcoders\TranscoderUtils.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */