/*     */ package net.rubyeye.xmemcached.utils.hibernate;
/*     */ 
/*     */ import com.googlecode.hibernate.memcached.LoggingMemcacheExceptionHandler;
/*     */ import com.googlecode.hibernate.memcached.Memcache;
/*     */ import com.googlecode.hibernate.memcached.MemcacheExceptionHandler;
/*     */ import com.googlecode.hibernate.memcached.utils.StringUtils;
/*     */ import java.util.Arrays;
/*     */ import java.util.Map;
/*     */ import net.rubyeye.xmemcached.MemcachedClient;
/*     */ import org.slf4j.Logger;
/*     */ import org.slf4j.LoggerFactory;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class Xmemcache
/*     */   implements Memcache
/*     */ {
/*  42 */   private static final Logger log = LoggerFactory.getLogger(Xmemcache.class);
/*  43 */   private MemcacheExceptionHandler exceptionHandler = new LoggingMemcacheExceptionHandler();
/*     */   private final MemcachedClient memcachedClient;
/*     */   
/*     */   public Xmemcache(MemcachedClient memcachedClient)
/*     */   {
/*  48 */     this.memcachedClient = memcachedClient;
/*     */   }
/*     */   
/*     */   public Object get(String key) {
/*     */     try {
/*  53 */       log.debug("MemcachedClient.get({})", key);
/*  54 */       return this.memcachedClient.get(key);
/*     */     } catch (Exception e) {
/*  56 */       this.exceptionHandler.handleErrorOnGet(key, e);
/*     */     }
/*  58 */     return null;
/*     */   }
/*     */   
/*     */   public Map<String, Object> getMulti(String... keys) {
/*     */     try {
/*  63 */       return this.memcachedClient.get(Arrays.asList(keys));
/*     */     } catch (Exception e) {
/*  65 */       this.exceptionHandler.handleErrorOnGet(StringUtils.join(keys, ", "), e);
/*     */     }
/*     */     
/*  68 */     return null;
/*     */   }
/*     */   
/*     */   public void set(String key, int cacheTimeSeconds, Object o) {
/*  72 */     log.debug("MemcachedClient.set({})", key);
/*     */     try {
/*  74 */       this.memcachedClient.set(key, cacheTimeSeconds, o);
/*     */     } catch (Exception e) {
/*  76 */       this.exceptionHandler.handleErrorOnSet(key, cacheTimeSeconds, o, e);
/*     */     }
/*     */   }
/*     */   
/*     */   public void delete(String key) {
/*     */     try {
/*  82 */       this.memcachedClient.delete(key);
/*     */     } catch (Exception e) {
/*  84 */       this.exceptionHandler.handleErrorOnDelete(key, e);
/*     */     }
/*     */   }
/*     */   
/*     */   public void incr(String key, int factor, int startingValue) {
/*     */     try {
/*  90 */       this.memcachedClient.incr(key, factor, startingValue);
/*     */     } catch (Exception e) {
/*  92 */       this.exceptionHandler.handleErrorOnIncr(key, factor, startingValue, e);
/*     */     }
/*     */   }
/*     */   
/*     */   public void shutdown()
/*     */   {
/*  98 */     log.debug("Shutting down XMemcachedClient");
/*     */     try {
/* 100 */       this.memcachedClient.shutdown();
/*     */     } catch (Exception e) {
/* 102 */       log.error("Shut down XMemcachedClient error", e);
/*     */     }
/*     */   }
/*     */   
/*     */   public void setExceptionHandler(MemcacheExceptionHandler exceptionHandler)
/*     */   {
/* 108 */     this.exceptionHandler = exceptionHandler;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\utils\hibernate\Xmemcache.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */