/*    */ package org.apache.avro.file;
/*    */ 
/*    */ import java.io.IOException;
/*    */ import java.nio.ByteBuffer;
/*    */ import java.util.zip.CRC32;
/*    */ import org.xerial.snappy.Snappy;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ class SnappyCodec
/*    */   extends Codec
/*    */ {
/* 28 */   private CRC32 crc32 = new CRC32();
/*    */   
/*    */   static class Option extends CodecFactory
/*    */   {
/*    */     protected Codec createInstance() {
/* 33 */       return new SnappyCodec(null);
/*    */     }
/*    */   }
/*    */   
/*    */   String getName()
/*    */   {
/* 39 */     return "snappy";
/*    */   }
/*    */   
/*    */   ByteBuffer compress(ByteBuffer in) throws IOException {
/* 43 */     ByteBuffer out = ByteBuffer.allocate(Snappy.maxCompressedLength(in.remaining()) + 4);
/*    */     
/* 45 */     int size = Snappy.compress(in.array(), in.position(), in.remaining(), out.array(), 0);
/*    */     
/* 47 */     this.crc32.reset();
/* 48 */     this.crc32.update(in.array(), in.position(), in.remaining());
/* 49 */     out.putInt(size, (int)this.crc32.getValue());
/*    */     
/* 51 */     out.limit(size + 4);
/*    */     
/* 53 */     return out;
/*    */   }
/*    */   
/*    */   ByteBuffer decompress(ByteBuffer in) throws IOException
/*    */   {
/* 58 */     ByteBuffer out = ByteBuffer.allocate(Snappy.uncompressedLength(in.array(), in.position(), in.remaining() - 4));
/*    */     
/* 60 */     int size = Snappy.uncompress(in.array(), in.position(), in.remaining() - 4, out.array(), 0);
/*    */     
/* 62 */     out.limit(size);
/*    */     
/* 64 */     this.crc32.reset();
/* 65 */     this.crc32.update(out.array(), 0, size);
/* 66 */     if (in.getInt(in.limit() - 4) != (int)this.crc32.getValue()) {
/* 67 */       throw new IOException("Checksum failure");
/*    */     }
/* 69 */     return out;
/*    */   }
/*    */   
/* 72 */   public int hashCode() { return getName().hashCode(); }
/*    */   
/*    */   public boolean equals(Object obj)
/*    */   {
/* 76 */     if (this == obj)
/* 77 */       return true;
/* 78 */     if (getClass() != obj.getClass())
/* 79 */       return false;
/* 80 */     return true;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\apache\avro\file\SnappyCodec.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */