/*    */ package org.apache.avro.io.parsing;
/*    */ 
/*    */ import java.io.IOException;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class SkipParser
/*    */   extends Parser
/*    */ {
/*    */   private final SkipHandler skipHandler;
/*    */   
/*    */   public SkipParser(Symbol root, Parser.ActionHandler symbolHandler, SkipHandler skipHandler)
/*    */     throws IOException
/*    */   {
/* 48 */     super(root, symbolHandler);
/* 49 */     this.skipHandler = skipHandler;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public final void skipTo(int target)
/*    */     throws IOException
/*    */   {
/* 59 */     while (target < this.pos) {
/* 60 */       Symbol top = this.stack[(this.pos - 1)];
/* 61 */       if (top.kind != Symbol.Kind.TERMINAL) {
/* 62 */         if ((top.kind == Symbol.Kind.IMPLICIT_ACTION) || (top.kind == Symbol.Kind.EXPLICIT_ACTION))
/*    */         {
/* 64 */           this.skipHandler.skipAction();
/*    */         } else {
/* 66 */           this.pos -= 1;
/* 67 */           pushProduction(top);
/*    */         }
/*    */       }
/*    */       else {
/* 71 */         this.skipHandler.skipTopSymbol();
/*    */       }
/*    */     }
/*    */   }
/*    */   
/*    */   public final void skipRepeater()
/*    */     throws IOException
/*    */   {
/* 79 */     int target = this.pos;
/* 80 */     Symbol repeater = this.stack[(--this.pos)];
/* 81 */     assert (repeater.kind == Symbol.Kind.REPEATER);
/* 82 */     pushProduction(repeater);
/* 83 */     skipTo(target);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public final void skipSymbol(Symbol symToSkip)
/*    */     throws IOException
/*    */   {
/* 91 */     int target = this.pos;
/* 92 */     pushSymbol(symToSkip);
/* 93 */     skipTo(target);
/*    */   }
/*    */   
/*    */   public static abstract interface SkipHandler
/*    */   {
/*    */     public abstract void skipAction()
/*    */       throws IOException;
/*    */     
/*    */     public abstract void skipTopSymbol()
/*    */       throws IOException;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\apache\avro\io\parsing\SkipParser.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */