package org.codehaus.jackson.map;

import org.codehaus.jackson.Version;
import org.codehaus.jackson.Versioned;
import org.codehaus.jackson.map.deser.BeanDeserializerModifier;
import org.codehaus.jackson.map.ser.BeanSerializerModifier;
import org.codehaus.jackson.map.type.TypeModifier;

public abstract class Module
  implements Versioned
{
  public abstract String getModuleName();
  
  public abstract Version version();
  
  public abstract void setupModule(SetupContext paramSetupContext);
  
  public static abstract interface SetupContext
  {
    public abstract Version getMapperVersion();
    
    public abstract DeserializationConfig getDeserializationConfig();
    
    public abstract SerializationConfig getSerializationConfig();
    
    public abstract void addDeserializers(Deserializers paramDeserializers);
    
    public abstract void addKeyDeserializers(KeyDeserializers paramKeyDeserializers);
    
    public abstract void addSerializers(Serializers paramSerializers);
    
    public abstract void addKeySerializers(Serializers paramSerializers);
    
    public abstract void addBeanDeserializerModifier(BeanDeserializerModifier paramBeanDeserializerModifier);
    
    public abstract void addBeanSerializerModifier(BeanSerializerModifier paramBeanSerializerModifier);
    
    public abstract void addAbstractTypeResolver(AbstractTypeResolver paramAbstractTypeResolver);
    
    public abstract void addTypeModifier(TypeModifier paramTypeModifier);
    
    public abstract void insertAnnotationIntrospector(AnnotationIntrospector paramAnnotationIntrospector);
    
    public abstract void appendAnnotationIntrospector(AnnotationIntrospector paramAnnotationIntrospector);
    
    public abstract void setMixInAnnotations(Class<?> paramClass1, Class<?> paramClass2);
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\Module.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */