/*    */ package org.codehaus.jackson.map.deser;
/*    */ 
/*    */ import java.io.IOException;
/*    */ import java.util.EnumMap;
/*    */ import org.codehaus.jackson.JsonParser;
/*    */ import org.codehaus.jackson.JsonProcessingException;
/*    */ import org.codehaus.jackson.JsonToken;
/*    */ import org.codehaus.jackson.map.DeserializationContext;
/*    */ import org.codehaus.jackson.map.JsonDeserializer;
/*    */ import org.codehaus.jackson.map.TypeDeserializer;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public final class EnumMapDeserializer
/*    */   extends StdDeserializer<EnumMap<?, ?>>
/*    */ {
/*    */   protected final Class<?> _enumClass;
/*    */   protected final JsonDeserializer<Enum<?>> _keyDeserializer;
/*    */   protected final JsonDeserializer<Object> _valueDeserializer;
/*    */   
/*    */   @Deprecated
/*    */   public EnumMapDeserializer(EnumResolver<?> enumRes, JsonDeserializer<Object> valueDeser)
/*    */   {
/* 33 */     this(enumRes.getEnumClass(), new EnumDeserializer(enumRes), valueDeser);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public EnumMapDeserializer(Class<?> enumClass, JsonDeserializer<?> keyDeserializer, JsonDeserializer<Object> valueDeser)
/*    */   {
/* 40 */     super(EnumMap.class);
/* 41 */     this._enumClass = enumClass;
/* 42 */     this._keyDeserializer = keyDeserializer;
/* 43 */     this._valueDeserializer = valueDeser;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */   public EnumMap<?, ?> deserialize(JsonParser jp, DeserializationContext ctxt)
/*    */     throws IOException, JsonProcessingException
/*    */   {
/* 52 */     if (jp.getCurrentToken() != JsonToken.START_OBJECT) {
/* 53 */       throw ctxt.mappingException(EnumMap.class);
/*    */     }
/* 55 */     EnumMap result = constructMap();
/*    */     
/* 57 */     while (jp.nextToken() != JsonToken.END_OBJECT) {
/* 58 */       String fieldName = jp.getCurrentName();
/* 59 */       Enum<?> key = (Enum)this._keyDeserializer.deserialize(jp, ctxt);
/* 60 */       if (key == null) {
/* 61 */         throw ctxt.weirdStringException(this._enumClass, "value not one of declared Enum instance names");
/*    */       }
/*    */       
/* 64 */       JsonToken t = jp.nextToken();
/*    */       
/*    */ 
/*    */ 
/* 68 */       Object value = t == JsonToken.VALUE_NULL ? null : this._valueDeserializer.deserialize(jp, ctxt);
/*    */       
/* 70 */       result.put(key, value);
/*    */     }
/* 72 */     return result;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */   public Object deserializeWithType(JsonParser jp, DeserializationContext ctxt, TypeDeserializer typeDeserializer)
/*    */     throws IOException, JsonProcessingException
/*    */   {
/* 81 */     return typeDeserializer.deserializeTypedFromObject(jp, ctxt);
/*    */   }
/*    */   
/*    */ 
/*    */   private EnumMap<?, ?> constructMap()
/*    */   {
/* 87 */     return new EnumMap(this._enumClass);
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\deser\EnumMapDeserializer.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */