/*    */ package org.codehaus.jackson.map.type;
/*    */ 
/*    */ import org.codehaus.jackson.type.JavaType;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public final class MapType
/*    */   extends MapLikeType
/*    */ {
/*    */   private MapType(Class<?> mapType, JavaType keyT, JavaType valueT)
/*    */   {
/* 17 */     super(mapType, keyT, valueT);
/*    */   }
/*    */   
/*    */   public static MapType construct(Class<?> rawType, JavaType keyT, JavaType valueT)
/*    */   {
/* 22 */     return new MapType(rawType, keyT, valueT);
/*    */   }
/*    */   
/*    */   protected JavaType _narrow(Class<?> subclass)
/*    */   {
/* 27 */     return new MapType(subclass, this._keyType, this._valueType);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public JavaType narrowContentsBy(Class<?> contentClass)
/*    */   {
/* 34 */     if (contentClass == this._valueType.getRawClass()) {
/* 35 */       return this;
/*    */     }
/* 37 */     return new MapType(this._class, this._keyType, this._valueType.narrowBy(contentClass)).copyHandlers(this);
/*    */   }
/*    */   
/*    */ 
/*    */   public JavaType widenContentsBy(Class<?> contentClass)
/*    */   {
/* 43 */     if (contentClass == this._valueType.getRawClass()) {
/* 44 */       return this;
/*    */     }
/* 46 */     return new MapType(this._class, this._keyType, this._valueType.widenBy(contentClass)).copyHandlers(this);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public JavaType narrowKey(Class<?> keySubclass)
/*    */   {
/* 53 */     if (keySubclass == this._keyType.getRawClass()) {
/* 54 */       return this;
/*    */     }
/* 56 */     return new MapType(this._class, this._keyType.narrowBy(keySubclass), this._valueType).copyHandlers(this);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public JavaType widenKey(Class<?> keySubclass)
/*    */   {
/* 66 */     if (keySubclass == this._keyType.getRawClass()) {
/* 67 */       return this;
/*    */     }
/* 69 */     return new MapType(this._class, this._keyType.widenBy(keySubclass), this._valueType).copyHandlers(this);
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public MapType withTypeHandler(Object h)
/*    */   {
/* 76 */     MapType newInstance = new MapType(this._class, this._keyType, this._valueType);
/* 77 */     newInstance._typeHandler = h;
/* 78 */     return newInstance;
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */   public MapType withContentTypeHandler(Object h)
/*    */   {
/* 85 */     return new MapType(this._class, this._keyType, this._valueType.withTypeHandler(h));
/*    */   }
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   public String toString()
/*    */   {
/* 98 */     return "[map type; class " + this._class.getName() + ", " + this._keyType + " -> " + this._valueType + "]";
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\jackson\map\type\MapType.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */