/*    */ package org.codehaus.janino.samples;
/*    */ 
/*    */ import java.io.FileReader;
/*    */ import java.io.IOException;
/*    */ import java.io.InputStreamReader;
/*    */ import java.io.PrintStream;
/*    */ import org.codehaus.commons.compiler.CompileException;
/*    */ import org.codehaus.janino.Java.ClassDeclaration;
/*    */ import org.codehaus.janino.Java.CompilationUnit;
/*    */ import org.codehaus.janino.Java.FieldDeclaration;
/*    */ import org.codehaus.janino.Java.InterfaceDeclaration;
/*    */ import org.codehaus.janino.Java.LocalVariableDeclarationStatement;
/*    */ import org.codehaus.janino.Parser;
/*    */ import org.codehaus.janino.Scanner;
/*    */ import org.codehaus.janino.util.Traverser;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class DeclarationCounter
/*    */   extends Traverser
/*    */ {
/*    */   public static void main(String[] args)
/*    */     throws CompileException, IOException
/*    */   {
/* 42 */     DeclarationCounter dc = new DeclarationCounter();
/* 43 */     for (int i = 0; i < args.length; i++) {
/* 44 */       String fileName = args[i];
/*    */       
/*    */ 
/* 47 */       FileReader r = new FileReader(fileName);
/*    */       Java.CompilationUnit cu;
/*    */       try {
/* 50 */         cu = new Parser(new Scanner(fileName, r)).parseCompilationUnit();
/*    */       } finally {
/* 52 */         r.close();
/*    */       }
/*    */       
/*    */ 
/* 56 */       dc.traverseCompilationUnit(cu);
/*    */     }
/*    */     
/* 59 */     System.out.println("Class declarations:     " + dc.classDeclarationCount);
/* 60 */     System.out.println("Interface declarations: " + dc.interfaceDeclarationCount);
/* 61 */     System.out.println("Fields:                 " + dc.fieldCount);
/* 62 */     System.out.println("Local variables:        " + dc.localVariableCount);
/*    */   }
/*    */   
/*    */   public void traverseClassDeclaration(Java.ClassDeclaration cd)
/*    */   {
/* 67 */     this.classDeclarationCount += 1;
/* 68 */     super.traverseClassDeclaration(cd); }
/*    */   
/* 70 */   private int classDeclarationCount = 0;
/*    */   
/*    */   public void traverseInterfaceDeclaration(Java.InterfaceDeclaration id)
/*    */   {
/* 74 */     this.interfaceDeclarationCount += 1;
/* 75 */     super.traverseInterfaceDeclaration(id); }
/*    */   
/* 77 */   private int interfaceDeclarationCount = 0;
/*    */   
/*    */   public void traverseFieldDeclaration(Java.FieldDeclaration fd)
/*    */   {
/* 81 */     this.fieldCount += fd.variableDeclarators.length;
/* 82 */     super.traverseFieldDeclaration(fd); }
/*    */   
/* 84 */   private int fieldCount = 0;
/*    */   
/*    */   public void traverseLocalVariableDeclarationStatement(Java.LocalVariableDeclarationStatement lvds)
/*    */   {
/* 88 */     this.localVariableCount += lvds.variableDeclarators.length;
/* 89 */     super.traverseLocalVariableDeclarationStatement(lvds); }
/*    */   
/* 91 */   private int localVariableCount = 0;
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\samples\DeclarationCounter.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */