/*    */ package org.codehaus.janino.util.resource;
/*    */ 
/*    */ import java.io.File;
/*    */ import java.util.Arrays;
/*    */ import java.util.Collections;
/*    */ import java.util.HashMap;
/*    */ import java.util.HashSet;
/*    */ import java.util.Map;
/*    */ import java.util.Set;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class DirectoryResourceFinder
/*    */   extends FileResourceFinder
/*    */ {
/*    */   private final File directory;
/* 40 */   private final Map subdirectoryNameToFiles = new HashMap();
/*    */   
/*    */ 
/*    */ 
/*    */   public DirectoryResourceFinder(File directory)
/*    */   {
/* 46 */     this.directory = directory;
/*    */   }
/*    */   
/* 49 */   public final String toString() { return "dir:" + this.directory; }
/*    */   
/*    */ 
/*    */ 
/*    */   protected final File findResourceAsFile(String resourceName)
/*    */   {
/* 55 */     int idx = resourceName.lastIndexOf('/');
/* 56 */     String subdirectoryName = idx == -1 ? null : resourceName.substring(0, idx).replace('/', File.separatorChar);
/*    */     
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/* 62 */     Set files = (Set)this.subdirectoryNameToFiles.get(subdirectoryName);
/* 63 */     if (files == null) {
/* 64 */       File subDirectory = subdirectoryName == null ? this.directory : new File(this.directory, subdirectoryName);
/*    */       
/*    */ 
/*    */ 
/*    */ 
/* 69 */       File[] fa = subDirectory.listFiles();
/* 70 */       files = fa == null ? Collections.EMPTY_SET : new HashSet(Arrays.asList(fa));
/* 71 */       this.subdirectoryNameToFiles.put(subdirectoryName, files);
/*    */     }
/*    */     
/*    */ 
/*    */ 
/* 76 */     File file = new File(this.directory, resourceName.replace('/', File.separatorChar));
/* 77 */     if (!files.contains(file)) { return null;
/*    */     }
/* 79 */     return file;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\util\resource\DirectoryResourceFinder.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */