/*     */ package org.codehaus.janino.util.resource;
/*     */ 
/*     */ import java.io.File;
/*     */ import java.io.IOException;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Arrays;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.zip.ZipFile;
/*     */ import org.codehaus.janino.util.iterator.TransformingIterator;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class PathResourceFinder
/*     */   extends LazyMultiResourceFinder
/*     */ {
/*     */   public PathResourceFinder(File[] entries)
/*     */   {
/*  48 */     super(createIterator(Arrays.asList(entries).iterator()));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public PathResourceFinder(Iterator entries)
/*     */   {
/*  55 */     super(entries);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public PathResourceFinder(String path)
/*     */   {
/*  62 */     this(parsePath(path));
/*     */   }
/*     */   
/*     */   private static Iterator createIterator(Iterator entries) {
/*  66 */     new TransformingIterator(entries) {
/*     */       protected Object transform(Object o) {
/*  68 */         return PathResourceFinder.createResourceFinder((File)o);
/*     */       }
/*     */     };
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public static File[] parsePath(String s)
/*     */   {
/*  89 */     int from = 0;
/*  90 */     List l = new ArrayList();
/*     */     for (;;) {
/*  92 */       int to = s.indexOf(File.pathSeparatorChar, from);
/*  93 */       if (to == -1) {
/*  94 */         if (from == s.length()) break; l.add(new File(s.substring(from))); break;
/*     */       }
/*     */       
/*  97 */       if (to != from) l.add(new File(s.substring(from, to)));
/*  98 */       from = to + 1;
/*     */     }
/* 100 */     return (File[])l.toArray(new File[l.size()]);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private static ResourceFinder createResourceFinder(File entry)
/*     */   {
/* 118 */     if (((entry.getName().endsWith(".jar")) || (entry.getName().endsWith(".zip"))) && (entry.isFile()))
/*     */     {
/*     */       try
/*     */       {
/*     */ 
/* 123 */         return new ZipFileResourceFinder(new ZipFile(entry));
/*     */       } catch (IOException e) {
/* 125 */         return ResourceFinder.EMPTY_RESOURCE_FINDER;
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 130 */     if (entry.isDirectory()) {
/* 131 */       return new DirectoryResourceFinder(entry);
/*     */     }
/*     */     
/*     */ 
/* 135 */     return ResourceFinder.EMPTY_RESOURCE_FINDER;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\util\resource\PathResourceFinder.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */