/*     */ package org.xerial.snappy;
/*     */ 
/*     */ import java.io.ByteArrayOutputStream;
/*     */ import java.io.DataInputStream;
/*     */ import java.io.DataOutputStream;
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.io.OutputStream;
/*     */ import java.util.Arrays;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SnappyCodec
/*     */ {
/*  52 */   public static final byte[] MAGIC_HEADER = { -126, 83, 78, 65, 80, 80, 89, 0 };
/*     */   
/*     */   public static final int MAGIC_LEN = 8;
/*     */   public static final int DEFAULT_VERSION = 1;
/*     */   public static final int MINIMUM_COMPATIBLE_VERSION = 1;
/*     */   public final byte[] magic;
/*     */   public final int version;
/*     */   public final int compatibleVersion;
/*     */   
/*     */   private SnappyCodec(byte[] magic, int version, int compatibleVersion)
/*     */   {
/*  63 */     this.magic = magic;
/*  64 */     this.version = version;
/*  65 */     this.compatibleVersion = compatibleVersion;
/*     */   }
/*     */   
/*     */   public String toString()
/*     */   {
/*  70 */     return String.format("version:%d, compatible version:%d", new Object[] { Integer.valueOf(this.version), Integer.valueOf(this.compatibleVersion) });
/*     */   }
/*     */   
/*     */   public static int headerSize() {
/*  74 */     return 16;
/*     */   }
/*     */   
/*     */   public void writeHeader(OutputStream out) throws IOException {
/*  78 */     ByteArrayOutputStream header = new ByteArrayOutputStream();
/*  79 */     DataOutputStream d = new DataOutputStream(header);
/*  80 */     d.write(this.magic, 0, 8);
/*  81 */     d.writeInt(this.version);
/*  82 */     d.writeInt(this.compatibleVersion);
/*  83 */     d.close();
/*  84 */     out.write(header.toByteArray(), 0, header.size());
/*     */   }
/*     */   
/*     */   public boolean isValidMagicHeader() {
/*  88 */     return Arrays.equals(MAGIC_HEADER, this.magic);
/*     */   }
/*     */   
/*     */   public static SnappyCodec readHeader(InputStream in) throws IOException {
/*  92 */     DataInputStream d = new DataInputStream(in);
/*  93 */     byte[] magic = new byte[8];
/*  94 */     d.read(magic, 0, 8);
/*  95 */     int version = d.readInt();
/*  96 */     int compatibleVersion = d.readInt();
/*  97 */     return new SnappyCodec(magic, version, compatibleVersion);
/*     */   }
/*     */   
/*     */   public static SnappyCodec currentHeader() {
/* 101 */     return new SnappyCodec(MAGIC_HEADER, 1, 1);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\xerial\snappy\SnappyCodec.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */