package prefuse.action.animate;

import java.awt.geom.Point2D;
import java.awt.geom.Point2D.Double;
import prefuse.Display;
import prefuse.Visualization;
import prefuse.action.ItemAction;
import prefuse.visual.VisualItem;

public class PolarLocationAnimator
  extends ItemAction
{
  private Point2D m_anchor = new Point2D.Double();
  private String m_linear = null;
  private double ax;
  private double ay;
  private double sx;
  private double sy;
  private double ex;
  private double ey;
  private double x;
  private double y;
  private double dt1;
  private double dt2;
  private double sr;
  private double st;
  private double er;
  private double et;
  private double r;
  private double t;
  private double stt;
  private double ett;
  
  public PolarLocationAnimator() {}
  
  public PolarLocationAnimator(String paramString)
  {
    super(paramString);
  }
  
  public PolarLocationAnimator(String paramString1, String paramString2)
  {
    super(paramString1);
    this.m_linear = paramString2;
  }
  
  private void setAnchor()
  {
    Display localDisplay = getVisualization().getDisplay(0);
    this.m_anchor.setLocation(localDisplay.getWidth() / 2, localDisplay.getHeight() / 2);
    localDisplay.getAbsoluteCoordinate(this.m_anchor, this.m_anchor);
    this.ax = this.m_anchor.getX();
    this.ay = this.m_anchor.getY();
  }
  
  public void run(double paramDouble)
  {
    setAnchor();
    super.run(paramDouble);
  }
  
  public void process(VisualItem paramVisualItem, double paramDouble)
  {
    if ((this.m_linear != null) && (paramVisualItem.isInGroup(this.m_linear)))
    {
      double d = paramVisualItem.getStartX();
      paramVisualItem.setX(d + paramDouble * (paramVisualItem.getEndX() - d));
      d = paramVisualItem.getStartY();
      paramVisualItem.setY(d + paramDouble * (paramVisualItem.getEndY() - d));
      return;
    }
    this.sx = (paramVisualItem.getStartX() - this.ax);
    this.sy = (paramVisualItem.getStartY() - this.ay);
    this.ex = (paramVisualItem.getEndX() - this.ax);
    this.ey = (paramVisualItem.getEndY() - this.ay);
    this.sr = Math.sqrt(this.sx * this.sx + this.sy * this.sy);
    this.st = Math.atan2(this.sy, this.sx);
    this.er = Math.sqrt(this.ex * this.ex + this.ey * this.ey);
    this.et = Math.atan2(this.ey, this.ex);
    this.stt = (this.st < 0.0D ? this.st + 6.283185307179586D : this.st);
    this.ett = (this.et < 0.0D ? this.et + 6.283185307179586D : this.et);
    this.dt1 = (this.et - this.st);
    this.dt2 = (this.ett - this.stt);
    if (Math.abs(this.dt1) < Math.abs(this.dt2)) {
      this.t = (this.st + paramDouble * this.dt1);
    } else {
      this.t = (this.stt + paramDouble * this.dt2);
    }
    this.r = (this.sr + paramDouble * (this.er - this.sr));
    this.x = Math.round(this.ax + this.r * Math.cos(this.t));
    this.y = Math.round(this.ay + this.r * Math.sin(this.t));
    paramVisualItem.setX(this.x);
    paramVisualItem.setY(this.y);
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\animate\PolarLocationAnimator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */