package prefuse.action.filter;

import java.util.Iterator;
import prefuse.Visualization;
import prefuse.action.GroupAction;
import prefuse.data.Graph;
import prefuse.data.expression.Predicate;
import prefuse.data.tuple.TupleSet;
import prefuse.data.util.BreadthFirstIterator;
import prefuse.data.util.FilterIterator;
import prefuse.util.PrefuseLib;
import prefuse.visual.VisualItem;
import prefuse.visual.expression.InGroupPredicate;

public class GraphDistanceFilter
  extends GroupAction
{
  protected int m_distance;
  protected String m_sources;
  protected Predicate m_groupP;
  protected BreadthFirstIterator m_bfs;
  
  public GraphDistanceFilter(String paramString)
  {
    this(paramString, 1);
  }
  
  public GraphDistanceFilter(String paramString, int paramInt)
  {
    this(paramString, Visualization.FOCUS_ITEMS, paramInt);
  }
  
  public GraphDistanceFilter(String paramString1, String paramString2, int paramInt)
  {
    super(paramString1);
    this.m_sources = paramString2;
    this.m_distance = paramInt;
    this.m_groupP = new InGroupPredicate(PrefuseLib.getGroupName(paramString1, Graph.NODES));
    this.m_bfs = new BreadthFirstIterator();
  }
  
  public int getDistance()
  {
    return this.m_distance;
  }
  
  public void setDistance(int paramInt)
  {
    this.m_distance = paramInt;
  }
  
  public void run(double paramDouble)
  {
    Iterator localIterator = this.m_vis.visibleItems(this.m_group);
    while (localIterator.hasNext())
    {
      localObject = (VisualItem)localIterator.next();
      ((VisualItem)localObject).setDOI(-1.7976931348623157E308D);
    }
    Object localObject = this.m_vis.getGroup(this.m_sources);
    FilterIterator localFilterIterator = new FilterIterator(((TupleSet)localObject).tuples(), this.m_groupP);
    this.m_bfs.init(localFilterIterator, this.m_distance, 2);
    VisualItem localVisualItem;
    while (this.m_bfs.hasNext())
    {
      localVisualItem = (VisualItem)this.m_bfs.next();
      int i = this.m_bfs.getDepth(localVisualItem);
      PrefuseLib.updateVisible(localVisualItem, true);
      localVisualItem.setDOI(-i);
      localVisualItem.setExpanded(i < this.m_distance);
    }
    localIterator = this.m_vis.visibleItems(this.m_group);
    while (localIterator.hasNext())
    {
      localVisualItem = (VisualItem)localIterator.next();
      if (localVisualItem.getDOI() == -1.7976931348623157E308D)
      {
        PrefuseLib.updateVisible(localVisualItem, false);
        localVisualItem.setExpanded(false);
      }
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\filter\GraphDistanceFilter.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */