package prefuse.action.layout;

import java.awt.Insets;
import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;
import java.awt.geom.Point2D.Double;
import java.awt.geom.Rectangle2D;
import java.awt.geom.Rectangle2D.Double;
import prefuse.Display;
import prefuse.Visualization;
import prefuse.action.GroupAction;
import prefuse.util.PrefuseLib;
import prefuse.visual.VisualItem;

public abstract class Layout
  extends GroupAction
{
  protected Rectangle2D m_bounds = null;
  protected Point2D m_anchor = null;
  protected boolean m_margin = false;
  protected Insets m_insets = new Insets(0, 0, 0, 0);
  protected double[] m_bpts = new double[4];
  protected Rectangle2D m_tmpb = new Rectangle2D.Double();
  protected Point2D m_tmpa = new Point2D.Double();
  
  public Layout() {}
  
  public Layout(String paramString)
  {
    super(paramString);
  }
  
  public Layout(String paramString, long paramLong)
  {
    super(paramString, paramLong);
  }
  
  public void setMargin(int paramInt1, int paramInt2, int paramInt3, int paramInt4)
  {
    this.m_insets.top = paramInt1;
    this.m_insets.left = paramInt2;
    this.m_insets.bottom = paramInt3;
    this.m_insets.right = paramInt4;
    this.m_margin = true;
  }
  
  public Rectangle2D getLayoutBounds()
  {
    if (this.m_bounds != null) {
      return this.m_bounds;
    }
    if ((this.m_vis != null) && (this.m_vis.getDisplayCount() > 0))
    {
      Display localDisplay = this.m_vis.getDisplay(0);
      Insets localInsets = this.m_margin ? this.m_insets : localDisplay.getInsets(this.m_insets);
      this.m_bpts[0] = localInsets.left;
      this.m_bpts[1] = localInsets.top;
      this.m_bpts[2] = (localDisplay.getWidth() - localInsets.right);
      this.m_bpts[3] = (localDisplay.getHeight() - localInsets.bottom);
      localDisplay.getInverseTransform().transform(this.m_bpts, 0, this.m_bpts, 0, 2);
      this.m_tmpb.setRect(this.m_bpts[0], this.m_bpts[1], this.m_bpts[2] - this.m_bpts[0], this.m_bpts[3] - this.m_bpts[1]);
      return this.m_tmpb;
    }
    return null;
  }
  
  public void setLayoutBounds(Rectangle2D paramRectangle2D)
  {
    this.m_bounds = paramRectangle2D;
  }
  
  public Point2D getLayoutAnchor()
  {
    if (this.m_anchor != null) {
      return this.m_anchor;
    }
    this.m_tmpa.setLocation(0.0D, 0.0D);
    if (this.m_vis != null)
    {
      Display localDisplay = this.m_vis.getDisplay(0);
      this.m_tmpa.setLocation(localDisplay.getWidth() / 2.0D, localDisplay.getHeight() / 2.0D);
      localDisplay.getInverseTransform().transform(this.m_tmpa, this.m_tmpa);
    }
    return this.m_tmpa;
  }
  
  public void setLayoutAnchor(Point2D paramPoint2D)
  {
    this.m_anchor = paramPoint2D;
  }
  
  public void setX(VisualItem paramVisualItem1, VisualItem paramVisualItem2, double paramDouble)
  {
    PrefuseLib.setX(paramVisualItem1, paramVisualItem2, paramDouble);
  }
  
  public void setY(VisualItem paramVisualItem1, VisualItem paramVisualItem2, double paramDouble)
  {
    PrefuseLib.setY(paramVisualItem1, paramVisualItem2, paramDouble);
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\layout\Layout.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */