package prefuse.data.util;

import java.util.NoSuchElementException;
import prefuse.data.Table;
import prefuse.data.expression.Predicate;
import prefuse.util.collections.IntIterator;

public class FilterRowIterator
  extends IntIterator
{
  private Predicate predicate;
  private IntIterator rows;
  private Table t;
  private int next;
  
  public FilterRowIterator(IntIterator paramIntIterator, Table paramTable, Predicate paramPredicate)
  {
    this.predicate = paramPredicate;
    this.rows = paramIntIterator;
    this.t = paramTable;
    this.next = advance();
  }
  
  private int advance()
  {
    while (this.rows.hasNext())
    {
      int i = this.rows.nextInt();
      if (this.predicate.getBoolean(this.t.getTuple(i))) {
        return i;
      }
    }
    this.rows = null;
    this.next = -1;
    return -1;
  }
  
  public int nextInt()
  {
    if (!hasNext()) {
      throw new NoSuchElementException("No more elements");
    }
    int i = this.next;
    this.next = advance();
    return i;
  }
  
  public boolean hasNext()
  {
    return this.rows != null;
  }
  
  public void remove()
  {
    throw new UnsupportedOperationException();
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\data\util\FilterRowIterator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */